<?php

if (!isset($bClient)){
	include "blocked_notice_wf.php";
	exit(0);
}

require_once "fs_lang.php";
require_once "common_functions.php";
require_once 'generate_common.php';

// 20080403 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$smarty->assign('L_BLOCKED_CHARSET', metaCharset());
$smarty->assign('L_BLOCKED_TITLE', get_var('blocked_title'));

// 20081219 - Determine using message from Client Blacklist or IP Block List
if ($bClient == 1)
    $smarty->assign('L_BLOCKED_MSG', get_var('block_client_blacklist'));
else if ($bClient == 3) {
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
	$bopTimeTable = $settingobj->getKey('blackout_period_time_table','gateway');
	$bopMessage="";
	
	if(!strlen($bopTimeTable)){
		$blackout_period_start_time = $settingobj->getKey('blackout_period_start_time', 'gateway');
		$blackout_period_end_time = $settingobj->getKey('blackout_period_end_time', 'gateway');
		$bopMessage = " (".$blackout_period_start_time."-".$blackout_period_end_time.")";
	}
	else{
		$wAry = array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');	
		$hAry = array('00:', '01:', '02:', '03:', '04:', '05:', '06:', '07:', '08:', '09:', '10:', '11:', '12:', '13:', '14:', '15:', '16:', '17:', '18:', '19:', '20:', '21:', '22:', '23:');
		$mAry = array(1,2,4,8);
		$mAry2 = array('00','15','30','45');
		$bopS = array(0,0,0);
		$bopE = array(0,0,0);
		$bopOn = false;
		$counter = 1;
		$bopMessage .="<br/><table>";
		for ($i=0; $i <7; $i++){
			for ($j=0; $j<24; $j++){
				for ($k=0; $k<4; $k++){
					if((hexdec(substr($bopTimeTable,($i*24+$j),1)) & $mAry[$k]) && !$bopOn){
						$bopOn = true;
						$bopS = array($i,$j,$k);
					}
					else if(!(hexdec(substr($bopTimeTable,($i*24+$j),1)) & $mAry[$k]) && $bopOn){
						$bopOn = false;
						if($bopS[0]==0 && $bopS[1]==0 && $bopS[2]==0){
							$bopE[0] = $i;
							$bopE[1] = $j;
							$bopE[2] = $k;
						}
						else{
							$bopMessage .= "<tr><td>".$counter.".</td><td>".$wAry[$bopS[0]]."</td><td>[".$hAry[$bopS[1]].$mAry2[$bopS[2]]."]</td><td> ~ </td><td>".$wAry[$i]."</td><td> [".$hAry[$j].$mAry2[$k]."]</td></tr>";
							$bopS = array(0,0,0);
							$counter++;
						}
					}
				}
			}
		}
		if(!($bopE[0]==0 && $bopE[1]==0 && $bopE[2]==0) || !($bopS[0]==0 && $bopS[1]==0 && $bopS[2]==0))
			$bopMessage .= "<tr><td>".$counter.".</td><td>".$wAry[$bopS[0]]."</td><td>[".$hAry[$bopS[1]].$mAry2[$bopS[2]]."]</td><td> ~ </td><td>".$wAry[$bopE[0]]."</td><td> [".$hAry[$bopE[1]].$mAry2[$bopE[2]]."]</td></tr>";
		$bopMessage .= "</table>";
	}
	$settingobj=null;

    $smarty->assign('L_BLOCKED_MSG', get_var('block_fs_in_blackout_period').$bopMessage);
}
else
    $smarty->assign('L_BLOCKED_MSG', get_var('block_ip_block_list'));

$smarty->assign('J_COMMON', $j_common);

// 20080403 - Move layout content and include the file here
$smarty->display('blocked_notice_body.tpl');

?>