<?
include("secureLogin.php");
include_once("..\\authserv\\common_functions.php");
include_once("..\\cfgmgr\\cmvar.php");
include_once("..\\usersetting\\custom_lang.php");

function get_custom_cm_var($element)
{
    global $lang;
    if (isset($lang[$element]))
        return $lang[$element];
    else
        return "";
}

// create COM object
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("UI_ExtraInformation.php FSCONFIG.Cfgmgr Object cannot be created!");
$isAnony = $settingobj->getKey( "anonymous_login", "gateway");
$scratchLogin = $settingobj->getKey('scratch_login', 'gateway');
$esmsMode = $settingobj->getKey('esms_mode', 'gateway');
$store_mobile_in_extra = $settingobj->getKey( "store_mobile_in_extra", "gateway");

$dsn_file = $settingobj->getKey( "Datasource", "gateway");
$dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");
$dsn="";

if (!feof($dsn_source)) 
    $line=fgets($dsn_source,512); 

while (!feof($dsn_source)){
    $line=fgets($dsn_source,512);
    if (trim($line)!="")
        $dsn=$dsn.$line;
}

$dsn=str_replace("\r\n",";",$dsn);
$userDB=odbc_connect($dsn,"","");

if($userDB){
    $firstspotusertable=$settingobj->getKey( "Datasource_Tablename", "gateway"); 
    $query1 = "SELECT * FROM $firstspotusertable";

    $result=odbc_exec($userDB,$query1); 
?>
<html>
<head>
<title>User Extra Information</title>
<style type="text/css">
<!--
table { font-family: Arial, sans-serif; font-size: 10pt; }
-->
</style>
<script type="text/javascript" src="javascript/json.js"></script>
</head>
<body>
<form name="User_ExtraInfo_Form" action="editUser.php?edit_extra_info_submit=1" method="POST">
<input type="hidden" name="username" value="<?=$_GET['selectedName']?>" />
<table width="100%" border="0" cellspacing="0" cellpadding="3">	
<?
    while(odbc_fetch_row($result)){ 
        $extraname=odbc_result($result,"name");
		if($extraname == $selectedName){
			$signup01=htmlspecialchars(odbc_result($result,"signup01"));
	        $signup02=htmlspecialchars(odbc_result($result,"signup02"));
	        $signup03=htmlspecialchars(odbc_result($result,"signup03"));
	        $signup04=htmlspecialchars(odbc_result($result,"signup04"));
	        $signup05=htmlspecialchars(odbc_result($result,"signup05"));
	        $signup06=htmlspecialchars(odbc_result($result,"signup06"));
	        $signup07=htmlspecialchars(odbc_result($result,"signup07"));
	        $signup08=htmlspecialchars(odbc_result($result,"signup08"));
	        $signup09=htmlspecialchars(odbc_result($result,"signup09"));
	        $signup10=htmlspecialchars(odbc_result($result,"signup10"));
		}
    }
	if (!isset($signup01))
		$signup01='';
	if (!isset($signup02))
		$signup02='';
	if (!isset($signup03))
		$signup03='';
	if (!isset($signup04))
		$signup04='';
	if (!isset($signup05))
		$signup05='';
	if (!isset($signup06))
		$signup06='';
	if (!isset($signup07))
		$signup07='';
	if (!isset($signup08))
		$signup08='';
	if (!isset($signup09))
		$signup09='';
	if (!isset($signup10))
		$signup10='';
?>	
<?php
	$totalField = 10;
	switch($_GET['action']) {
		case 'view':
			for ($i = 1; $i <= 10; $i++) {
				$varName = 'signup' . ($i == 10 ? '10' : '0' . $i);
				
				if ($i == 10 && (isset($esmsMode) && strcasecmp($esmsMode, 'on') == 0) && (isset($scratchLogin) && strcasecmp($scratchLogin, 'on') == 0) && $store_mobile_in_extra == 1){ // * start at 1
					$fieldName = get_cm_var('setcfg_users_extra_info_label_used_by_store_mobile');
				}
				else {
					$fieldName = get_custom_cm_var('ReqSignUp_extra' . $i);
				}
				
				if ($fieldName) {
?>
					<tr>
						<td valign="top"><b><?=$fieldName?></b></td>
						<td valign="top"><input type="text" name="<?=$varName?>" value="<?=$$varName?>" style="border: 1px solid #99D1A2; width: 250px;" /></td>
					</tr>
<?php
				} else {
					$totalField = $totalField - 1;
				}
			}
			
			if ($totalField == 0){
				echo get_cm_var('setcfg_users_extra_info_empty_msg');
			}
?>
			<tr>
				<td colspan="2" align="center" style="padding-top: 8px;">
				<?php
					if($totalField !=0 ){
					$sc = <<<start
					<input type="submit" name="" value="Save" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" /> <input type="button" name="" value="Cancel" onclick="javascript:popupClose();" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" />
start;
				echo $sc;
				}
				?>
				</td>
			</tr>
<?php
			break;
		case 'add':
			for ($i = 1; $i <= 10; $i++) {
				$varName = 'signup' . ($i == 10 ? '10' : '0' . $i);
				
				if ($i == 10 && (isset($esmsMode) && strcasecmp($esmsMode, 'on') == 0) && (isset($scratchLogin) && strcasecmp($scratchLogin, 'on') == 0) && $store_mobile_in_extra == 1){ // * start at 1
					$fieldName = get_cm_var('setcfg_users_extra_info_label_used_by_store_mobile');
				}
				else {
					$fieldName = get_custom_cm_var('ReqSignUp_extra' . $i);
				}
				
				if ($fieldName) {
?>
					<tr>
						<td valign="top"><b><?=$fieldName?></b></td>
						<td valign="top"><input type="text" name="<?=$varName?>" value="" style="border: 1px solid #99D1A2; width: 250px;" /></td>
					</tr>
<?php
				} else {
					$totalField = $totalField - 1;
				}
			}
			
			if ($totalField == 0){
				echo get_cm_var('setcfg_users_extra_info_empty_msg');
			}
?>
			<tr>
				<td colspan="2" align="center" style="padding-top: 8px;">
					<input type="button" name="" value="OK" onclick="javascript: saveDataToOpener();" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" /> <input type="button" name="" value="Cancel" onclick="javascript:popupClose();" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" />
				</td>
			</tr>
<?php
			break;
		case 'edit':
			for ($i = 1; $i <= 10; $i++) {
				$varName = 'signup' . ($i == 10 ? '10' : '0' . $i);
				if ($i == 10 && (isset($esmsMode) && strcasecmp($esmsMode, 'on') == 0) && (isset($scratchLogin) && strcasecmp($scratchLogin, 'on') == 0) && $store_mobile_in_extra == 1){ // * start at 1
					$fieldName = get_cm_var('setcfg_users_extra_info_label_used_by_store_mobile');
				}
				else {
					$fieldName = get_custom_cm_var('ReqSignUp_extra' . $i);
				}
				
				if ($fieldName) {
?>
					<tr>
						<td valign="top"><b><?=$fieldName?></b></td>
						<td valign="top"><input type="text" name="<?=$varName?>" value="<?=$$varName?>" style="border: 1px solid #99D1A2; width: 250px;" /></td>
					</tr>
<?php
				} else {
					$totalField = $totalField - 1;
				}
			}
			
			if ($totalField == 0){
				echo get_cm_var('setcfg_users_extra_info_empty_msg');
			}
?>
			<tr>
				<td colspan="2" align="center" style="padding-top: 8px;">
					<input type="button" name="" value="OK" onclick="javascript: saveDataToOpener();" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" /> <input type="button" name="" value="Cancel" onclick="javascript:popupClose();" style="border: 1px solid #18A718; background: #ddd; color: #003300; font-weight: bold;" />
				</td>
			</tr>
<?php
			break;
	}
?>
</table>
</form>
<script type="text/javascript">
if (opener.document.forms['<?=($_GET['action'] == 'add' ? 'addform' : 'userinfoform')?>'].signupData.value != '') {
	var signupDataTemp = JSON.parse(opener.document.forms['<?=($_GET['action'] == 'add' ? 'addform' : 'userinfoform')?>'].signupData.value);
	var fieldNameTemp = '';
	var fieldNumber = 0;
	for (var i in signupDataTemp) {
		fieldNumber = parseInt(i) + 1;
		fieldNameTemp = i == 9 ? 'signup10' : 'signup0' + fieldNumber;
		document.forms['User_ExtraInfo_Form'][fieldNameTemp].value = signupDataTemp[i];
	}
}
function popupClose() {
	this.close();
}
function saveDataToOpener() {
	var dataArray = new Array();
	<?php
		for ($i = 1; $i <= 10; $i++) {
			if ($i == 10 && (isset($esmsMode) && strcasecmp($esmsMode, 'on') == 0) && (isset($scratchLogin) && strcasecmp($scratchLogin, 'on') == 0) && $store_mobile_in_extra == 1){ // * start at 1
				$fieldName = get_cm_var('setcfg_users_extra_info_label_used_by_store_mobile');
			}
			else {
				$fieldName = get_custom_cm_var('ReqSignUp_extra' . $i);
			}
			
			if ($fieldName) {
				?>
				dataArray[<?=($i-1)?>] = document.forms['User_ExtraInfo_Form'].signup<?=($i == 10 ? '10' : '0' .$i)?>.value;
				<?php
			}
		}
	?>
	opener.document.forms['<?=($_GET['action'] == 'add' ? 'addform' : 'userinfoform')?>'].signupData.value = JSON.stringify(dataArray);
	this.close();
}
</script>
</body>
</html>
<?	
    odbc_close($userDB);
}else{
    echo "connection failed!";  
}

//$settingobj->Release();
$settingobj=null;
?>
  
