<?php

require_once "fs_lang.php";
require_once "common_functions.php";
require_once 'generate_common.php';

$wait_before_redirect=5;
$security = false;

$text_title=get_var('esms_form');
$error_message_footer=get_var('esms_fail_link');
$success_message_footer=get_var('esms_ok_link');
$phoneNumber=$_POST['phoneNumber'];
$success_url=$_POST['success_url'];
$failed_url=$_POST['failed_url'];

$settingobj = new COM("FSCONFIG.Cfgmgr") or die("fs_esms.php FSCONFIG.Cfgmgr Object cannot be created!");
// email to sms gateway
$esmsMode = $settingobj->getKey('esms_mode', 'gateway');
$SMTP = $settingobj->getKey( "esms_smtp_domain", "gateway");
$smtp_port = $settingobj->getKey( "esms_smtp_port", "gateway");

if (!isset($smtp_port) || $smtp_port == ''){
	$smtp_port =25;
}

$sendmail_from = $settingobj->getKey( "esms_sendmail_from", "gateway");
$sendmail_to = $settingobj->getKey( "esms_sendmail_to", "gateway");
$smsgateway = $settingobj->getKey( "smsgateway", "gateway");
$current_scratchcode = $settingobj->getKey( "current_scratchcode", "gateway");
$store_mobile_in_extra = $settingobj->getKey( "store_mobile_in_extra", "gateway");

$captcha_check = $settingobj->getKey("self_sign_up_captcha_check", "gateway");
if ($captcha_check == 'on' && isset($_POST['security_code']))
	$security_code=$_POST['security_code'];

// hard code
$retry_time=5;
$export_file = 'email_to_sms_gateway_error.log';

$r_state=0;
$error_msg = "";
if (isset($esmsMode) && strcasecmp($esmsMode, 'on') == 0){
if (isset($_SESSION['esms_status']) && $_SESSION['esms_status'] == 1){
	$error_msg = get_var('esms_send_already');
}
else if (isset($phoneNumber) && $phoneNumber!= '' && ctype_digit($phoneNumber)){

	// the captcha check is off
	if (!isset($security_code) && $captcha_check == 'off' ){
		$security = true;
	}
	//Compare security code 
	else if (isset($_SESSION['session_security_code_su']) && isset($_POST['security_code'])){
		if ($_SESSION['session_security_code_su'] == $security_code ){
			$security = true;
		}
	}

	// checking extra information field
	$isExtraInfo = true;
	$arr = array('01', '02', '03', '04', '05', '06', '07', '08', '09', '10');

	foreach ($arr as $value) {
		${"signup$value"."_not_empty"} = $settingobj->getKey( "ReqSignUp$value", "lang");
	}

	foreach ($arr as $value) {
		if (isset(${"signup$value"}) && (${"signup$value"."_not_empty"} == 'on'))
			if (${"signup$value"} == "" )
				$isExtraInfo = false;
	}
	
	if ($security == false){
		$error_msg = get_var('esms_problem_security_code_mismatch');
	}
	else if ($isExtraInfo == false){
		$error_msg = get_var('esms_problem_field_empty');
	}
	else{
	
		// hard code
		$lock_filename = "..\\authserv\\sc_lock.txt";
		
		$isLocked = false;
		
		$lock_handle = fopen($lock_filename, "a+");
		
		for ($i = 0; $i < $retry_time; $i ++){
		
			if(!flock($lock_handle, LOCK_EX | LOCK_NB)) {
				// Unable to obtain lock
				sleep(1);
			}
			else{
				// Able to obtain lock
				$isLocked = true;
				break;
			}
		}
		
		$sendMail = true;
		$print_err_log = false;
		
		if ($isLocked == false){
			$sendMail = false;
			$print_err_log = true;
			
			$error_msg = get_var('esms_lock_fail');
			$output = date("D M d H:i:s Y")." \t Fail to lock [Phone Number: $phoneNumber]\r\n";
		}
		else{

			$output = "";
			
			$curr_time = time();
			
			if ($smsgateway[0] == '.' || $smsgateway[0] == '@'){
				// no need adjust
			}
			else if (strpos($smsgateway, "@")=== false){
				// adjust
				$smsgateway = "@".$smsgateway;
			}
			else{
				// no . at font also no need adjust
			}
			
			$to = $phoneNumber.$smsgateway;
			
			if (isset($sendmail_to) && $sendmail_to != ''){
				// for testing purpose sending to your email address if set
				$to = $sendmail_to;
			}
			
			ini_set('SMTP', $SMTP);
			ini_set('smtp_port', $smtp_port);
			ini_set('sendmail_from', $sendmail_from);
			
			// hard code
			$filename = "..\\authserv\\email_to_sms_gateway_sample.eml";
			$handle = fopen($filename, "rb");
			$contents = fread($handle, filesize($filename));
			fclose($handle);
			
			// get scratch code
			$scratch_code="";
			
			$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
			$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
			$dsn='';

			if(!feof($dsn_source))
				$line=fgets($dsn_source,512); 

			while(!feof($dsn_source)) {
				$line=fgets($dsn_source,512);
				if (trim($line)!='') $dsn.=$line;
			}

			// 20090326 - Suppress SQL error shown in client browser
			$dsn=str_replace("\r\n",';',$dsn);
			$er = error_reporting(0);
			$userDB=odbc_connect($dsn,'','');
			error_reporting($er);
			
			$sub_q_condition = "";
			if (isset($current_scratchcode)){
				$sub_q_condition = " OR NAME = '".$current_scratchcode."'";
			}
			
			$q = 'select name from '.fs_usr_table()." WHERE (reserved1 is NULL AND (MACasUsr='N' OR MACasUsr IS NULL) AND (used='0' OR used IS NULL) AND (acctype=1 OR acctype=4))".$sub_q_condition." ORDER BY NAME;";
			
			if ($userDB != 0) {
				$result = odbc_exec( $userDB, $q );
				
				$i=1;
				$takeNextRecoed=false;
				$haveScratchCode=false;
				
				if (!isset($current_scratchcode) || $current_scratchcode == ''){
					$takeNextRecoed = true;
				}
				
				while (odbc_fetch_row($result,$i)) {
					$name=odbc_result($result,"name");
						
					if ($takeNextRecoed == true){
						$scratch_code = $name;
						$haveScratchCode = true;
						break;
					}
					
					if ($name == $current_scratchcode){
						$takeNextRecoed = true;
					}
					
					$i++;
				} //end of looping through all query result
				
				if (!$takeNextRecoed){
					// current scratch code not found in database
					// find in head
					$takeNextRecoed=true;
				}
				
				if ($takeNextRecoed && !$haveScratchCode){
					$j = 1;
					while (odbc_fetch_row($result,$j)) {
						$name=odbc_result($result,"name");
						
						if ($name == $current_scratchcode){
							
						}
						else if ($takeNextRecoed == true){
							$scratch_code = $name;
							$haveScratchCode = true;
							break;
						}
						
						$j++;
					} //end of looping through all query result
				}
				
				if (!$haveScratchCode && !$takeNextRecoed){
					// not found
					$sendMail = false;
					$print_err_log = true;
					$error_msg = get_var('esms_error1');
					$output = date("D M d H:i:s Y")." \t Cannot find current scratch code ($current_scratchcode) in database [Phone Number: $phoneNumber]\r\n";
				}
				else if (!$haveScratchCode){
					// full
					$sendMail = false;
					$print_err_log = true;
					$error_msg = get_var('esms_run_out');
					$output = date("D M d H:i:s Y")." \t do not send email to sms gateway (since Scratch Code has been run out) [Phone Number: $phoneNumber]\r\n";
				}
				else{
					// replace the tag
					
					/*
						%mobile_phone% (optional)
					*/
					$countOptional = 0;
					$contents = str_ireplace("%mobile_phone%", $phoneNumber, $contents, $countOptional);					
					
					/*
						%scratch_code%
					*/
					$count = 0;
					$contents = str_ireplace("%scratch_code%", $scratch_code, $contents, $count);
					
					// checking is it contain link tag
					if ($count <= 0){
					
						$sendMail = false;
						$print_err_log = true;
						$error_msg = get_var('esms_error2');
						$output = date("D M d H:i:s Y")." \t do not send email to sms gateway (since email sample (email_to_sms_gateway_sample.eml) do not contain any tag)[Phone Number: $phoneNumber]\r\n";
					}
					else {
						// divide content
						$pos = stripos($contents, "\r\n\r\n");
						
						if ($pos === false){
							// error
						}
						$org_header = substr($contents, 0, $pos);
				
						$message_body = strstr($contents, "\r\n\r\n");
						
						// get data from content
						$pos_subject_start = stripos($org_header, "Subject: ");
						$pos_subject_end = stripos($org_header, "\r\n", $pos_subject_start);
						$message_subject = substr($org_header, $pos_subject_start + strlen("Subject: "),$pos_subject_end-$pos_subject_start - strlen("Subject: "));

						$pos_to_start = stripos($org_header, "To: ");
						$pos_to_end = stripos($org_header, "\r\n", $pos_to_start);
						$message_to = substr($org_header, $pos_to_start + strlen("To: "),$pos_to_end-$pos_to_start - strlen("To: "));
						
						// erase subject and to field from header
						$message_header = $org_header;

						$message_header = str_ireplace("Subject: ".$message_subject."\r\n", "", $message_header); 
						$message_header = str_ireplace("To: ".$message_to."\r\n", "", $message_header); 
						
						if ($sendMail){
							$mail_sent = @mail( $to, $message_subject, $message_body, $message_header );
							
							if (!$mail_sent){
								$print_err_log = true;
								$error_msg = get_var('esms_send_sms_fail');
								$output = date("D M d H:i:s Y")."\t Fail to send email to sms gateway [Phone Number: $phoneNumber]\r\n";
							}
							else{
								$_SESSION['esms_status'] = 1;
								
								$session_handling=$settingobj->getKey( "session_handling", "gateway");
								$signup_mac_or_ip = "";
								if ($session_handling==0){
									$signup_mac_or_ip = isset($_SESSION['sess_patronsoft2'])? $_SESSION['sess_patronsoft2'] : '';
								}
								else{
									if ($session_handling == "1" && (!isset($_SESSION['sess_patronsoft2']) || $_SESSION['sess_patronsoft2'] == "")) {
										//flip ip address and convert it into long format
										$_SESSION['sess_patronsoft2'] = ip2long(join('.', array_reverse( explode('.', $_SERVER['REMOTE_ADDR']) ) ));  
									}
									$signup_mac_or_ip = isset($_SESSION['sess_patronsoft2'])? $_SESSION['sess_patronsoft2'] : '';	
								}
								
								$now = mktime();
								
								// update extra information field
								$q = "UPDATE ".fs_usr_table()." SET ";

								foreach ($arr as $value){
									if (isset(${"signup$value"})){
										if ($value == 10 && $store_mobile_in_extra == 1){ // * start at 1
											// skip, since this field used by store mobile during esms
										}
										else{
											$q .= "SIGNUP$value = '".${"signup$value"}."', ";
										}
									}
								}

								$q = substr($q, 0, strlen($q) - 1);  //trim the ending comma
								
								if ($store_mobile_in_extra == 1){
									// hard code store mobile in signup10
									$q .= " signup10='$phoneNumber',";
								}								
								
								$q .= " REQSIGNUP = NULL, used='1', signupmac='$signup_mac_or_ip', signuptime='$now' WHERE NAME = '$scratch_code'";
									
								$result = odbc_exec( $userDB, $q );
								
								$settingobj->setKey( $scratch_code, "current_scratchcode", "gateway");
								$r_state=1;
								
								/*
								// output sms signup data's log
								if ($r_state == 1) {
									$export_file = 'sms_signup.log';
									$output = "";
									
									$session_handling=$settingobj->getKey( "session_handling", "gateway");
									$signup_mac_or_ip = "";
									if ($session_handling==0){
										$signup_mac_or_ip = isset($_SESSION['sess_patronsoft2'])? make_mac_name($_SESSION['sess_patronsoft2']) : '';
									}
									else{
										if ($session_handling == "1" && (!isset($_SESSION['sess_patronsoft2']) || $_SESSION['sess_patronsoft2'] == "")) {
											//flip ip address and convert it into long format
											$_SESSION['sess_patronsoft2'] = ip2long(join('.', array_reverse( explode('.', $_SERVER['REMOTE_ADDR']) ) ));  
										}
										$signup_mac_or_ip = isset($_SESSION['sess_patronsoft2'])? make_ip_name($_SESSION['sess_patronsoft2']) : '';	
									}
									
									// log format: scratch_code, mobile_number, signup_mac_or_ip, signup_date
									$output .= $scratch_code.','.$phoneNumber.','.$signup_mac_or_ip.','.date("D M d H:i:s Y")."\r\n";
									$writeHd = false;
									
									if (is_file("..\\log\\".$export_file) == FALSE){
										touch ("..\\log\\".$export_file);
										$writeHd = true;
									}
									$fileHandler = fopen ("..\\log\\".$export_file, 'a');
									if ($writeHd == true)
										fwrite ($fileHandler, "scratch_code, mobile_number, signup_mac_or_ip, signup_date\r\n");
									fwrite ($fileHandler, $output);
									fclose ($fileHandler);
								}
								*/
							}
						}
					}
				}
				odbc_close( $userDB );
			}
			else{
				// fail to connect db
				$error_msg = get_var('esms_connect_db_fail');
				$output = date("D M d H:i:s Y")." \t Fail to connect database. [Phone Number: $phoneNumber]\r\n";
			}
			
			flock($lock_handle, LOCK_UN); // release the lock
		}
		
		if ($lock_handle)
			fclose($lock_handle);
		
		if ($print_err_log){
			$writeHd = false;
			
			if (is_file("..\\log\\".$export_file) == FALSE){
			touch ("..\\log\\".$export_file);
			$writeHd = true;
			}
			$fileHandler = fopen ("..\\log\\".$export_file, 'a');
			fwrite ($fileHandler, $output);
			fclose ($fileHandler);
		}
	}
}
else{
	$error_msg = get_var('esms_error');
}
}
else{
	// option not set
	$error_msg = get_var('esms_block_msg');
}

//release object
//$settingobj->Release();
$settingobj=null;

$meta='';
$input='';

if ($r_state == 1){
	// OK
	$input = '<span class="failloginspan">'.get_var('esms_success').' (Phone Number: '.$phoneNumber.')</span><br/><a class="freelink" href="'.$success_url.'">'.$success_message_footer.'</a><br/>';
	// $meta = '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_before_redirect.';URL='.$success_url.'">';
}
else{
	// Error occur
	$input = '<span class="failloginspan">'.$error_msg.'</span><br/><a class="freelink" href="'.$failed_url.'">'.$error_message_footer.'</a><br/>';
	$meta = '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_before_redirect.';URL='.$failed_url.'">'; 
}

GenTable($meta, $input, '');

exit();

?>
