<?php
// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
// include functions
require_once 'common_functions.php';
require_once 'fs_lang.php';
require_once "..\\cfgmgr\\fsAPI.php";

// $wait_b4_to_ok_page='0';
$wait_b4_to_fail_page='3';
$wait_b4_to_zero_page='5';

// 20080502 - Add retrieving Self Sign-up display flag
// 20080417 - Add retrieving scratch mode	

$settingobj						= new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
$redirect_address				= $settingobj->getKey('redirect_address', 'gateway');
$dsn_file						= $settingobj->getKey('Datasource', 'gateway');
$scratchLogin					= $settingobj->getKey('scratch_login', 'gateway');
$showSCode						= ($settingobj->getKey('showSCode', 'gateway')=='1');
$username_plus_scratch_login	= strtolower($settingobj->getKey('username_plus_scratch_login', 'gateway'));
$sn_login						= strtolower($settingobj->getKey('social_login', 'gateway'));
$enableSNOnly					= $settingobj->getKey('social_login_only', 'socialNetwork');
$fb_login						= "";
$fb_appid						= "";
$fb_pageid						= "";
$sn_continue					= false;
$ig_login 						= ""; 
$wb_login						= "";
$button							= "off";
$showinfo						= $settingobj->getKey('show_infobox', 'gateway');

$email_login					= ($settingobj->getKey('email_login', 'gateway')=='on');
if($email_login)
{
	$emailConfirm				= true;
	$isUseEmailasUsername		= true;
}
else
{
	$emailConfirm 				= ($settingobj->getKey('self_sign_up_email_verification', 'gateway') == '1');
	$isUseEmailasUsername		= ($settingobj->getKey('use_email_as_username', 'gateway') == '1');
}

// Check invoice if it is completed
if(isset($waitcomp) && $waitcomp > 0){
	if(isset($waiting) && $waiting > 0){
		include_once "..\\local\\transaction.php";
		$myTransaction = new transaction();
//		$status = $myTransaction->checkInvoiceStatus($waitcomp, 60);
		if(strtolower($myTransaction->checkInvoiceStatus($waitcomp, 120, 2)) != 'completed'){
			$input = '<span class="failloginspan">'.get_var('waiting_ppal_tcomplete_fail').'</span><br>';
			$meta = '';
			GenTable($meta, $input, '');
			exit;
		}
	}
	else{
		$input = '<span class="failloginspan">'.get_var('waiting_ppal_tcomplete').'</span><br>';
		$meta = '<META HTTP-EQUIV="Refresh" CONTENT="0; URL='.full_url($_SERVER).'&waiting=1">';
		GenTable($meta, $input, '');
		exit;
	}
}

// social network login option
if($sn_login === 'on'){
	$fb_login						= strtolower($settingobj->getKey('facebook_login', 'socialNetwork'));
	$ig_login 						= strtolower($settingobj->getKey('instagram_login', 'socialNetwork'));
	$wb_login 						= strtolower($settingobj->getKey('weibo_login', 'socialNetwork'));
//google plus login
	$gp_login 						= strtolower($settingobj->getKey('googlePlus_login', 'socialNetwork'));
	//facebook login
	if($fb_login === "on"){
		$fb_appid					= $settingobj->getKey('facebook_appid', 'socialNetwork');
		$fb_likeCheck				= (strtolower($settingobj->getKey('facebook_check_like', 'socialNetwork')) === "on");
		if($fb_appid == "" || !$fb_likeCheck)
			$fb_appid				= $settingobj->getKey('facebook_appid_default', 'socialNetwork');
			$fb_pageid					= $settingobj->getKey('facebook_pageid', 'socialNetwork');
			$fb_plan					= $settingobj->getKey('facebook_plan', 'socialNetwork');
	}
	// instagram login
	if($ig_login != null && $ig_login=== "on"){
		$IG_clientid 	= $settingobj->getKey('instagram_client_id', 'socialNetwork');
		$IG_clientS		= $settingobj->getKey('instagram_client_secret', 'socialNetwork');
		$ig_plan		= $settingobj->getKey('instagram_plan', 'socialNetwork');

		if ($IG_clientid == null || $IG_clientid=="")
			{
			$IG_clientid = "e2a2aeb73c1d43ad876f0c87348ed159" ;
			$_SESSION['IG_clientid'] = $IG_clientid ; 
			}
		
		if ($IG_clientS == null || $IG_clientS=="")
			{
			$IG_clientS = "51569732f56949539cb2bd89c6d66c12" ;
			$_SESSION['IG_clientS'] = $IG_clientS ; 
			}
		
		if($ig_plan== null|| $ig_plan=="")
			$ig_plan="Social Network Plan";
		$IG_redirectURL	= "http://firstspot.org:5788/instagram.php";
		$IG_aURL 		= "https://api.instagram.com/oauth/authorize/?client_id=$IG_clientid&redirect_uri=$IG_redirectURL&response_type=code";
		}

	//weibo login
	if($wb_login != null && $wb_login=== "on"){
	
		include_once( 'weibo_class.php' );
		$wb_akey 	= $settingobj->getKey('weibo_client_id', 'socialNetwork');
		$wb_skey		= $settingobj->getKey('weibo_client_secret', 'socialNetwork');
		$wb_plan		= $settingobj->getKey('weibo_plan', 'socialNetwork');

		$WB_CALLBACK_URL = "http://firstspot.org:5788/weibo_callback.php";
		
		if ($wb_akey == null || $wb_akey==""){
			$wb_akey = "3656515421";
			$_SESSION['wb_app_key'] = $wb_akey ;
			}
		if ($wb_skey == null || $wb_skey==""){
			$wb_skey = "b251b7b05cddd75e37e9b251a01d452d";
			$_SESSION['wb_se_key'] = $wb_skey ;
			}
		$_SESSION['WB_CALLBACK_URL'] = $WB_CALLBACK_URL ; 
		
		$o = new SaeTOAuthV2( $wb_akey , $wb_skey );
		$code_url = $o->getAuthorizeURL( $WB_CALLBACK_URL );
	
		if($wb_plan== null|| $wb_plan=="")
			$wb_plan="Social Network Plan";
	}
	
	//google plus login
	if($gp_login!= null && $gp_login=== "on"){
		$gp_clientid 	= $settingobj->getKey('googlePlus_client_id', 'socialNetwork');
		$gp_plan 	= $settingobj->getKey('googlePlus_plan', 'socialNetwork');
		
		if ($gp_clientid == null || $gp_clientid==""){
			$gp_clientid = "234237079608-nl5ka3hfqlupdkpih9geeam9pd9jf1na.apps.googleusercontent.com";
		}
		if($gp_plan== null|| $gp_plan=="")
			$gp_plan="Social Network Plan";
	}
	
	//declare social network username and password
	if(!(isset($username) && $username!="") && isset($socialType) && isset($_SESSION['social_type']) && isset($_SESSION['social_username'])&& isset($_SESSION['social_data'])  && $_SESSION['social_type']!='' && $_SESSION['social_username']!='' && $_SESSION['social_data']!='')
	{
		foreach($_SESSION['social_type'] as $value)
			if($value == $socialType)
				{
					$username 	= $_SESSION['social_username'][$value];
					$socialData = $_SESSION['social_data'][$value];
					$password 	= $_SESSION['social_username'][$value];
					unset($_SESSION['social_username']);
					unset($_SESSION['social_data']);
					unset($_SESSION['social_type']);
				}

		if(isset($socialData) && $socialData!='')
		{
			$socialName	= '|'.$socialData;
			if($socialType==1)
				{
				$socialName	= strstr($socialName, '|name=');
				$socialName	= substr($socialName, 6, strpos($socialName,'|',6)-6);
				}
			else if($socialType==2)
				{
				$socialName	= strstr($socialName, '|username=');
				$socialName	= substr($socialName, 11, strpos($socialName,'|',11)-11);
				}
		}
		switch($socialType)
		{
			case 1:
				$username	= 'FB_'.$username;
				$sn_plan	= $fb_plan;
				break;
			case 2:
				$username	= 'IG_'.$username;
				$sn_plan	= $ig_plan;
				break;
			case 4:
				$username	= 'WB_'.$username;
				$sn_plan	= $wb_plan;
				break;
			case 8:
				$username	= 'GP_'.$username;
				$sn_plan	= $gp_plan;
				break;
			//Create in the future....
		}
		$sn_continue = true;
	}
}

$displaySelfSignup = $settingobj->getKey('display_self_sign_up', 'gateway');
$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');
$dsn = '';

$myFsApi	= new fsAPI();

$scratchCodeAsUser = false;
if (isset($username_plus_scratch_login) && $username_plus_scratch_login == 'on' &&
	isset($scratchCodeLogin) && $scratchCodeLogin == true && !($scratchLogin == 'on')){
	$scratchCodeAsUser = true;
}

if (!feof($dsn_source)) {
	$line=fgets($dsn_source,512);
}
while (!feof($dsn_source)) {
	$line=fgets($dsn_source,512);
	if (trim($line)!='') $dsn=$dsn.$line;
}
$dsn=str_replace("\r\n",';',$dsn);

$isRedirect = $settingobj->getKey( 'redirect_cart', 'gateway');

// client pass-through  by 0 = MAC-based 1 = IP-based
$session_handling	= $settingobj->getKey( 'session_handling', 'gateway');

// get verion
$version			= $settingobj->getKey('version', 'version');

// get the absolute path and infobox port
$urlhead=fs_urlhead("infobox");

// 20090918 - Add retrieving login page content display control
$disable_show_reminder	= $settingobj->getKey('disable_show_reminder', 'lang');
$disable_show_example	= $settingobj->getKey('disable_show_example', 'lang');
$disable_show_link		= $settingobj->getKey('disable_show_link', 'lang');
$disable_show_tc		= $settingobj->getKey('disable_show_tc', 'lang');

// 20101025 - Obtain login CAPTCHA check setting
$login_captcha_check		= strtolower($settingobj->getKey('login_captcha_check', 'gateway'));
$esmsMode					= strtolower($settingobj->getKey('esms_mode', 'gateway'));
$start_up_redirect_wait		= $settingobj->getKey("start_up_redirect_wait", "gateway");
$start_up_redirect_option	= $settingobj->getKey("start_up_redirect_option", "gateway");
$start_up_redirect_url		= $settingobj->getKey('start_up_redirect_url', 'gateway');

//redirect to info box instead of pop-up
if ($start_up_redirect_option == 2 || $email_login)
	$showinfo="off";

//\\ 20130422 >>> 222 - Path for resend verification e-mail
$resend_email_page			= $settingobj->getKey('gateway_domain', 'gateway');
if($resend_email_page=='')
	$resend_email_page = 'firstspot.org';
$resend_email_page = 'http://'.$resend_email_page.':'.$settingobj->getKey('auth_port', 'gateway').'/resend_email.php';

$settingobj=null;

// assume it is valid
$valid=true;

// 20080714 - Retrieve destination string after auto refresh
if (!isset($desturl) && isset($_SESSION['sess_desturl']))
	$desturl = 'desturl='.$_SESSION['sess_desturl'];

// Unset username to stop login with exist user for email login
if($email_login)
	unset($username);

//\\ 20120813 - Decrypt $_GET['code'] as useful data ( user|passwd )
//\\ 20130606 >>> 222.1 - $_GET['code'] have not been url decoded for some cases
if(isset($_GET['code']))
{
	if($_GET['code'] != "")
	{
		if(strstr($_GET['code'],"|"))		// this condition should never happen as rawurlencode will encode '|'
			list($username, $password)  = explode("|", decrypt($_GET['code']));
		else
			list($username, $password)  = explode("|", decrypt(rawurldecode($_GET['code'])));
	}
	//error_log($_GET['code']." : ".$username." => ".$password);
}

// now, form is submitted and desturl is not posted
if(isset($desturl)) {
	// COM object provides desturl when user login

	// 'desturl' is empty
	if($desturl=='')		// invalid case
		$valid = false;
		
	else {	// continue processing..
		// 20090129 - Apply URL-encoded format according to RFC 1738 to the redirect links
		// 20080714 - Add else branch to get back information after auto refresh
		if (count($_GET) > 0) {
			// in case there are others non-firstspot specific querystring, concat them..
			// for security reason, POST data will not concat
			foreach($_GET as $item=>$value) {
			//echo "$item: $value<br/>";
			// 20080707 - Prepare extra redirect information at the 2nd round fs_login
				if ($item == 'desturl') {
					if (strpos($value, '&sslredir=') != FALSE) {
						$sslRedir = rawurlencode(substr($value, strpos($value, '&sslredir=')+10));
					} elseif (strpos($value, '&loginPage=') != FALSE) {
						$loginPage = substr($value, strpos($value, '&loginPage=')+11);
					}
				}
				// concat if value posted is neither 'desturl' nor 'patronsoft1' nor 'patronsoft2' nor 'firstspotL'
				if($item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
					$desturl = $desturl.'&'.$item.'='.$value;
			}
		} else
		{
			if (strpos($desturl, '&sslredir=') != FALSE)
				$sslRedir = rawurlencode(substr($desturl, strpos($desturl, '&sslredir=')+10));
			elseif (strpos($desturl, '&loginPage=') != FALSE)
				$loginPage = substr($desturl, strpos($desturl, '&loginPage=')+11);
		}
	}
	// reigster desturl session, if needed
	if(!isset($_SESSION['sess_desturl'])){
		$_SESSION['sess_desturl']=$desturl;
	}

	$sess_desturl=$_SESSION['sess_desturl'];
}

if(isset($sslpage)) {
	foreach($_GET as $item=>$value) {
		if($item!='sslpage' && $item!='loginPage' && $item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
			$sslpage .= '&'.$item.'='.$value;
	}
	// 20080707
	unset($loginPage);
}

if(isset($patronsoft1)) {
	// empty ip
	if($patronsoft1=='')
		$valid=false;
		
	// assign session value
	if(!isset($_SESSION['sess_patronsoft1']))
		$_SESSION['sess_patronsoft1']=$patronsoft1;

	$sess_patronsoft1=$_SESSION['sess_patronsoft1'];
}

if(isset($patronsoft2)) {
	// empty ip
	if($patronsoft2=='')
		$valid=false;
	
	// assign session value
	if(!isset($_SESSION['sess_patronsoft2']))
		$_SESSION['sess_patronsoft2']=$patronsoft2;

	$sess_patronsoft2=$_SESSION['sess_patronsoft2'];
}

if(!isset($_SESSION['sess_desturl']) && !isset($sess_patronsoft1) && !isset($sess_patronsoft2)) {
	//echo "<script type=\"text/javascript\">location.href='".$redirect_address."';</script>";
	// 20080703 - Add extra information in redirect link at the 1st round entering fs_login
	if (isset($sslpage)) {
	$redirect_suffix = "?&sslredir=$sslpage";
	} else {
	$redirect_suffix = "?&loginPage=1";
	}
	header("Location: $redirect_address$redirect_suffix");
	exit;
} elseif (isset($sslpage)) {
	// 20080707 - New case for HTTPS request at the 1st round entering fs_login and already have session values
	header("Location: $redirect_address?&sslredir=$sslpage");
	exit;
} elseif ((!isset($ok_url) && !isset($desturl)) || !isset($_SESSION['sess_desturl']) || !isset($sess_patronsoft1) || !isset($sess_patronsoft2)) {
	// 20080707 - New case for direct accessing 5788 at the 1st round entering fs_login and already have several session values
	header("Location: $redirect_address?&loginPage=1");
	exit;
} else {
	// no cache for browser
	header('Cache-Control: no-cache, must-revalidate');
}

// check if valid
if($valid) {
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');

	if(isset($sess_patronsoft2)) {
		$IP_str=long2ip(intval(floatval($sess_patronsoft2)));
		$tok = explode('.', $IP_str);
		$IP=$tok[3].'.'.$tok[2].'.'.$tok[1].'.'.$tok[0];

		$num=$settingobj->getKey( 'num_return_path', 'MNS');

		// 20080416 - Bug fix for getKey, store redirect template file to new variable for login_form use
		for ($x = 0; $x < $num; $x++) {
			$path	= $settingobj->getKey('return_path'.$x, 'MNS');
			$net	= explode(' ', $path);
			if (isInSubnet($net[0], $net[1], $IP)) {
				$enableRedir	= $settingobj->getKey('Login_enable'.$x, 'loginPhp');
				if ($enableRedir == 1) {
					$fail_url	= fs_form_to_load();
					$redirTpl	= $settingobj->getKey('Login_php_Num'.$x, "loginPhp");
				}
			}
		}
	}
	// validate anonymous login
	if(fs_is_anonymous_mode()) {
		$fieldEmpty = false;
		$isUpdated = false;
		$arr = array('01', '02', '03', '04', '05', '06', '07', '08', '09', '10' );

		foreach ($arr as $value)
				${"extra".$value."_not_empty"} = $settingobj->getKey( "extra$value", 'lang');

		foreach ($arr as $key => $value) {
				if( isset(${"extra$value"}) ) {
					if( ${"extra$value"}=='' && (${"extra".$value."_not_empty"} == 'on') )
						$fieldEmpty = true;
					else
						$isUpdated = true;
				}
		}

		if ($fieldEmpty==true) {
				$input = '<span class="failloginspan">'.get_var('extra_field_err_empty').'</span><br>';
				$meta = '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?reason=invalid">'; 
				GenTable($meta, $input, '');
		}
	} else {
		//$username = get_var('user_name') . " : ";
	}

	if( !(isset($fieldEmpty)&&($fieldEmpty==true))) {
		// create COM Object
		$IsRandom=$settingobj->getKey( 'random', 'gateway');
		if ($IsRandom) {
			$count=$settingobj->getKey( 'loginpage_pic_count', 'gateway');
			$r_no=gen_random_no($count);
		}
		else
			$r_no=0;
		$fname_loginpage_pic		="loginpage_pic";
		$fname_loginpage_pic		.=$r_no;
		$fname_loginpage_pic_html	="loginpage_pic_html";
		$fname_loginpage_pic_html	.=$r_no;
		$pic						=get_pic($fname_loginpage_pic);
		$html						=get_html($fname_loginpage_pic_html);
		$pic						='./loginpage_pic/'.$pic;
		$login_msg					= '';

		// 20100503 - Login preparation for free access account
		if (isset($_SESSION['free_access']) && $_SESSION['free_access']) {
			if (isset($_SESSION['session_username'])) {
				$username = $_SESSION['session_username'];
			}
		}

		// checking
		$inputCheckOK = true;
		if (isset($username) && $username!=''){
			$pos = strpos($username, " ");
			if ($pos === false) {}
			else{
				$inputCheckOK = false;
			}
		}
		if (isset($secret_code)){
			$pos = strpos($secret_code, " ");
			if ($pos === false) {}
			else{
				$inputCheckOK = false;
			}
		}

		// check username
		if($inputCheckOK && ((isset($username) && $username!='') || isset($secret_code) || isset($anonymous_mode_button))) {
			// create COM Object
			$myobj = new COM('FSAUTH.Authserv') or die('fs_login.php FSAUTH.Authserv Object cannot be created!');

			$secret_enable=$settingobj->getKey( 'secret_enable', 'gateway');
			$firstspotusertable=$settingobj->getKey( 'Datasource_Tablename', 'gateway'); 

			// 20100621 - Handle escape chars
			if (get_magic_quotes_gpc()) {
				if (isset($password)) {
					$password = stripslashes($password);
				}
				if (isset($username)) {
					$username = stripslashes($username);
				}
			}

			if(fs_is_anonymous_mode()) {
				$username = '';
				$password = '';
				$arr = array('01', '02', '03', '04', '05', '06', '07', '09', '10' );

				if( isset($isUpdated)&&($isUpdated==true)) {
					// connect to database
					$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
					$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
					$dsn='';

					if(!feof($dsn_source)) 
						$line=fgets($dsn_source,512); 

					while(!feof($dsn_source)) {
						$line=fgets($dsn_source,512);
						if (trim($line)!='')
							$dsn=$dsn.$line;
					}

					$dsn=str_replace("\r\n",';',$dsn);
					$userDB=odbc_connect($dsn,'','');

					// update the exfield table with extra information field
					$q = 'insert into '.fs_exfield_table().' ( signuptime, aexmac, ';
					$v = ' values( '.mktime().', '.$sess_patronsoft2.', ';

					foreach ($arr as $value) {
							if (isset(${"extra$value"})) {
								$q .= "AEX$value, ";
								$v .= "'".${"extra$value"}."', ";
							}
					}

					$q = substr($q, 0, strlen($q) - 2);  //trim the ending comma
					$v = substr($v, 0, strlen($v) - 2);  //trim the ending comma

					$q .= ") ";
					$v .= ");";
					$q .= $v;
					$result = odbc_exec($userDB,$q); 
				}

			// 20101025 - Login page CAPTCHA check
			} else {
				if (isset($login_captcha_check) && $login_captcha_check == 'on') {
					if (!(isset($_SESSION['session_security_code_li']) && isset($_POST['security_code'])
							&& $_SESSION['session_security_code_li'] == $_POST['security_code'])) {
						$meta = '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?reason=invalid">'; 
						$input = '<span class="failloginspan">'.get_var('login_captcha_mismatch').'</span><br>';
						//$settingobj = null;
						GenTable($meta, $input, '');
					}
				}
			}

			// 20071031 - Check DB for extra information before authentication
			$obj		= new COM("FSCONFIG.Cfgmgr") or die("fs_login.php FSCONFIG.Cfgmgr Object cannot be created!");
			$isRADIUS	= $obj->getKey("use_radius", "radius");
			//$obj->Release();
			$obj		= null;
			if ($isRADIUS != "true") {
				// connect to database
				$dsn_file	= $settingobj->getKey( 'Datasource', 'gateway');
				$dsn_source	= fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
				$dsn		='';

				if(!feof($dsn_source)) 
					$line=fgets($dsn_source,512); 

				while(!feof($dsn_source)) {
					$line=fgets($dsn_source,512);
					if (trim($line)!='')
						$dsn.=$line;
				}

				// 20090326 - Suppress SQL error shown in client browser
				$dsn	=str_replace("\r\n",';',$dsn);
				$er		=error_reporting(0);
				$userDB	=odbc_connect($dsn,'','');
				error_reporting($er);

				// 20090326 - Improve error handling
				$result		= FALSE;
				
				$q = 'select count(*) as num from '.fs_usr_table()." where ReqSignUp = 'Y' and name = '$username' and acctype <> 3 and acctype <> 4;";
				if ($userDB != 0) {
					$result = odbc_exec( $userDB, $q );
					if ($result != FALSE) {
						$RequestSU = odbc_result( $result, 'num' );
						if( $RequestSU == 0 && $sn_login === 'on' &&$sn_continue==true){
							//create new user for social network user
							$fields		= fs_get_plan_info($sn_plan);
							unset($fields['value']['PNAME']);
							unset($fields['type']['PNAME']);
							foreach($fields['type'] as $snutkey => $snutvalue){
								if($snutvalue == 'null'){
									unset($fields['value'][$snutkey]);
									unset($fields['type'][$snutkey]);
								}
								elseif($snutvalue == 'char')
									$fields['type'][$snutkey] = 0;
								else
									$fields['type'][$snutkey] = 1;
							}
							if(isset($socialType) && $socialType!=''){
								$fields['value']['SOCIALNET']	= $socialType;
								$fields['type']['SOCIALNET']	= 1;
							}
							if(isset($socialName) && $socialName!=''){
								$fields['value']['SOCIALNAME']	= $socialName;
								$fields['type']['SOCIALNAME']	= 0;
							}
							$createRlt	= $myFsApi->addUser($username, $password, $fields['value'], $fields['type']);
						}

						if($sn_login === 'on'){
							if(isset($socialData) && $socialData!=''){
								$social_info	= array();
								$social_dlist	= explode('|', $socialData);
								$tempString		= "";
								if($myFsApi->getUsrInfoTypes(intval($socialType))){
									foreach($social_dlist as $data){
										$skey		= $myFsApi->checkUsrInfoTypes($data);
										
										if($skey === false)	//	skip this info
										{
									
											continue;
										}
										else if($skey < 0)	//	New Information type found
											{$skey	= $myFsApi->addUsrInfoTypes(substr($data, 0, strpos($data, '=')), intval($socialType));
											
											}
										$updateUserInfo[$skey]=substr($data, strpos($data, '=')+1);
										
									}
									$result	= $myFsApi->addUserInfo($updateUserInfo, $username, intval($socialType));

								}
								else
								{
//									echo $myFsApi->phpGetLastError();
								}
								
								
							}
						}
						
						if( $RequestSU>0 ){
							if(!session_id())
								session_start();

							$_SESSION['session_username']=$username;

							// 20090812 - Set password as blank for scratch mode
							// 20071102 - Check password and stop redirect if incorrect
							if ($scratchLogin == 'on' || $scratchCodeAsUser == true) {
								$password = '';
							}
							$_SESSION['session_password'] = $password;
							$pwValidNum = fs_is_password_correct($username, $password);
;							if ($pwValidNum > 0) {
								header('Location: ReqSignUp_Form.php');
								$settingobj = null; // clear setting object before quit
								exit;
							}
						}
						
					}
				}
				if ($userDB == 0 || $result == FALSE) {
					$input = '<span class="failloginspan">'.get_var('login_database_unavailable').'</span><br>';
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
					GenTable($meta, $input, '');
				}
			}

			// get clinet browser information
			$useragent = $_SERVER['HTTP_USER_AGENT'];

				$fl_user = $username;
				if(isset($runame))
					$fl_user = $runame;

				if(isset($logout))
					$objrsult = $myobj->ForceLogout($fl_user);
				else if (isset($logout_from_other))
					$objrsult = $myobj->ForceLogoutFromOtherSite($fl_user, $sess_patronsoft2); // * In Anonymous and Share Secret, username will no usage

				if (strtolower($secret_enable)=='on')
					$objrsult = $myobj->Authenticate('', $secret_code, $sess_patronsoft1, $sess_patronsoft2, $useragent);
				else {
					// 20080417 - Set password as blank for scratch mode
					if (($scratchLogin == 'on' || $scratchCodeAsUser == true)&&$sn_continue==false)
						$password = '';
					
				// 20100503 - Login preparation for free access account
				if (isset($_SESSION['free_access']) && $_SESSION['free_access']) {
					if (isset($_SESSION['session_password']))
						$password = $_SESSION['session_password'];
					if (isset($_SESSION['ok_url']))
						$ok_url = $_SESSION['ok_url'];
				}

				if ($password == '' && !($scratchLogin == 'on' || $scratchCodeAsUser == true) && !fs_is_anonymous_mode()){
					// password is empty
					$objrsult = '';
				}
				else
				
					$objrsult = $myobj->Authenticate($username, $password, $sess_patronsoft1, $sess_patronsoft2, $useragent);
				
					
			}
			// authenticated

			// 20080410 - Return string instead of echo
			$scriptInput = "
	function CloseExistingInfoBox() {
		if (test) {			// test is used to prevent open/close action on platform that is incompatable with InfoBox (e.g. macOS captive network)
			popupWin = window.open('', 'firstspotInfoBox', '');
			if (popupWin) popupWin.close();
		}
	}";
			// 20100511 - Redirect cart URL to sign up form
			if (isset($_SESSION['free_access']) && $_SESSION['free_access']) {
				if(isset($_SESSION['cart_url'])){ //fix bug
					$cart_url = $_SESSION['cart_url'];
					unset($_SESSION['cart_url']);
				}
				else{
					echo "You already Logined, type 'logout' in the URL to logout your account.";
					exit();
				}
			}

			if (!($objrsult=='TR_MODE' || $objrsult=='SUCCESS' || $objrsult=='INSERT_TABLE' || $objrsult=='ALREADY_SERVING' || $objrsult=='EM_NOT_VERIFIED')) {
				$scriptInput .= "
	CloseExistingInfoBox();";
			}

			//authentication mode
			if($objrsult=='TR_MODE') {
				// 20080709 - Add okurl
				// In firstspot trial version, users will be automatically redirected to the page "Redirect.php" 
				// during the following object call, while no redirection will happen for release version.
				header("Location: trialmode.dll?login=$username&patronsoft1=$sess_patronsoft1&patronsoft2=$sess_patronsoft2&browserInfo=$useragent&okurl=$ok_url");
				$settingobj = null; // clear setting object before quit
				exit;
			} else if($objrsult=='SUCCESS' || $objrsult=='INSERT_TABLE' || $objrsult=='LOGIN_ONCE' || $objrsult=='EM_NOT_VERIFIED') {
				if(!session_id())
					session_start();

				if (isset($_SESSION['session_username']))
					$_SESSION['session_username']='';

				if ($objrsult=='LOGIN_ONCE')
					$_SESSION['login_once']='1';

				//\\ 20130422 >>> 222 - Change redirection target
				if(isset($_SESSION['sess_desturl']) && $objrsult=='EM_NOT_VERIFIED'){
					$ecuName = base64_encode("uid=".$username);
					$sess_desturl = $resend_email_page.'?code='.$ecuName;
					$_SESSION['sess_desturl']=$sess_desturl;
					if(strcmp(strtolower($version),'trial')==0){
						header("Location: trialmode.dll?login=$username&patronsoft1=$sess_patronsoft1&patronsoft2=$sess_patronsoft2&browserInfo=$useragent&okurl=$ok_url");
						$settingobj = null; // clear setting object before quit
						exit;
					}
				}

				if(isset($_SESSION['sess_desturl']) && ($start_up_redirect_wait == "" || $start_up_redirect_wait == 0)){
					if ($start_up_redirect_option == 1){
						$sess_desturl = $start_up_redirect_url;
						$_SESSION['sess_desturl'] = $start_up_redirect_url;
					}
					else if ($start_up_redirect_option == 2){
						$infobox_url=$urlhead.'info.php';
						$sess_desturl=$infobox_url;
						$_SESSION['sess_desturl']=$infobox_url;
					}
					header("Location: ".$_SESSION['sess_desturl']);
				}
				else{
					// The following code has no effect in trial version, but will cause a redirection to the 
					// page 'Redirect.php' in release version.
					header("Location: $ok_url");
				}
				$settingobj = null; // clear setting object before quit
				exit;
			} else if($objrsult=='ALREADY_SERVING') {
				if (isset($_SESSION['sess_desturl']) && ($start_up_redirect_wait == "" || $start_up_redirect_wait == 0)){
					if ($start_up_redirect_option == 1){
						$sess_desturl = $start_up_redirect_url;
						$_SESSION['sess_desturl'] = $start_up_redirect_url;
					}
					else if ($start_up_redirect_option == 2){
						$infobox_url=$urlhead.'info.php';
						$sess_desturl=$infobox_url;
						$_SESSION['sess_desturl']=$infobox_url;
					}
					header("Location: ".$_SESSION['sess_desturl']);
				}
				else{
					// current user and machine has already logged in and internet connection has been made ready, 
					// no need to submit login information again
					header("Location: $ok_url");
				}
				$settingobj = null; // clear setting object before quit
				exit;
			} else if($objrsult=='ALREADY_LOGGED') {
				//20080827	added redirect to info box option 
				//20080829	make infobox resizabe
				// 20080410 - Return string instead of echo
				if (strtolower($showinfo) == "on") {
					$scriptInput .= "
		var y = window.screen.availHeight - 25;
		var x = window.screen.availWidth - 10;
		var w = 400;
		var h = 200;
		y -= h;
		x -= w;

		function popInfoBox()
		{
			if (test){
				popupWin = window.open('', 'firstspotInfoBox', 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
				if (popupWin) {
				popupWin.location='".$urlhead."info.php?state=wait';
				popupWin.focus();
				}
			}
		}";
				}

					$input = '
		<br><span class="failloginspan">'.get_var('logged').'</span><br><br>
		<form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
		<input type="hidden" name="username" value="'.$username.'">
		<input type="hidden" name="password" value="'.$password.'">
		<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
		<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
		<input type="hidden" name="ok_url" value="redirect.php">
		<input type="hidden" name="fail_url" value="login_form.php">
		<input type="hidden" name="chgpw_url" value="chgpwd_form.php">
		<input type="hidden" name="zero_url" value="cart.php">
		<input type="hidden" name="cart_url" value="cart.php">
		<input type="hidden" name="logout" value="true">
		<input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('user_relogin_button').'" onclick="popInfoBox()">'.	//<<<<<<
		'</form>';
				GenTable('', $input, $scriptInput);
			} else if($objrsult=='ZERO_TIMELEFT') {
				if(!session_id())
					session_start();

			$_SESSION['session_username']=$username;
			$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

			$meta='';
			$input = '<span class="failloginspan">'.get_var('no_usage').'</span><br>';

			if($isRedirect==1){
				$temp_url = $cart_url;
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=nousage'>";
				if ($isRADIUS == "true") {
					$temp_url = $fail_url;
					// 20080714 - Save destination string
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=nousage&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				}
			}
			GenTable($meta, $input, $scriptInput);
		} else if($objrsult=='BWFAIL') {
			if(!session_id())
				session_start();

			$_SESSION['session_username']=$username;
			$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

			$meta = '';
			$input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
			if($isRedirect==1){
				$temp_url = $cart_url;
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfail'>";
				if ($isRADIUS == "true") {
					$temp_url = $fail_url;
					// 20080714 - Save destination string
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfail&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				}
			}
			GenTable($meta, $input, $scriptInput);
		} else if($objrsult=='BWFAILUL') {
			if(!session_id())
				session_start();

			$_SESSION['session_username']=$username;
			$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

			$meta = '';
			$input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
			if($isRedirect==1){
				$temp_url = $cart_url;
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailul'>";
				if ($isRADIUS == "true") {
					$temp_url = $fail_url;
					// 20080714 - Save destination string
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailul&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				}
			}
			GenTable($meta, $input, $scriptInput);
		// 20071126 - Add case for bandwidth quota sharing
		} else if ($objrsult == 'BWFAILSHARE') {
			if (!session_id()) 
				session_start();

			$_SESSION['session_username'] = $username;
			$meta = '';
			$input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
			if ($isRedirect == 1) {
				$temp_url = $cart_url;
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailshare'>";
				if ($isRADIUS == "true") {
					$temp_url = $fail_url;
					// 20080714 - Save destination string
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailshare&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				}
			}
			GenTable($meta, $input, $scriptInput);
		} else if($objrsult=='ACC_DISABLED') {
			if(!session_id())
				session_start();
			$_SESSION['session_username']=$username;
			$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

			$meta='';
			$input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
			if($isRedirect==1)
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$cart_url."?reason=disabled'>";
			GenTable($meta, $input, $scriptInput);
		} else if($objrsult=='START_DATE') {
				if(!session_id())
					session_start();

				$_SESSION['session_username']=$username;
				$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

				$meta = '';
				$input = '<span class="failloginspan">'. get_var('start_date').'</span><br>';
				if($isRedirect==1)
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$cart_url."?reason=sdate'>";
				GenTable($meta, $input, $scriptInput);
			} else if($objrsult=='MAX_LOGINS') {
				if(!session_id())
					session_start();

				$_SESSION['session_username']=$username;
				$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

				$meta = '';
				$input = '<span class="failloginspan">'.get_var('max_logins').'</span><br>';
				if($isRedirect==1)
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=" .  $cart_url . "?reason=maxlogins'>";
				GenTable($meta, $input, $scriptInput);  
			} else if($objrsult=='EXPIRY_DATE') {
				if(!session_id())
					session_start();

				$_SESSION['session_username']=$username;
				$_SESSION['session_code']=rawurlencode(encrypt($username.'|'.$password)); //\\

				$meta = '';
				$input = '<span class="failloginspan">'.get_var('expiry_date').'</span><br>';
				if($isRedirect==1){
					if(!isset($cart_url) || $cart_url =="")
						$cart_url = fs_urlhead().'cart.php/';
					$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$cart_url."?reason=edate'>";
				}
				GenTable($meta, $input, $scriptInput);
			} else if($objrsult=='SECRET_ERROR') {
				$input = '<span class="failloginspan">wrong code! Please try again...</span><br>';
		// 20080714 - Save destination string
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				GenTable($meta, $input, $scriptInput);
			} else if($objrsult=='REACH_CONC_MAX') {
				$input = '<span class="failloginspan">'.get_var('login_max_conc').'</span><br>';
				GenTable('', $input, $scriptInput);
			} else if($objrsult=='MAC_MISMATCH') {
				$input = '<span class="failloginspan">'.get_var('mac_mismatch').'</span><br>';
				GenTable('', $input, $scriptInput);
			} else if($objrsult=='SEGMENT_MISMATCH') {
				$input = '<span class="failloginspan">'.get_var('segment_mismatch').'</span><br>';
				GenTable('', $input, $scriptInput);
			} else if($objrsult=='LOGGED_IN_OTHER_SITE' ) {
				//20080827	added redirect to info box option 
				//20080829	make infobox resizabe
				if (strtolower($showinfo) == "on" && !fs_is_anonymous_mode()) {
					$scriptInput .= "
			var y = window.screen.availHeight - 25;
			var x = window.screen.availWidth - 10;
			var w = 400;
			var h = 200;
			y -= h;
			x -= w;

			function popInfoBox()
			{
				if (test){
					popupWin = window.open('', 'firstspotInfoBox', 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
					if (popupWin) {
					popupWin.location='".$urlhead."info.php?state=wait';
					popupWin.focus();
					}
				}
			}";
				}
				if (fs_is_anonymous_mode()){
					if (fs_is_shared_secret_in_anonymous_mode()){
						$input =  '
				<br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
				<form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
					<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
					<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
					<input type="hidden" name="ok_url" value="redirect.php">
					<input type="hidden" name="fail_url" value="alogin_form.php">
					<input type="hidden" name="cart_url" value="alogin_form.php">
					<input type="hidden" name="anonymous_mode_button" value="true">
					<input type="hidden" name="secret_code" value="'.$secret_code.'">
					<input type="hidden" name="logout_from_other" value="true">
					<input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
				</form>';
					}else {
						$input =  '
					<br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
					<form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
						<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
						<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
						<input type="hidden" name="ok_url" value="redirect.php">
						<input type="hidden" name="fail_url" value="alogin_form.php">
						<input type="hidden" name="cart_url" value="alogin_form.php">
						<input type="hidden" name="anonymous_mode_button" value="true">
						<input type="hidden" name="logout_from_other" value="true">
						<input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
					</form>';
					}
				}else{
					$input =  '
				<br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
				<form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
					<input type="hidden" name="username" value="'.$username.'">
					<input type="hidden" name="password" value="'.$password.'">
					<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
					<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
					<input type="hidden" name="ok_url" value="redirect.php">
					<input type="hidden" name="fail_url" value="login_form.php">
					<input type="hidden" name="chgpw_url" value="chgpwd_form.php">
					<input type="hidden" name="zero_url" value="cart.php">
					<input type="hidden" name="cart_url" value="cart.php">
					<input type="hidden" name="logout_from_other" value="true">
					<input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
				</form>';

				}
				GenTable('', $input, $scriptInput);

		// 20100707 - IP is being used by another user
		} elseif ($objrsult == 'IP_IS_LOGGED_IN') {
			$input = '<span class="failloginspan">'.get_var('login_ip_occupied').'</span><br>';
			GenTable('', $input, $scriptInput);

		// 20100707 - MAC is being used by another user
		} elseif ($objrsult == 'MAC_IS_LOGGED_IN') {
			$input = '<span class="failloginspan">'.get_var('login_mac_occupied').'</span><br>';
			GenTable('', $input, $scriptInput);

		}
		else if ($objrsult == 'FS_IN_BLACKOUT_PERIOD') {
			$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
			if (isset($showDomainUrl) && $showDomainUrl > 0) {

				if (substr_count(strtolower($version), 'standard') > 0) {
					$dn = 'firstspot.org';
				}
				else {
					$dn = $settingobj->getKey("gateway_domain", "gateway");
					if ($dn == '') {
						$dn = 'firstspot.org';
					}
				}
				$urlhead2 = $dn;
			}
			else	{
				$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
				$urlhead2 = $ip_address;
			}

			// hard code
			header("Location: http://".$urlhead2.":5803/blocked_notice.php?bClient=3");
			exit;
			}
		//\\ 20130717 >>> Enable relogin function for multiple login user
		elseif ($objrsult == 'REACH_USER_MULTIPLE_LOGIN_LIMIT') {	//// <<<< Edit to select user for force logout
			$input	= '';
			$dhcpfp	= $settingobj->getKey("dhcppath", "gateway");
			$dhcpfc	= file_get_contents($dhcpfp);
			$cMac	= null;
			$cIp	= null;
			$cHName	= null;

			$DFile	= $settingobj->getKey( 'Datasource', ($isRADIUS=='true'?'radius':'gateway'));
			$DTable	= $settingobj->getKey( 'Datasource_Tablename', ($isRADIUS=='true'?'radius':'gateway'));
			$DSource= fopen($DFile, 'r') or die('Cannot open Radius mode DSN source file!');
			$rDsn	= ''; 

			if(!feof($DSource))		//<<< First Line
				$ReadLine=fgets($DSource,512); 

			while(!feof($DSource)){	//<<< Following Line
				$ReadLine=fgets($DSource,512);
				if (trim($ReadLine)!='')
					$rDsn.=$ReadLine;
			}

			$rDsn	= str_replace("\r\n",';',$rDsn);
			$userDB	= odbc_connect($rDsn,'','');

			$input	.='<span class="failloginspan">'.get_var('reach_user_multiple_login_limit').'</span><br>';
					
			$rSql	= "select * from $DTable where name = '".$username."'";
			$result	= odbc_exec($userDB,$rSql);

			if(odbc_fetch_row($result))
			{
				if(odbc_result($result,"macmap") != '2'){
					preg_match_all('/([0-9A-F]{2}[-]){5}([0-9A-F]{2})/', $dhcpfc, $cMac);		//>>> $cMac[0][n]	= mac address
					preg_match_all('/IPADDR=(([0-9]{1,3}[\.]){3}([0-9]{1,3}))/', $dhcpfc, $cIp);//>>> $cIp[1][n]	= ip address
					preg_match_all('/HostName=([0-9A-z\-]+)/', $dhcpfc, $cHName);				//>>> $cHName[1][n]	= host name
					$cMac	= $cMac[0];
					$cIp	= $cIp[1];
					$cHName	= $cHName[1];

					$input	.='<br/><br/>
						<table border="1" bordercolor="#000000" bgcolor="#FFFFFF" cellspacing="0" width = "100%">
							<tr>
								<td>'.get_var('rumll_logged_in_user_device_name').'</td>
								<td>'.get_var('rumll_logged_in_user_mac').'</td>
								<td>'.get_var('rumll_logged_in_user_ip').'</td>
								<td>'.get_var('rumll_logged_in_user_time').'</td>
								<td></td>
							</tr>';

					$rSql	= "select * from $DTable where name like '".$username."[_]_%' order by reserved2";
					$result	= odbc_exec($userDB,$rSql);

					while (odbc_fetch_row($result))
					{
						$rName	= '';
						$rDName	= '';
						$ipAdd	= '';
						$macAdd	= '';
						$loginT	= '';

						$rName	= odbc_result($result,"name");
						if($session_handling == 0)
						{
							$macAdd	= odbc_result($result,"reserved1");
							$macAdd	= make_mac_name($macAdd);
							for($dCount = 0; $dCount < count($cMac); $dCount++){
								if(strcmp($cMac[$dCount],$macAdd) == 0)
								{
									$ipAdd	= $cIp[$dCount];
									$rDName	= $cHName[$dCount];
								}
							}
						}
						else
						{
							$ipAdd	= odbc_result($result,"reserved1");
							$ipAdd	= long2ip(intval(floatval($ipAdd)));
							$ipArr	= explode('.',$ipAdd);
							$ipAdd	= $ipArr[3].".".$ipArr[2].".".$ipArr[1].".".$ipArr[0];
							for($dCount = 0; $dCount < count($cIp); $dCount++){
								if(strcmp($cIp[$dCount],$ipAdd) == 0)
								{
									$macAdd	= $cMac[$dCount];
									$rDName	= $cHName[$dCount];
								}
							}
						}
						$loginT	= odbc_result($result,"reserved2");
						$loginT	= date("D M d H:i:s Y", $loginT);

						if($session_handling == 0)
							$regexp	= "/^".$username."_([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$/";
						else
							$regexp	= "/^".$username."_([0-9]{1,3}[\.]){3}([0-9]{1,3})$/";

						if(!preg_match($regexp, $rName))
							continue;

						$input	.='
							<tr>
								<td><font size="2">'.($rDName==''?'unknow':$rDName).'</font></td>
								<td><font size="2">'.($macAdd==''?'unknow':$macAdd).'</font></td>
								<td><font size="2">'.($ipAdd==''?'unknow':$ipAdd).'</font></td>
								<td><font size="2">'.$loginT.'</font></td>
								<td>
									<form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
										<input type="hidden" name="runame" value="'.$rName.'">
										<input type="hidden" name="username" value="'.$username.'">
										<input type="hidden" name="password" value="'.$password.'">
										<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
										<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
										<input type="hidden" name="ok_url" value="redirect.php">
										<input type="hidden" name="fail_url" value="login_form.php">
										<input type="hidden" name="chgpw_url" value="chgpwd_form.php">
										<input type="hidden" name="zero_url" value="cart.php">
										<input type="hidden" name="cart_url" value="cart.php">
										<input type="hidden" name="logout" value="true">
										<input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('rumll_logged_in_user_relogin').'" onclick="popInfoBox()">
									</form>
								</td>
							</tr>';
					}
					$input	.='</table>';
					//\\ <<<
				}
			}
			GenTable('', $input, $scriptInput);
		}
		//\\ 20121015 >>> 336 - Add checking for changing password when login
		elseif ($objrsult == 'LOGIN_CPW')	{
			if(!session_id())
				session_start();
			$_SESSION['session_username']=$username;
			$_SESSION['lcpw']=true;

			$input = '<span class="failloginspan">'.get_var('login_change_password').'</span><br>';
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".fs_urlhead().
			"chgpwd_form.php'>";
			GenTable($meta, $input, $scriptInput);
			$settingobj = null; // clear setting object before quit
			exit;
		}
		else {
			if (!isset($fail_url)) $fail_url='login_form.php';
			$input='<span class="failloginspan">'.get_var('invalid').'</span><br>';
			// 20080714 - Save destination string
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
			GenTable($meta, $input, $scriptInput);
		}

		// free the COM object
		//$myObj->Release();
		$myobj=null;  
	}
	elseif (!$inputCheckOK || (isset($username) && $username=='')) {
		if (!isset($fail_url)) $fail_url='login_form.php';
		$input= '<span class="failloginspan">'.get_var('invalid').'</span><br>';
		// 20080714 - Save destination string
		$meta= "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>"; 
		GenTable($meta, $input, '');
	}
	} // end fieldEmpty
	$settingobj=null;
}
else {  // login invalid
	if (!isset($fail_url)) $fail_url='login_select.php';
	$input= '<span class="failloginspan">'.get_var('invalid_access').'</span><br>';
	// 20080714 - Save destination string
	$meta= '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?desturl='.urlencode($_SESSION['sess_desturl']).'">';
	GenTable($meta, $input, '');
}

// check RADIUS mode
$obj = new COM("FSCONFIG.Cfgmgr") or die("fs_login.php FSCONFIG.Cfgmgr Object cannot be created!");
$isRADIUS = $obj->getKey("use_radius", "radius");
$global_bwcount_dl = $obj->getKey("bwcount_dl", "DataTransfer");
$global_bwquota_dl = $obj->getKey("bwquota_dl", "DataTransfer");
$global_bwcount_ul = $obj->getKey("bwcount_ul", "DataTransfer");
$global_bwquota_ul = $obj->getKey("bwquota_ul", "DataTransfer");
//$obj->Release();
$obj=null;

if ( ((isset($sess_patronsoft2) && $sess_patronsoft2!="" && $session_handling == 0) || (isset($sess_patronsoft1) && $sess_patronsoft1 !="" && $session_handling == 1)) && 
		!fs_is_anonymous_mode() && $isRADIUS == "false") {

	// 20100803 - Add searching passive login accounts with username
	// 20100429 - Select only non-free access accounts
	if ($session_handling==0){
		// Auto fill the username when the MAC address is the username
		$macname = make_mac_name($sess_patronsoft2);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' AND name='$macname' AND (faflag IS NULL OR faflag=0);";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
			$num = 0;
		} else {
			$num = odbc_result($result, "num");
			if ($num > 0) {
				$s_name = $macname;
			} else {
				$q = "SELECT name FROM ".fs_usr_table()." WHERE pwd IS NULL AND macasusr='Y' AND name LIKE '%(".$macname.")'";
				$result = db_query($q);
				if ($result != FALSE) {
					$s_name = odbc_result($result, 'name');
					if ($s_name != FALSE && $s_name != NULL && $s_name != '') {
						$num = 1;
					}
				}
			}
		}
	}else{
		// Auto fill the username when the IP address is the username
		$ipname = make_ip_name($sess_patronsoft1);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' AND name='$ipname' AND (faflag IS NULL OR faflag=0);";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
			$num = 0;
		} else {
			$num = odbc_result($result, "num");
			if ($num > 0) {
				$s_name = $ipname;
			} else {
				$q = "SELECT name FROM ".fs_usr_table()." WHERE pwd IS NULL AND macasusr='Y' AND name LIKE '%(".$ipname.")'";
				$result = db_query($q);
				if ($result != FALSE) {
					$s_name = odbc_result($result, 'name');
					if ($s_name != FALSE && $s_name != NULL && $s_name != '') {
						$num = 1;
					}
				}
			}
		}
	}

	if( $num > 0 ) {
		$q = "SELECT pwd as pw, status, sdate, edate, bwquota, bwquotaUL, bwquotaSha, bwcount, bwcountUL, bwcountSha, accumbw, accumbwUL, accumbwSha FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$s_name."'";
		$result = db_query($q);
		$pw = odbc_result($result, "pw");
		$status = odbc_result($result, "status");
		$bwquota = odbc_result($result, "bwquota");
		$bwquotaUL = odbc_result($result, "bwquotaUL");
		$bwquotaSha = odbc_result($result, "bwquotaSha");
		$bwcount = odbc_result($result, "bwcount");
		$bwcountUL = odbc_result($result, "bwcountUL");
		$bwcountSha = odbc_result($result, "bwcountSha");
		$accumbw = odbc_result($result, "accumbw");
		$accumbwUL = odbc_result($result, "accumbwUL");
		$accumbwSha = odbc_result($result, "accumbwSha");
		$sdate = odbc_result($result, "sdate");
		$edate = odbc_result($result, "edate");

		$currenttime = mktime();

		if($sdate!="") {
			list($day,$mon,$date,$time,$year)	= explode(" ", $sdate);
			list($hr,$min,$sec)  = explode(":", $time);
			$starttime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
		}

		if($edate!="") {
			list($day,$mon,$date,$time,$year)	= explode(" ", $edate);
			list($hr,$min,$sec)  = explode(":", $time);
			$endtime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
		}

		// Passive Login 
		if ($pw == ''){
			if(!session_id())
				session_start();

		$_SESSION['session_username']=$s_name;

		$meta='';

		if ($status == 1){
			$input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
		}
		else if (($bwcount == 2 && $accumbw>= $bwquota) || ($bwcount == "" && $global_bwcount_dl == 2 && $accumbw>= $global_bwquota_dl)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
		}
		else if (($bwcountUL == 2 && $accumbwUL>= $bwquotaUL) || ($bwcountUL == "" && $global_bwcount_dl == 2 && $accumbwUL>= $global_bwquota_ul)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
		}
		else if (($bwcountSha == 2 && $accumbwSha>= $bwquotaSha)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
		}
		else if ($sdate!="" && $currenttime < $starttime){
			$input = '<span class="failloginspan">'.get_var('start_date').'</span><br>';
		}
		else if ($edate!="" && $currenttime >= $endtime){
			$input = '<span class="failloginspan">'.get_var('expiry_date').'</span><br>';
		}
		else{
			$input = '<span class="failloginspan">'.get_var('no_usage').'</span><br>';
		}

		if($isRedirect==1)
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT= '".$wait_b4_to_zero_page." ;URL= cart.php?reason=nousage'>";

				GenTable($meta, $input, '');
		}

	// 20090326 - Handling for database failure
	} elseif ($result == FALSE) {
		$input = '<span class="failloginspan">'.get_var('login_database_unavailable').'</span><br>';
		$scriptInput = "
	CloseExistingInfoBox();";
		GenTable('', $input, '');
	}
}

//20080829	make infobox resizabe
// 20080401 - Output function content
function GetFunctContent($functName)
{
	$retStr = '';

	if ($functName == 'submitPopup') {
	global $showinfo, $urlhead;

	$retStr = "if (test) {";
	if (strcasecmp($showinfo, "ON") == 0 ) {
		$retStr .= "
		var popupName = 'firstspotInfoBox';
		popup = window.open('', popupName, 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
		popup.location = '".$urlhead."info.php?state=wait';
		popup.blur();
		window.focus();";
	} else {
		$retStr .= "return;";
	}
	$retStr .= "
	} else {
		return;
	}";
	} else if ($functName == 'fillName') {
	// 20080418 - Add password handling under scratch mode
	global $isRADIUS;
	global $sess_patronsoft2, $session_handling, $num, $pw, $version, $macname;
	global $sess_patronsoft1, $ipname;
	global $scratchLogin;
	global $username_plus_scratch_login;
	global $scratchCodeAsUser;

	if ($isRADIUS == "true") {
		$retStr = "document.loginForm.username.focus()";
	} else if (isset($sess_patronsoft2) && $sess_patronsoft2 != "" && $session_handling == 0) {
		if (($num > 0) && ($pw != '') && substr_count(strtolower($version), 'standard') == 0) {
		$retStr = "document.loginForm.username.value = '$macname';
	document.loginForm.username.readOnly = true;
	document.getElementById('name').style.display = 'none';
	document.getElementById('input').style.display = 'none';";
		if ($scratchLogin == 'off' && $scratchCodeAsUser == false) {
			$retStr .= "
	document.loginForm.password.focus();";
		}
		} else if (fs_is_shared_secret_in_anonymous_mode()) { // share secret
		$retStr = "if (document.loginForm.secret_code) {
		document.loginForm.secret_code.focus();
	}";
		}
		else if(fs_is_anonymous_mode()){ // anonymous
			$retStr .= "if (document.loginForm.anonymous_mode_button) {
				document.loginForm.anonymous_mode_button.focus();
			}";
		}
		else{ // normal user name and password
			$retStr .= "if (document.loginForm.username) {
				document.loginForm.username.focus();

			}";
		}
	} else if (isset($sess_patronsoft1) && $sess_patronsoft1 != "" && $session_handling == 1) {
		if (($num > 0) && ($pw != '') && substr_count(strtolower($version), 'standard') == 0) {
		$retStr = "document.loginForm.username.value = '$ipname';
	document.loginForm.username.readOnly = true;
	document.getElementById('name').style.display = 'none';
	document.getElementById('input').style.display = 'none';";
		if ($scratchLogin == 'off' && $scratchCodeAsUser == false) {
			$retStr .= "
	document.loginForm.password.focus();";
		}
		} else if (fs_is_shared_secret_in_anonymous_mode()) {
		$retStr = "if (document.loginForm.secret_code) {
		document.loginForm.secret_code.focus();
	}";
		}
		else if(fs_is_anonymous_mode()){ // anonymous
			$retStr .= "if (document.loginForm.anonymous_mode_button) {
				document.loginForm.anonymous_mode_button.focus();
			}";
		}
		else{ // normal user name and password
			$retStr .= "if (document.loginForm.username) {
				document.loginForm.username.focus();
			}";
		}
	}
	}

	return $retStr;
}

// 20080402 - Collect javascript content
$jsHeaderFunct = 'var y = window.screen.availHeight - 25	// y coordinate of popup
	var x = window.screen.availWidth - 10		// x coordinate of popup
	var w = 400	// width of popup
	var h = 200	// height of popup
	y -= h
	x -= w

	function submitPopup()
	{
	';

$jsHeaderFunct .= GetFunctContent('submitPopup');
$jsHeaderFunct .= '
	}

	var isFilled=false;

	fillName = function()
	{
	if (isFilled == false){
	';
$jsHeaderFunct .= GetFunctContent('fillName');
$jsHeaderFunct .= '
	isFilled = true;
	}
	}

	// Kick out frameset
	if (window.self != window.top) {
	window.top.location = window.self.location;
	}
	window.onload = fillName;';

// 20100430 - Change content retrieving method
// 20090918 - Add checking of content display
$sLoginRemind = '';
if (!isset($disable_show_reminder) || $disable_show_reminder != 1) {
	if (isset($p_result) && $p_result == 3) // iphone view
		$sBuf = get_var('ip_login_form_reminder');
	else
		$sBuf = get_var('login_form_reminder');
	$tok = strtok($sBuf, "\n");
	while ($tok !== FALSE) {
		$sLoginRemind .= "$tok<br>";
		$tok = strtok("\n");
	}
}

$sLoginLink = array();
if (!isset($disable_show_link) || $disable_show_link != 1) {
	$sBuf = get_var('login_form_link', true);
	$tok = strtok($sBuf, "\n");
	while ($tok !== FALSE) {
		$sLoginLink[] = explode('=', $tok, 2);
		$tok = strtok("\n");
	}
}

if (isset($disable_show_tc) && $disable_show_tc == 1)
	$sLoginTerm = '';
else
	$sLoginTerm = get_var('login_form_term', true);

if (isset($disable_show_example) && $disable_show_example == 1)
	$sLoginExample = '';
else
	$sLoginExample = get_var('example');

$myFsApi	= null;
// 20080402 - Create template engine instance

$smarty = new SmartyConnect;
$smarty->assign('J_LOGIN_FORM_HEADER', $jsHeaderFunct);

// 20080331 - Move layout content and include the file here
$smarty->display('login_form_header.tpl');

?>