<?php

// 20080415 - Add notice about layout modifications
/*
 * Please refer to
 * "FirstSpot\authserv\template\login_form_body.tpl"
 * for HTML layout content
 */

require_once 'generate_common.php';
require_once "fs_login.php";


// 20080401 - Collect dynamic HTML content for layout
$smarty->assign('L_LOGIN_FORM_HEAD_TITLE', get_var('greeting', true));
$smarty->assign('L_LOGIN_FORM_TITLE', get_var('greeting'));
$smarty->assign('L_LOGIN_FORM_CHARSET', metaCharset());
$smarty->assign('L_LOGIN_FORM_LANG_BOX', language_selection_box()); // generate a selection box for user to choose language
if ($html != '>') {
    $smarty->assign('L_LOGIN_FORM_PIC_LINK', "<a href=\"$html\">");
    $smarty->assign('L_LOGIN_FORM_PIC_LINK_END', "</a>");
} else {
    $smarty->assign('L_LOGIN_FORM_PIC_LINK', '');
    $smarty->assign('L_LOGIN_FORM_PIC_LINK_END', '');
}
$smarty->assign('LOGIN_FORM_PIC', $pic);
$smarty->assign('LOGIN_FORM_PIC_ALT', get_var('login_form_pic_alt'));

$fb_header			= "";
$fb_js_open			= "<!--";
$fb_js_close		= "-->";
$fb_display_open	= "<!--";
$fb_display_close	= "-->";
$sn_dialog_open		= "<!--";
$sncount = 0;
	$sn_dialog_close	= "-->";

$social_js          = "";
$submit_btn			= get_var('submit_btn');
$social_submitbtn 	= "";
$submit_act			= "";
$submit_display   	= "";

$ig_display_open 	="<!--";
$ig_display_close	="-->";

$wb_display_open	= "<!--";
$wb_display_close	= "-->";

$gp_display_open	= "<!--";
$gp_display_close	= "-->";

$td_display_open    ="";
$td_display_close	="";

$igLoginbtn  		= "";

$isFBLikeCheck		= "false";

if ($emailConfirm == '1' && $isUseEmailasUsername=='1')
	$username_label = get_var('email');
else
	$username_label = get_var('user_name');

if (isset($scratchLogin) && $scratchLogin == 'on' && $isRADIUS != "true") {
    $smarty->assign('L_LOGIN_FORM_USER_NAME', get_var('user_scratch'));
    $smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', $showSCode?'text':'password');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_OPEN', '');
    $smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_CLOSE', '');
}
else if (isset($username_plus_scratch_login)
		&& strtolower($username_plus_scratch_login) == 'on'
		&& $isRADIUS != "true")
{
	$smarty->assign('L_LOGIN_FORM_USER_NAME_SL', get_var('user_scratch'));
	$smarty->assign('L_LOGIN_FORM_USERBOX_TYPE_SL', $showSCode?'text':'password');
	$smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN_SL', '<!--');
	$smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE_SL', '-->');

	$smarty->assign('L_LOGIN_FORM_USER_NAME', $username_label);
	$smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', 'text');
	$smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '');

	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_CLOSE', '');

	$smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_CLOSE', '-->');
}
else if($email_login)
{
    $smarty->assign('L_LOGIN_FORM_USER_NAME', $username_label);
    $smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', 'text');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_CLOSE', '-->');
}
else
{
    $smarty->assign('L_LOGIN_FORM_USER_NAME', $username_label);
    $smarty->assign('L_LOGIN_FORM_USERBOX_TYPE', 'text');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '');

	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_CLOSE', '-->');
}

 if(isset($sn_login) && $sn_login === "on")
{

	$sn_dialog_open		= "";
	$sn_dialog_close	= "";
	$submit_act			= " onclick =\"return getLoginState()\"";
	$social_submitbtn	= get_var('continue_btn');
	$submit_display 	= "display:none" ;
	$social_js			= '	
	<script language="javascript">
	var docComplete = false;
	function changeValue(elementID,val1){
	document.getElementById(elementID).value=val1;
   }
   function loadXMLDoc(type, username, data, socialType,syn)
		{	
			if (window.XMLHttpRequest)
				xmlhttp=new XMLHttpRequest();                     // code for IE7+, Firefox, Chrome, Opera, Safari
			else
				xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");					// code for IE6, IE5	
			var SOCIAL_URL = "social_network.php";
			if(type===1)
				var socialLink= SOCIAL_URL+"?username="+username+"&data="+data+"&socialType="+socialType;
			else if(type===2)
				{
					var socialLink= SOCIAL_URL+"?count=1";
					xmlhttp.onreadystatechange=function()
					  {
					  if (xmlhttp.readyState==4 && xmlhttp.status==200)
						{
						socialLogin=xmlhttp.responseText;
						
						}
					  }
				}
			
			xmlhttp.open("GET",socialLink,syn);
			xmlhttp.send();
		}
		
	function sn_Logined_display(sn_type){


		if(sn_type==1){

			document.getElementById("fbTick").style.display ="";
		}
		else if(sn_type==2){
			document.getElementById("igTick").style.display ="";
		}
		if(sn_type==4){
			document.getElementById("wbTick").style.display ="";
		}
		if(sn_type==8){
			document.getElementById("gpTick").style.display ="";
		}
	}

	
  </script>
  <link rel="stylesheet" href="jquery-ui.css">
  <script src="../script/jquery-1.10.2.js"></script>
  <script src="../script/jquery-ui.js"></script>
';
	$smarty->assign('L_LOGIN_FORM_SOCIAL_NETWORK_SUMBIT_DISPLAY', $submit_display);

	if (isset($enableSNOnly) && $enableSNOnly == 'on' ){

    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_OPEN', '<!--');
	$smarty->assign('L_LOGIN_FORM_NOT_USERNAME_PLUS_SCRATCH_COMMENT_CLOSE', '-->');

	$smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_USERNAME_COMMENT_CLOSE', '-->');
	
	$smarty->assign('L_LOGIN_FORM_SN_ONLY_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_SN_ONLY_CLOSE', '-->');
	}

	
	if (isset($fb_login) && $fb_login == 'on' && isset($fb_appid) && $fb_appid != ''){
		$fb_header			=" xmlns:fb=\"http://ogp.me/ns/fb#\"";
		$fb_display_open	="";
		$fb_display_close	="";
		$fb_js_open			= "";
		$fb_js_close		= "";
		$isFBLikeCheck		= $fb_likeCheck?"true":"false";

		$smarty->assign('L_LOGIN_FORM_FB_APPID', $fb_appid);
		$smarty->assign('L_LOGIN_FORM_FB_PAGEID', $fb_pageid);

		$sncount+=1;
	}
	if(isset($ig_login) && $ig_login==="on" && isset($IG_aURL) && !empty($IG_aURL) )
		{
		$ig_display_open	= "";
		$ig_display_close	= "";
		$smarty->assign('L_LOGIN_FORM_IG_AURL', $IG_aURL);
		$sncount+=2;
		}
	else 
		{
		$smarty->assign('L_LOGIN_FORM_IG_AURL', "");
		}
	if(isset($wb_login) && $wb_login === "on" && isset ($code_url) && !empty($code_url))
	{
		$wb_display_open	= "";
		$wb_display_close	= "";
		$smarty->assign('L_LOGIN_FORM_SN_WEIBO', $code_url);
		$sncount+=4;
	}
	else 
	{
		$smarty->assign('L_LOGIN_FORM_SN_WEIBO', "");
	}
	if (isset($gp_login) && $gp_login == 'on' && isset($gp_clientid) && $gp_clientid != ''){
		$gp_display_open	= "";
		$gp_display_close	= "";
		$smarty->assign('L_LOGIN_FORM_SN_GOOGLE_PLUS_ID', $gp_clientid);
		$sncount+=8;
	}
}

$smarty->assign('L_LOGIN_FORM_NO_LOGIN',get_var('social_network_no_login'));
$smarty->assign('L_LOGIN_FORM_MUTI_SOCIAL_LOGIN',get_var('multiple_social_network_login'));

$smarty->assign('L_LOGIN_FORM_SOCIAL_NETWORK_JS',$social_js);
$smarty->assign('L_LOGIN_FORM_FB_CHECK', $submit_act);

$smarty->assign('L_LOGIN_FORM_FB_HEAD', $fb_header);
$smarty->assign('L_LOGIN_FORM_FB_JS_OPEN', $fb_js_open);
$smarty->assign('L_LOGIN_FORM_FB_JS_CLOSE', $fb_js_close);
$smarty->assign('L_LOGIN_FORM_FB_CHECK_LIKE', $isFBLikeCheck);
$smarty->assign('L_LOGIN_FORM_FB_DISPLAY_OPEN',$fb_display_open);
$smarty->assign('L_LOGIN_FORM_FB_DISPLAY_CLOSE',$fb_display_close);
$smarty->assign('L_LOGIN_FORM_FB_LIKE',get_var('facebook_like'));


if($sncount==1 ){
	$smarty->assign('L_LOGIN_FORM_FB_ONLY_OPEN', "<!--");
	$smarty->assign('L_LOGIN_FORM_FB_ONLY_CLOSE', "-->");
}



$smarty->assign('L_LOGIN_FORM_SN_DIALOG_OPEN', $sn_dialog_open);
$smarty->assign('L_LOGIN_FORM_SN_DIALOG_CLOSE', $sn_dialog_close);



$smarty->assign('L_LOGIN_FORM_INSTAGRAM_DISPLAY_OPEN', $ig_display_open);
$smarty->assign('L_LOGIN_FORM_INSTAGRAM_DISPLAY_CLOSE', $ig_display_close);

$smarty->assign('L_LOGIN_FORM_WEIBO_DISPLAY_OPEN', $wb_display_open);
$smarty->assign('L_LOGIN_FORM_WEIBO_DISPLAY_CLOSE', $wb_display_close);

$smarty->assign('L_LOGIN_FORM_GOOGLE_PLUS_DISPLAY_OPEN', $gp_display_open);
$smarty->assign('L_LOGIN_FORM_GOOGLE_PLUS_DISPLAY_CLOSE', $gp_display_close);

$cSelfSignup = '';
$cSelfSignup2 = '';
if(!$email_login && isset($displaySelfSignup) && strtolower($displaySelfSignup) == 'on') {
	if (isset($esmsMode) && strtolower($esmsMode) == 'on') {
		$cSelfSignup = '<a class="signuplink" href="esms.php">'.get_var('sign_up_now').'</a>';
		if (isset($username_plus_scratch_login) && strtolower($username_plus_scratch_login) == 'on') {
			$cSelfSignup2 = '<a class="signuplink" href="esms.php?sc=1">'.get_var('sign_up_now').'</a>';
		}
	}
	else{
		$cSelfSignup = '<a class="signuplink" href="signup_form.php">'.get_var('sign_up_now').'</a>';
		if (isset($username_plus_scratch_login) && strtolower($username_plus_scratch_login) == 'on') {
			$cSelfSignup2 = '<a class="signuplink" href="signup_form.php?sc=1">'.get_var('sign_up_now').'</a>';
		}
	}
}

if ($emailConfirm && $isUseEmailasUsername)
	$smarty->assign('LOGIN_FORM_METHOD_USERNAME', get_var('login_method_email'));
else
	$smarty->assign('LOGIN_FORM_METHOD_USERNAME', get_var('login_method_username'));

$smarty->assign('LOGIN_FORM_METHOD_SCRATCH', get_var('login_method_scratch'));

$smarty->assign('L_LOGIN_FORM_SELF_SIGN_UP', $cSelfSignup);
$smarty->assign('L_LOGIN_FORM_SELF_SIGN_UP2', $cSelfSignup2);
$smarty->assign('L_LOGIN_FORM_PASSWORD', get_var('Password'));
$smarty->assign('LOGIN_FORM_SUBMIT_BTN', $submit_btn);
$smarty->assign('LOGIN_FORM_SOCIAL_SUBMIT_BTN', $social_submitbtn);
if (isset($sLoginRemind)) {
    if ($sLoginRemind == '') {
		$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '<!--');
		$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '-->');
    } else {
		$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '');
		$smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '');
    }
    $smarty->assign('L_LOGIN_FORM_REMIND', $sLoginRemind);
} else {
    $smarty->assign('L_LOGIN_FORM_REMIND', '');
    $smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_REMIND_COMMENT_CLOSE', '-->');
}

// 20100430 - Mod complete
// 20090921 - Temp modification in v6, mod TPL in the next version
if (isset($sLoginExample)) {
	if ($sLoginExample == '') {
		$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_OPEN', '<!--');
		$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_CLOSE', '-->');
	} else {
		$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_OPEN', '');
		$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_CLOSE', '');
	}
	$smarty->assign('L_LOGIN_FORM_EXAMPLE', $sLoginExample);
} else {
	$smarty->assign('L_LOGIN_FORM_EXAMPLE', '');
	$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_OPEN', '');
	$smarty->assign('L_LOGIN_FORM_EXMAPLE_COMMENT_CLOSE', '');
}

$smarty->assign('L_LOGIN_FORM_SUPPORT_LINK', print_support_link('login'));
$smarty->assign('L_LOGIN_FORM_FREE_WEBSITE', get_var('free_website'));
if (isset($sLoginLink)) {
    if (count($sLoginLink) <= 0) {
		$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '<!--');
		$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '-->');
		$smarty->assign('L_LOGIN_FORM_LINK', '');
    } else {
		$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '');
		$smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '');
		$cLoginLink = '';
		$i = 0;
		while ($i < count($sLoginLink)) {
			if (isset($sLoginLink[$i][0]) && isset($sLoginLink[$i][1])) {
				$cLoginLink .= '
					<tr><td><a class="freelink" style="'.getStyle('login_form_link').'" href="'.$sLoginLink[$i][1].'">'.$sLoginLink[$i][0].'</a></td></tr>';
			} else 
				$cLoginLink .= '<tr><td><br></td></tr>';
			$i++;
		}
		$smarty->assign('L_LOGIN_FORM_LINK', $cLoginLink);
    }
} else {
    $smarty->assign('L_LOGIN_FORM_LINK_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_LINK_COMMENT_CLOSE', '-->');
    $smarty->assign('L_LOGIN_FORM_LINK', '');
}
$smarty->assign('L_LOGIN_FORM_TERM_TITLE', get_var('term_condition'));
if (isset($sLoginTerm)) {
    if ($sLoginTerm == '') {
		$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '<!--');
		$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '-->');
    } else {
		$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '');
		$smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '');
    }
		$smarty->assign('L_LOGIN_FORM_TERM_CONTENT', $sLoginTerm);
		$smarty->assign('L_LOGIN_FORM_TERM_CONTENT_STYLE', getStyle('login_form_term'));
} else {
    $smarty->assign('L_LOGIN_FORM_TERM_COMMENT_OPEN', '<!--');
    $smarty->assign('L_LOGIN_FORM_TERM_COMMENT_CLOSE', '-->');
    $smarty->assign('L_LOGIN_FORM_TERM_CONTENT', '');
    $smarty->assign('L_LOGIN_FORM_TERM_CONTENT_STYLE', '');
}
$smarty->assign('L_LOGIN_FORM_TECH_BY', get_var('login_form_tech_by'));

// 20100503 - Add session variable for free access
// 20080707 - Add new tag to pass redirect information
$sOkUrl = '';
if (isset($sslRedir))
    $sOkUrl = "?&sslredir=$sslRedir";
elseif (isset($loginPage))
    $sOkUrl = "?&loginPage=$loginPage";
$smarty->assign('LOGIN_FORM_OKURL', $sOkUrl);
$_SESSION['ok_url'] = "redirect.php$sOkUrl";

// change login form action for email login
if($email_login)
{
	$eml_js = '
<script type="text/javascript">
	window.onload = function()
	{
		document.loginForm.action = "fs_signup.php";
		document.loginForm.ok_url.value = "login_form.php";
		document.loginForm.ok_url.setAttribute("name", "success_url");
		document.loginForm.fail_url.value = "login_form.php";
		document.loginForm.fail_url.setAttribute("name", "failed_url");
		document.loginForm.zero_url.value = "login_form.php";
		document.loginForm.zero_url.setAttribute("name", "failed_url2");
	};
</script>';
	$j_common.= $eml_js;
}

// variable <p_result> init by generate_common.php
$l_meta="";
$l_body="";
if($p_result == 1)
{
	// workaround for add meta tag (purpose: set width = device width, scale = 1, <work in wm6.5 >) inside head tag through J_COMMON
	$l_meta.='<META content="width=device-width,minimum-scale=1.0,maximum-scale=1.0" name=viewport>';
	$j_common.=$l_meta;
	

	// workaround for window.onload <fs_login.php> not work in some mobile device (wm6.1.0 or previous version)
	$l_body='onload=fillName()';
	$smarty->assign('L_LOGIN_FORM_BODY', $l_body);

}

$smarty->assign('J_COMMON', $j_common);

// 20101025 - Control CAPTCHA section
$captchaStr = '';
$captchaStr2 = '';
if (isset($login_captcha_check) && $login_captcha_check == 'on') {
	if ($p_result == 3){ // iphone view
		$captchaStr = '<tr><td align="left" valign="bottom"><span class="securityspan">'.get_var('login_security_desc').'</span></td></tr>
					<tr>
						<td align="left" valign="bottom"><img class="captchaimg" src="CaptchaImage.php?width=230&height=40&num_character=6&dest=li" align="left"></td>
					</tr>
					<tr><td align="left" valign="bottom"><input class="userbox" type="text" name="security_code" tabindex="3" size="8px"></td></tr>
					';
	}
	else{
		$captchaStr = '<tr><td colspan=2 align="left" valign="bottom"><span class="securityspan">'.get_var('login_security_desc').'</span></td></tr>
					<tr>
						<td width="20%" align="left" valign="bottom"><img class="captchaimg" src="CaptchaImage.php?width=230&height=40&num_character=6&dest=li" align="left"></td>
						<td width="20%" align="left" valign="bottom"><input class="userbox" type="text" name="security_code" tabindex="3" size="8px"></td>
					</tr>';
	}

	if (isset($username_plus_scratch_login) && strtolower($username_plus_scratch_login) == 'on' && $isRADIUS != "true") {
		if ($p_result == 3){ // iphone view
			$captchaStr2 = '<tr><td align="left" valign="bottom"><span class="securityspan">'.get_var('login_security_desc').'</span></td></tr>
						<tr>
							<td align="left" valign="bottom"><img class="captchaimg" src="CaptchaImage.php?width=230&height=40&num_character=6&dest=li2" align="left"></td>
						</tr>
						<tr><td align="left" valign="bottom"><input class="userbox" type="text" name="security_code" tabindex="3" size="8px"></td></tr>
						';
		}
		else{
			$captchaStr2 = '<tr><td colspan=2 align="left" valign="bottom"><span class="securityspan">'.get_var('login_security_desc').'</span></td></tr>
						<tr>
							<td width="20%" align="left" valign="bottom"><img class="captchaimg" src="CaptchaImage.php?width=230&height=40&num_character=6&dest=li2" align="left"></td>
							<td width="20%" align="left" valign="bottom"><input class="userbox" type="text" name="security_code" tabindex="3" size="8px"></td>
						</tr>';
		}
	}
}

$smarty->assign('L_LOGIN_FORM_CAPTCHA_IMAGE', $captchaStr);
$smarty->assign('L_LOGIN_FORM_CAPTCHA_IMAGE2', $captchaStr2);

// 20080331 - Move layout content and include the file here
if (isset($enableRedir) && $enableRedir == 1)
    $smarty->display($redirTpl);
else {
	if ($p_result == 3) // iphone view
		$smarty->display('ip_login_form_body.tpl');
	else
		$smarty->display('login_form_body.tpl');
}

?>
