
	window.onload = function() { if (document.form1) {document.form1.username.focus();} else if (document.form3) {document.form3.username.focus();} };

	function check_username(un)
	{
	    for (var i = 0; i < un.length; i++) {
		// 20090129 - Add 46(.), 64(@) to allow e-mail format
		// ASCII 48-57(Number0-9), 65-90(A-Z), 97-122(a-z), 45(-), 95(_)
		if ((un.charCodeAt(i)>=48 && un.charCodeAt(i) <=57) ||
			(un.charCodeAt(i)>=65 && un.charCodeAt(i) <=90) ||
			(un.charCodeAt(i)>=97 && un.charCodeAt(i) <=122)||
			(un.charCodeAt(i) == 45) || (un.charCodeAt(i) == 46) ||
			(un.charCodeAt(i) == 64) || (un.charCodeAt(i) == 95)) {
		} else {
		    return false;
		}
	    }
	    return true;
	}

	function check_password(pw)
	{
	    for (var i = 0; i < pw.length; i++) {
		// ASCII 48-57(Number0-9), 65-90(A-Z), 97-122(a-z), 35-38(#$%&), 45(-), 95(_), 33(!), 42(*), 43(+), 63(?), 64(@), 94(^)
		if ((pw.charCodeAt(i)>=48 && pw.charCodeAt(i) <=57) ||
			(pw.charCodeAt(i)>=65 && pw.charCodeAt(i) <=90) ||
			(pw.charCodeAt(i)>=97 && pw.charCodeAt(i) <=122)||
			(pw.charCodeAt(i)>=35 && pw.charCodeAt(i) <=38)||
			(pw.charCodeAt(i)==45) ||
			(pw.charCodeAt(i)==95) ||
			(pw.charCodeAt(i)==33) ||
			(pw.charCodeAt(i)==42) ||
			(pw.charCodeAt(i)==43) ||				
			(pw.charCodeAt(i)==63) ||
			(pw.charCodeAt(i)==64) ||
			(pw.charCodeAt(i)==94)){
		} else {
		    return false;
		}
	    }
	    return true;
	}

	function inputCheck()
	{
	    var hiddenusername = document.getElementById('hiddenusername');
	    var temptime = new Date();
		
		// 0-username error 1, 1-username error 2, 2-username empty, 3-password error 1, 4-password error 2, 5-password empty
		// 6-password mismatch, 7-email error, 8-captcha empty
	    var errorarray = [];
		var firsterror = 100;	// remember the position of the first error, 100 means no errors
		var emailasuser = 0;
		
		if ( typeof document.form1.emailVer == 'undefined' ) { // assume email verification is turn off if email field is missing
			// do nothing, just print debug log
			console.log (temptime.toLocaleDateString() + ' ' + temptime.toLocaleTimeString() + ' : email field missing');
		} else { // email verification is on
			if ((hiddenusername != null) && getComputedStyle(hiddenusername).display == 'none') emailasuser = 1;
						
			if ((document.form1.emailVer.value.length <= 2) || (document.form1.emailVer.value.indexOf('@') <= 0)) {//basic check email format
				errorarray [7] = '{%$L_SIGNUP_FORM_PROBLEM_EMAIL%}';
				if (firsterror > 7) firsterror = 7;
			} else if (emailasuser == 1) { //use email as username, copy email field to username
				document.form1.username.value=document.form1.emailVer.value; // copy email field to username field
				console.log (temptime.toLocaleDateString() + ' ' + temptime.toLocaleTimeString() + ' : use email as username : ');
			}
		}
		
		temptime = undefined; // free memory
		
		var un = document.form1.username.value;
		
		if (emailasuser != 1) { // skip username check if "use email as username" is enabled
			//check user name
			if (un.length > 0) {
			// 20090130 - Update maximum length
			if (un.length > 40) {
				errorarray [0] = '{%$L_SIGNUP_FORM_PROBLEM_ID_TOTAL%}' + '{%$L_SIGNUP_FORM_USERNAME_CRITERIA%}';
				if (firsterror > 0) firsterror = 0;
			} else if (check_username(un) == false) {
				errorarray [1] = '{%$L_SIGNUP_FORM_PROBLEM_ID_CHARACTERS%}' + '{%$L_SIGNUP_FORM_USERNAME_CRITERIA%}';
				if (firsterror > 1) firsterror = 1;
			}
			} else {
				errorarray [2] = '{%$L_SIGNUP_FORM_PROBLEM_ID_EMPTY%}';
				if (firsterror > 2) firsterror = 2;
			}
		}
	    
		var pw1 = document.form1.password1.value;
	    
	    //check password
	    if (pw1.length > 0) {
		// 20090130 - Update maximum length
		if (pw1.length > 40) {
			errorarray [3] = '{%$L_SIGNUP_FORM_PROBLEM_PWD_TOTAL%}' + '{%$L_SIGNUP_FORM_PASSWORD_CRITERIA%}';
		    if (firsterror > 3) firsterror = 3;
		} else if (check_password(pw1) == false ) {
			errorarray [4] = '{%$L_SIGNUP_FORM_PROBLEM_PWD_CHARACTERS%}' + '{%$L_SIGNUP_FORM_PASSWORD_CRITERIA%}';
		    if (firsterror > 4) firsterror = 4;
		}
	    } else {
			errorarray [5] = '{%$L_SIGNUP_FORM_PROBLEM_PWD_EMPTY%}';
			if (firsterror > 5) firsterror = 5;
		}
	    
	    var pw2 = document.form1.password2.value;
	    
	    if (pw1 != pw2) {
			errorarray [6] = '{%$L_SIGNUP_FORM_PROBLEM_PWD_MISMATCH%}';
			if (firsterror > 6) firsterror = 6;
		}
	    
	    if ('{%$L_SIGNUP_FORM_CAPTCHA_OPTION%}' == 'on') {
       
		var sc = document.form1.security_code.value;
       
		if (sc.length <= 0) {
			errorarray [8] = '{%$L_SIGNUP_FORM_PROBLEM_SECURITY_CODE_EMPTY%}';
			if (firsterror > 8) firsterror = 8;
		} 
	    }
		
		if  (firsterror != 100) {  // there are errors
			alert (errorarray.filter (function(val) { return val !== null; }).join("\n\n"));
			switch (firsterror) {
				case 0:
				case 1:
				case 2:
					document.form1.username.focus();
					document.form1.username.select();
					break;
				case 3:
				case 4:
				case 5:
					document.form1.password1.focus();
					document.form1.password1.select();
					break;
				case 6:
					document.form1.password2.focus();
					document.form1.password2.select();
					break;
				case 7:
					document.form1.emailVer.focus();
					document.form1.emailVer.select();
					break;
				case 8:
					document.form1.security_code.focus();
					document.form1.security_code.select();
					break;
				default:
			}
			return false;
		} else {
			return ExtraInfoFieldsCheck('form1');
		}
	}

	function FAInputCheck()
	{
		if ('{%$L_SIGNUP_FORM_CAPTCHA_OPTION%}' == 'on') {
			var sc = document.form2.security_code.value;
		   
			if (sc.length <= 0) {
				alert('{%$L_SIGNUP_FORM_PROBLEM_SECURITY_CODE_EMPTY%}');
				document.form2.security_code.focus();

				return false;
			} 
		}

		return ExtraInfoFieldsCheck('form2');
	}
	
	function SCInputCheck()
	{
	    var un = document.form3.username.value;
	    
	    //check user name
	    if (un.length > 0) {
		// 20090130 - Update maximum length
		if (un.length > 40) {
		    alert('{%$L_SIGNUP_FORM_SC_PROBLEM_ID_TOTAL%}' + '{%$L_SIGNUP_FORM_USERNAME_CRITERIA%}');
		    document.form3.username.focus();
		    document.form3.username.select();
		    return false;
		} else if (check_username(un) == false) {
		    alert('{%$L_SIGNUP_FORM_SC_PROBLEM_ID_CHARACTERS%}' + '{%$L_SIGNUP_FORM_USERNAME_CRITERIA%}');
		    document.form3.username.focus();
		    document.form3.username.select();
		    return false;
		}
	    } else {
		alert('{%$L_SIGNUP_FORM_SC_PROBLEM_ID_EMPTY%}');
		document.form3.username.focus();
		return false;
	    }
	    
	    if ('{%$L_SIGNUP_FORM_CAPTCHA_OPTION%}' == 'on') {
       
		var sc = document.form3.security_code.value;
       
		if (sc.length <= 0) {
		    alert('{%$L_SIGNUP_FORM_PROBLEM_SECURITY_CODE_EMPTY%}');
		    document.form3.security_code.focus();
		    return false;
		} 
	    }
       
	    return ExtraInfoFieldsCheck('form3');
	}

	
	// generic functions to check Extra Information Fields in different forms
	function ExtraInfoFieldsCheck(formx)
	{
		var EIFerror='';
		
		for (i = 0; i < inputName.length; i++) {
			cur = eval('document.' + formx + '.' + inputName[i]);
			
			if ((typeof cur != 'undefined' && cur.value == '')
					&& eval(inputName[i] + '_not_empty') === "on") {
				EIFerror += '\n' + text_extra_field[i]; 		
			}
		}
		
		if (EIFerror !='')	{
			alert('{%$L_SIGNUP_FORM_EXTRA_INFO_EMPTY%}' + '\n' + EIFerror);
		}
		
		return (EIFerror == '');
	};