<?php header("Cache-Control: no-cache, must-revalidate"); ?>
<?php

	include_once '..\\authserv\\common_functions.php';
	include_once "transaction.php";
	$pending_release=false;
	
	picturePath();
	
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("webpay_callback.php FSCONFIG.Cfgmgr Object cannot be created!");
	$id=$settingobj->getKey( "webpay_id", "webpay");
	$mac=$settingobj->getKey( "webpay_mac_key", "webpay");
	$pid 	=$settingobj->getKey("webpay_product_id", "webpay");
	$alogin			=$settingobj->getKey( "auto_login", "creditcard");
	$test			=$settingobj->getKey( "webpay_testing", "webpay");
	
	// 20070831 - Correct typo
	$cancel_return=$settingobj->getKey("ppal_cancel_return", "paypal");
	// 20140820 - Sending email 
	$SMTP_server= $settingobj->getKey( "webpay_smtp_domain", "webpay");
	$email 		= $settingobj->getKey( "fromEmail", "webpay");
	$valid_txn = true;
	$current_time = time();
	$manual = false;
	if (isset($_POST['user']) && isset($_POST['manual'])){// manual means resubmitt by webpayrequery.html
		if ($_POST['manual'] = 'true' )$manual = true;
		$notrequery = true;
		$myTxn = new transaction();
		$info = $myTxn->requery_by_username($_POST['user']);// only requery the latest one
		if (($info == -1) || ($info == 0)){
			$valid_txn = false;
			$falsecode = 2; // no transaction to be requery
		} else {
			$transactionreference = $info['txn_ref'];
			$username = $_POST['user'];
			$amount = $info['amount'];
			$desc = $info['desc'];
			$invoice_no = $info['invoice_no'];
			$plan = $info['plan'];
			$post_time = $current_time;
			$notrequery = false;
			$log = $info['txn_ref'];
			
		$myTxn->writeLog("..\\log\\txn.log", $log);

		}
	} else {
		$myTxn = new transaction();
		if (isset($_POST["txnref"])){
		$transactionreference = $_POST["txnref"]; } else {
			$log = date('l dS \of F Y h:i:s A')." - undefine invoice number.\r\n\r\n";
			$myTxn->writeLog("..\\log\\txn.log", $log);
			die;
		}
		if (isset ($_SESSION['amount'])){
		$amount = $_SESSION['amount']; unset($_SESSION['amount']);
		} else $valid_txn = false;
		if (isset ($_SESSION['username'])){
		$username = $_SESSION['username'];
		} else $valid_txn = false;
		if (isset ($_SESSION['desc'])){
		$desc = $_SESSION['desc']; unset($_SESSION['desc']);
		} else $valid_txn = false;
		if (isset ($_SESSION['plan'])){
		$plan = $_SESSION['plan']; unset($_SESSION['plan']);
		} else $valid_txn = false;
		if (isset ($_SESSION['postTime'])){
		$post_time = $_SESSION['postTime']; unset($_SESSION['postTime']);
		} else $valid_txn = false;
		
	} 
	if($manual == false){
		if($alogin == 'true')
	{
	if($myTxn->checkUserLogin())
	$return = $return = FetchUrlPath().'redirect.php?loginPage=2';
	else // not logged in
		$return = fs_urlhead()."login_form.php?code=".$_SESSION['code'];
	}
	else $return=$settingobj->getKey( "ppal_return", "paypal");
	} else $return=NULL;
		$settingobj=null;
		
	if ( $valid_txn == true){
	$product_id = $pid;
	$hash = strtoupper(hash('sha512',$product_id.$transactionreference.$mac));
    $url = "https://stageserv.interswitchng.com/test_paydirect/api/v1/gettransaction.json?productid=$product_id&transactionreference=$transactionreference&amount=$amount";
	if($test != 'true')  $url = "https://webpay.interswitchng.com/paydirect/api/v1/gettransaction.json?productid=$product_id&transactionreference=$transactionreference&amount=$amount";
	$curl = curl_init($url);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER , 1); 
	curl_setopt($curl, CURLOPT_USERAGENT , 'Mozilla/4.0 (compatible; MSIE 6.0; MS Web Services Client Protocol 4.0.30319.239)');
	curl_setopt($curl, CURLOPT_HTTPHEADER , array("Hash: $hash")); 
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
	$resp = curl_exec($curl);
    curl_close($curl);
	$json=(array)json_decode($resp);
	
	$log="";
	$postfields['txnref'] = $transactionreference;
	foreach ($json as $key => $val){
		$postfields[strtolower($key)] = $val;
	}
	
	 
	 if ( $myTxn->isexist_transaction("invoice", $invoice_no) != true ) {
		$log .= date('l dS \of F Y h:i:s A')." - invoice number not found\r\n";
		$valid_txn = false;
	}
	
	/*if (isset($_POST["txnref"]) && $myTxn->isexist_transaction("txn_id", $_POST["txnref"]) == true ) {
    $log .= date('l dS \of F Y h:i:s A')." - Transaction has been processed\r\n";
    $valid_txn = false;
  }*/

  if (isset($post_time) && $post_time >0){
	$withinDay = false;
	$curr_localtime  = localtime($current_time, true);
	$post_localtime  = localtime($post_time, true);
	// compare the running time within a day
	if ($curr_localtime['tm_year'] == $post_localtime['tm_year'] && $curr_localtime['tm_yday'] == $post_localtime['tm_yday']){ // compare year and Day of the year 
		$withinDay = true;
	}
	if ($withinDay == false) { // not at the same day
		$log .= date('l dS \of F Y h:i:s A')." - Transaction (between submit and notification) not at the same day, it will affect calculate price with prorata\r\n";
		$valid_txn = false;
	}
  }

  if ( $valid_txn == false ) {
    foreach ( $_POST as $key => $val )
      $log .= "$key = $val\r\n";
    $log .= "\r\n";
    $myTxn->writeLog("..\\log\\txn.log", $log);
  }}
if ($valid_txn == true)
{
  $txn_fields=array();

	// 20090708 - Add field type array
	$bFieldNumeric = array();


	if (isset($json["ResponseCode"])) {
		$txn_fields['pay_status'] = $json["ResponseCode"];
		$bFieldNumeric['pay_status'] = 0;
	}
  
	if (isset($json["TransactionDate"])) {
		$txn_fields['pay_date'] = $json["TransactionDate"];
		$bFieldNumeric['pay_date'] = 0;
	}
	
	if (isset($transactionreference)){
		$txn_fields['txn_id'] = $transactionreference;
		$bFieldNumeric['txn_id'] = 0;
	}
	
	if (isset($plan)){
		$txn_fields['planname'] = $plan;
		$bFieldNumeric['planname'] = 0;
	}

	/*if (isset($json["RetrievalReferenceNumber"])) {
		$txn_fields['txn_id'] = $json["RetrievalReferenceNumber"];
		$bFieldNumeric['txn_id'] = 0;
	}
	if (isset($json["CardNumber"])) {
		$txn_fields['card_no'] = $json["CardNumber"];
		$bFieldNumeric['card_no'] = 0;
	}
  
	if (isset($json["MerchantReference"])) {
		$txn_fields['merchant_ref'] = $json["MerchantReference"];
		$bFieldNumeric['merchant_ref'] = 0;
	}
  
	if (isset($json["PaymentReference"])) {
		$txn_fields['payment_ref'] = $json["PaymentReference"];
		$bFieldNumeric['payment_ref'] = 0;
	}*/
  //handle your own postfields

  //update transaction
  if (count($txn_fields) > 0) {
   if ($txn_fields['pay_status'] =="00") $txn_fields['pay_status'] = "Completed"; else $txn_fields['pay_status'] ="Failed";
	$bFieldNumeric['pay_status'] = 0;
	
	
	
	// 20071114 - Set error flag
	// 20070807 - Validate if transacted amount matches with the plan
	$payErrFlag = 0;
	$pureGross = 0;
	
	if (isset($desc) && isset($json["Amount"])) {
		
		$pureGross = $json["Amount"];
		
		if (isset($post_time) && $post_time > 0){ // >0: using item attribute and set monthly pass
			$cart_item_arr = null;
			$cart_item_arr = $myTxn->get_cart_item_arr_by_desc($desc);
			
			if($cart_item_arr!=null){
				$base_time = 0;
				$u_expire_month = 0;

				if ($username != ""){
					$u_expire_month = fs_expire_month_utime($username); // get user expire month (unix timestamp format)
				}

				if ( $current_time > $u_expire_month || $u_expire_month == false) // emonth eyear field is null or expired
					$base_time = $current_time;
				else
					$base_time = $u_expire_month;
					
				if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
					// calculate price with prorata
					$p_price = fs_cal_price_with_prorata($base_time, $cart_item_arr["amount"], $cart_item_arr["item_attr"]["topup"], 2);
					
					$pureGross = $pureGross + ($cart_item_arr["amount"] - $p_price);
				}
				else{
				}
			}
		}
	    $vRC = $myTxn->ValidateCart($desc, $pureGross / 100);
	    if ($vRC == -1) {
		$txn_fields['pay_status'] = "Failed";
		$payErrFlag = -2;
	    } elseif ($vRC == -2) {
		$txn_fields['pay_status'] = "Failed";
		$payErrFlag = -3;
	    }
	} else {
	    $txn_fields['pay_status'] = "Failed";
	    $payErrFlag = -1;
	}
		
		$myTxn->update_transaction($invoice_no, $txn_fields, $bFieldNumeric);
  }

    if (isset($json['ResponseCode'])) {
	if ($json['ResponseCode'] == "00" && strtolower($txn_fields["pay_status"]) == "completed") {
	
		if (!isset($plan) || $plan =='')
			$myTxn->update_usr_table_by_item_attr($username, $desc, $post_time);
		else
		$myTxn->update_usr_table($username, $plan);
	
	    $log = "Interswitch WebPAY : ".date('l dS \of F Y h:i:s A')." - $username has been updated!\r\n";
	} else {
	    if ($payErrFlag == -1) {
		$log = "Interswitch WebPAY : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to insufficient payment information!\r\n";
	    } elseif ($payErrFlag == -2) {
		$log = "Interswitch WebPAY : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to chosen shopping item does not exist!\r\n";
	    } elseif ($payErrFlag == -3) {
		$log = "Interswitch WebPAY : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to payment amount mismatch!\r\n";
	    } else {
		$log = "Interswitch WebPAY : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account!\r\n";
	    }

	    // 20071115 - Print all postfields for investigation
	    foreach ($json as $key => $val) {
		$log .= "$key = $val\r\n";
	    }
	    $log .= "\r\n";
	}
	$myTxn->writeLog("..\\log\\txn.log", $log);
    }
}	

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>FirstSpot&reg; | submit</title>

</head>
<body <?php if(!$manual) echo "onLoad=\"redirect()\""?>>
<?php
if ( isset($transactionreference) &&  $json["ResponseCode"]=="00" && strtolower($txn_fields["pay_status"]) == "completed"&& isset($valid_txn) && $valid_txn == true )
	{
		$redirect_url=$return;

		echo "<p>Transaction succeed!<br>";
		

		
		// sending email
		$to = array();
		$sendMail = true;
		$export_file = '..\\log\\txn.log';
		$output = "";
		$attachment = null;
		$reciver = null;
		$curr_time = time();

		$to[0][0] = "to";
		$to[0][1] = $_SESSION['webpay_email'];
		$to[0][2] = "";

		$filename = "webpay_email.eml";
		$handle = fopen($filename, "rb");
		if($handle != false)
		{
			$contents = fread($handle, filesize($filename));
			$contents = str_replace('%account%','account',$contents);
			$contents = str_replace('%amount%',$amount,$contents);
			$contents = str_replace('%sender%',$SMTP_server,$contents);
			$contents = str_replace('%refNum%',$transactionreference,$contents);
			fclose($handle);
		
			$pos = stripos($contents, "\r\n\r\n");
			if ($pos === false)
			{
				$output.= date("D M d H:i:s Y")."\t Email Error : Content header not found\n";
				$sendMail = false;
			}
		}
		else
		{
			$output.= date("D M d H:i:s Y")."\t Email Error : Email sample not found\n";
			$sendMail = false;
		}

		$org_header = substr($contents, 0, $pos);
		$message_body = strstr($contents, "<!DOCTYPE");

		// get data from content
		$pos_subject_start = stripos($org_header, "Subject: ");
		$pos_subject_end = stripos($org_header, "\r\n", $pos_subject_start);
		$message_subject = substr($org_header, $pos_subject_start + strlen("Subject: "),$pos_subject_end-$pos_subject_start - strlen("Subject: "));

		if (is_file("..\\log\\".$export_file) == FALSE)
			touch ("..\\log\\".$export_file);
		$fileHandler = fopen ("..\\log\\".$export_file, 'a');


		if ($sendMail)
		{
				$mail_sent = sys_mail( $to, $message_subject, $message_body, setWebpayMail(), $attachment);
			if ($mail_sent!="0")
				{
				$output.= date("D M d H:i:s Y")."\t Email Error : $mail_sent\r\n";
				echo "Fail to send verification email (SMTP error)" ;
				}
			else
				$output.= date("D M d H:i:s Y")."\t Verification email is sent sucessfully\r\n";
				
		}
		if (is_file("..\\log\\".$export_file) == FALSE)
			touch ("..\\log\\".$export_file);
		$fileHandler = fopen ("..\\log\\".$export_file, 'a');

		fwrite ($fileHandler, $output);
		fclose ($fileHandler);
	  
	}
else
	{
	$redirect_url=$cancel_return;
	if ($falsecode = 2) 
		echo "<p>No Transaction to be requeried!<br>";
	else 
		echo "<p>Transaction failed!<br>";
	if (!$notrequery)
		if ($json["ResponseCode"]!="00")
		  echo "Response Code: ".$json['ResponseCode']." Response Description: ".$json['ResponseDescription']."<br>";
	echo "Please contact the help desk!";
	}

if (!$manual)
{
	echo "<p>You will be redirected shortly.<br>";
	echo "<a href='".$redirect_url."'>Click here to proceed</a>";
}
?>
</body>
<link href="local.css" rel="stylesheet" type="text/css">
<script type="text/javascript">
function redirect() {

	setTimeout("location.href=<?php echo "'".$redirect_url."'"; ?>", 5000);
}
</script>
</html>
