<?php
    /*
     *  To add a field for a user
     *  A. Update user tab
     *    1. Add HTML element in 'userinfoform' and 'addform'
     *    2. Update javascript:
     *      -changeUser() //add displayArray[]
     *      -displayInfo() //add argument, set value according to argument 
     *      -clearAddformData() //set default value
     *      -validate_ue() // in validate.php if field validation needed
     *      -validate_ua() // in validate.php if field validation needed
     *    3. Update makeUserDetailFromODBCResult() in common_functions.php
     *    4. Update editUser.php to save user data in both add and edit mode
     *
     *  B. Update plan tab
     *    1. Add HTML element in plan
     *    2. Update settingok.php
     *    3. Update loadPlans.php
     *    4. Update javascript
     *      -clearPlan() in plan.js
     *
     *  C. Update bulk account
     *    1. settingok.php
     *
     *  D. Update advanced search user form if needed
     *    1. Steps can be found in searchUser.js
     */
?>
    <script type="text/javascript" src="./javascript/loadingBox.js"></script>
	
	<?php //date picker plugin ?>
	<script type="text/javascript" src="plugin/date-picker/js/datepicker.js"></script>
    <link href="plugin/date-picker/css/datepicker.css" rel="stylesheet" type="text/css" />
	<?php //end date picker plugin ?>
	<?php multiple_login_js(0);multiple_login_js(1)?>
    <script type="text/javascript">
	var ns=(document.layers);
	var ie=(document.all);
	var w3=(document.getElementById && !ie);
	
	function initSavebtn(){
		if(!ns && !ie && !w3) return;
		if(ie) addSaveDiv=eval('document.all.AddSavebtn.style');
		else if(ns) addSaveDiv=eval('document.layers["AddSavebtn"]');
		else if(w3) addSaveDiv=eval('document.getElementById("AddSavebtn").style');
		
		if(ie) editSaveDiv=eval('document.all.saveBtn.style');
		else if(ns) editSaveDiv=eval('document.layers["saveBtn"]');
		else if(w3) editSaveDiv=eval('document.getElementById("saveBtn").style');
		
	    // 20071112 - Must init position of loading box here as only allow 1 init function
	    if (ie) {
		loadingBoxDiv = eval('document.all.loadingBox.style');
	    } else if (ns) {
		loadingBoxDiv = eval('document.layers["loadingBox"]');
	    } else if (w3) {
		loadingBoxDiv = eval('document.getElementById("loadingBox").style');
	    }

		showAddSavebtn();
		showEditSavebtn();

	    // 20071112 - Must set position of loading box here as only allow 1 init function
	    ShowLoadingBox();
	}

	function showAddSavebtn(){
		//var addFormHeight_ie = 1480
		//var addFormHeight_mozilla = 1420
		var addFormHeight = document.exportUsageform.exportLog.offsetParent.offsetTop - 10;
		
		// 20071109 - Adjust vertical position
		if (ie){
			documentWidth =document.body.offsetWidth - 220;
			documentHeight =document.body.offsetHeight+document.body.scrollTop-50;
		}
		else if (ns){
			documentWidth=window.innerWidth - 230;
			documentHeight=window.innerHeight+window.pageYOffset-50;
		}
		else if (w3){
			documentWidth=self.innerWidth - 230;
			documentHeight=self.innerHeight+window.pageYOffset-50;
		}
		
		addSaveDiv.left=600;
		addSaveDiv.left=documentWidth;
		
		if (documentHeight>addFormHeight)
			addSaveDiv.top = addFormHeight;
		else
			addSaveDiv.top =documentHeight;
		
		setTimeout("showAddSavebtn()",100);
	}
	
	function showEditSavebtn(){
		//var editFormHeight_ie = 1720;
		//var editFormHeight_mozilla = 1690;
		var editFormHeight = document.exportUsageform.exportLog.offsetParent.offsetTop - 10;
		
		// 20071109 - Adjust vertical position
		if (ie){
			documentWidth =document.body.offsetWidth - 220;
			documentHeight =document.body.offsetHeight+document.body.scrollTop-50;
		}
		else if (ns){
			documentWidth=window.innerWidth - 230;
			documentHeight=window.innerHeight+window.pageYOffset-50;
		}
		else if (w3){
			documentWidth=self.innerWidth - 230;
			documentHeight=self.innerHeight+window.pageYOffset-50;
		}
		
		editSaveDiv.left=600;
		editSaveDiv.left=documentWidth;
		if (documentHeight>editFormHeight)
			editSaveDiv.top = editFormHeight;
		else
			editSaveDiv.top =documentHeight;
		
		setTimeout("showEditSavebtn()",100);
	}

	// 20080318 - Fix position shown in Firefox
	// 20071112 - Control the position of loading box
	function ShowLoadingBox() {
	    if (ie) {
		documentHeight = document.body.scrollTop;
	    } else if (ns) {
		documentHeight = window.innerHeight + window.pageYOffset - 50;
	    } else if (w3) {
		documentHeight = self.pageYOffset;
	    }
	    loadingBoxDiv.right = 0;
	    loadingBoxDiv.top = documentHeight;
	    setTimeout("ShowLoadingBox()", 100);
	}
	
	var usernameText = "<?=get_cm_var('setcfg_users_user_name')?>";
	var scodeText = "<?=get_cm_var('setcfg_users_scode')?>";
	
	var glo_isUsernamePlusScratchMode = false;
	
	</script>
<?php
    if (isset($searchUser)) { //Search user mode
        $allUserTabClass = "allUserTabInactive";
        if ($searchUser == "frmSimple") {
            //Simple search mode
            $simpleSearchTabClass = "simpleSearchTabActive";
            $simpleSearchTabHref = "#";
            $simpleSearchTabOnclick = "showSearch('frmSimple')";
            $advancedSearchTabClass = "advancedSearchTabInactive";
            $advancedSearchTabHref = "setcfg.php?category=u&searchUser=frmAdvanced";
            $advancedSearchTabOnclick = "";
            $stopOnclick = "stopSearch('frmSimple')";
        } else if ($searchUser=="frmAdvanced") {
            //Advaned search mode
            $simpleSearchTabClass = "simpleSearchTabInactive";
            $simpleSearchTabHref = "setcfg.php?category=u&searchUser=frmSimple";
            $simpleSearchTabOnclick = "";
            $advancedSearchTabClass = "advancedSearchTabActive";
            $advancedSearchTabHref = "#";
            $advancedSearchTabOnclick = "showSearch('frmAdvanced')";
            $stopOnclick = "stopSearch('frmAdvanced')";
        }
    } else {
        //All users mode
        $allUserTabClass = "allUserTabActive";
        $simpleSearchTabClass = "simpleSearchTabInactive";
        $simpleSearchTabHref = "setcfg.php?category=u&searchUser=frmSimple";
        $simpleSearchTabOnclick = "";
        $advancedSearchTabClass = "advancedSearchTabInactive";
        $advancedSearchTabHref = "setcfg.php?category=u&searchUser=frmAdvanced";
        $advancedSearchTabOnclick = "";
        $stopOnclick = "stopSearch()";
        echo "<script type='text/javascript'>onload=initSavebtn;</script>";
    }//end if isset($searchUser)
?>
<?
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setfree.php FSCONFIG.Cfgmgr Object cannot be created!');
	$max_admin_account=$settingobj->getKey( "max_admin_account", "gateway");
	$i = 0;
	$disabled_ip_text_sub1 = '';
	$disabled_ip_text_sub2 = '';
	$disabled_ip_text_sub3 = '';
	$disabled_ip_text_sub4 = '';
	$disabled_ip_text_sub5 = '';
	$disabled_ip_text_sub6 = '';
	$disabled_ip_text_sub7 = '';
	$disabled_ip_text_sub8 = '';
	$disabled_ip_text_sub9 = '';
	$onlineEditing	= false;
	
	for ($i = 0; $i < $max_admin_account; $i++) {
		$admin_username = $settingobj->getKey( "admin_username".$i, "gateway");
		if ($admin_username == $_SESSION["operator"]){
			$admin_parameter = $settingobj->getKey( "admin_parameter".$i, "gateway");
			
			if (strstr($admin_parameter, "u_dis_sub1") != false){
				$disabled_ip_text_sub1 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub2") != false){
				$disabled_ip_text_sub2 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub3") != false){
				$disabled_ip_text_sub3 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub4") != false){
				$disabled_ip_text_sub4 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub5") != false){
				$disabled_ip_text_sub5 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub6") != false){
				$disabled_ip_text_sub6 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub7") != false){
				$disabled_ip_text_sub7 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub8") != false){
				$disabled_ip_text_sub8 = 'disabled';
			}
			if (strstr($admin_parameter, "u_dis_sub9") != false){
				$disabled_ip_text_sub9 = 'disabled';
			}

			break;
		}
	}
	$onlineEditing = $settingobj->getKey( "edit_with_disconnect", "gateway");
	if($onlineEditing!='1')
		$onlineEditing	= '0';
	$settingobj=null;
?>
    <!-- loading box -->
    <div id="loadingBox" class="loadingBoxBright" style="position:absolute; z-index:100;"> 
        <div id="loadingBoxText"></div>
        <a id="btn_Stop" class="stop" onclick="<?=$stopOnclick?>">
            <?=get_cm_var('setcfg_users_stop')?>
        </a>
    </div>
    <script type="text/javascript">
        //Purpose of glo_Message is to allow javascript function to get data from php
        //to prevent too many javascript function being embeded inside php file.
        var glo_Message = new Object();
        glo_Message.setcfg_users_loading = "<?=get_cm_var('setcfg_users_loading')?>"; //string for loading box
        glo_Message.setcfg_users_deleting = "<?=get_cm_var('setcfg_users_deleting')?>"; //string for loading box
        callLoadingBox(true,true); //show loading box with stop button
    </script>
    <!-- Need to split javascript here to make loading box and the three tabs below to show up immediately -->

    <div class="userHeader">
        <a id="allUserTab" class="<?=$allUserTabClass?>" href="setcfg.php?category=u">
            <?=get_cm_var('setcfg_users_search_alluser')?></a>
        <a id="simpleSearchTab" class="<?=$simpleSearchTabClass?>" href="<?=$simpleSearchTabHref?>" onclick="<?=$simpleSearchTabOnclick?>">
            <?=get_cm_var('setcfg_users_search_simplesearch')?></a>
        <a id="advancedSearchTab" class="<?=$advancedSearchTabClass?>" href="<?=$advancedSearchTabHref?>" onclick="<?=$advancedSearchTabOnclick?>">
            <?=get_cm_var('setcfg_users_search_advancedsearch')?></a>

		<script type="text/javascript">
			glo_Message.js_alert_users_20 = "<?=get_cm_var('js_alert_users_20')?>"; //string for calladdform()
			glo_Message.js_alert_users_18 = "<?=get_cm_var('js_alert_users_18')?>"; //string for warnEditTimeLeft()
			glo_Message.js_alert_users_19 = "<?=get_cm_var('js_alert_users_19')?>"; //string for warnEditQuota()
			glo_Message.js_users_search_form_validation_error = "<?=get_cm_var('js_users_search_form_validation_error')?>"; //string for form validateion warnning
			glo_Message.setcfg_date_format = "<?=get_cm_var('setcfg_date_format')?>"; //string for date format
			glo_Message.setcfg_time_format = "<?=get_cm_var('setcfg_time_format')?>"; //string for time format
			glo_Message.js_users_search_form_validation_integer = "<?=get_cm_var('js_users_search_form_validation_integer')?>";
			glo_Message.js_users_search_form_validation_integer = "<?=get_cm_var('js_users_search_form_validation_integer')?>";
			glo_Message.js_users_search_form_validation_date = "<?=get_cm_var('js_users_search_form_validation_date')?>";
			glo_Message.js_users_search_form_validation_time = "<?=get_cm_var('js_users_search_form_validation_time')?>";
			glo_Message.setcfg_data_transfer_remind = "<?=get_cm_var('setcfg_data_transfer_remind')?>";
			glo_Message.setcfg_users_export_and_clear_userlog_confirm = "<?=get_cm_var('setcfg_users_export_and_clear_userlog_confirm')?>";
			glo_Message.setcfg_users_exportuserlog_confirm = "<?=get_cm_var('setcfg_users_exportuserlog_confirm')?>";
		</script>

		<input type="hidden" id="editDisconnect" value="<?=$onlineEditing;?>" />
<?php
    if (isset($searchUser)) { //only have 'show search' button in search user mode
?>
		<input type="button" id="btn_showSearch" value="<?=get_cm_var('setcfg_users_search_showsearch')?>" class="btn_showSearch" onclick="showSearch('<?=$searchUser?>')"/>
        
<?php
    } //end 'show search' button
?>
    </div> <!-- end userHeader -->
<?php
    if (isset($searchUser)) { //include search form in search user mode
        include("searchForm.php");
    } //end include search form in search user mode

    if (!isset($searchUser) || isset($searchFormData)) {
        /* Only show user detail during all user mode or a search is submitted */

		// 20090518 - Remove Start
		if (substr_count(strtolower($version), 'standard') > 0) {
			if (substr_count(strtolower($version),'donation') >0)
				$version = substr($version,0,strlen($version)-9);
			$disabled = ' disabled';
			$version_msg = '<span class="star">* This feature is not available in '. ucwords($version) .' Edition.</span>';
			$arrJavascriptVariable['glo_version'] = "'standard'";
			$standard_version_star = '<span class="star">* </span>';
		} else {
			$disabled = '';
			$version_msg = '';
			$standard_version_star = '';
			if (strpos(strtolower($version), 'advanced') === false) {
				$arrJavascriptVariable['glo_version'] = "'trial'";
			} else {
				$arrJavascriptVariable['glo_version'] = "'advanced'";
			}
		}

        //output version as global javascript variable
        echo "<script type=\"text/javascript\">\n";
        echo "//version of firstspot\n";
        foreach ($arrJavascriptVariable as $key=>$value) {
            echo "$key = $value;\n";
        }
        echo "</script>\n";

        gen_head();  
?>

  <tr>
    <td width="100%" colspan="5" valign="top" height="5"><img src="./images/blank.gif" border="0" width="3" height="5"></td>
  </tr>  

  <tr valign="top">

    <td width="40%">&nbsp;</td>
    <td width="220">
        <p class="captionbig">
<?php
    //Show different word above the selection box
    if (isset($searchFormData)) {
        echo $version_msg."<br>".get_cm_var('setcfg_users_search_result');
    } else {
        echo $version_msg."<br>".get_cm_var('setcfg_users_existing_users');
    }
?>

        </p>
    <span style="font-family:Tahoma;">
    <font size="2"><?=get_cm_var('setcfg_users_select')?>&nbsp;</font> 
    <a href="#" onclick="selectAllUser();"><font size="2" color="blue"><?=get_cm_var('setcfg_users_select_all')?></font></a>&nbsp;
    <a href="#" onclick="selectNoneUser();"><font size="2" color="blue"><?=get_cm_var('setcfg_users_select_none')?></font></a><br><br>
    </span>

<?php
    if(!session_id())
        session_start();

    include('users.php');
?>
    <form name="userControlForm" action="setcfg.php?category=u" method="post">
        <img src="./images/double_left.gif" vspace="0" width="14" height="8" border="0" style="cursor:pointer;cursor:hand;" onclick="changePage('first')" title="First page">&nbsp;
        <img src="./images/left.gif" vspace="0" width="8" height="8" border="0" style="cursor:pointer;cursor:hand;" onclick="changePage('previous')" title="Previous 1000">&nbsp;
        
		<select id="curr" name="currentPage"  style="text-align:top; border:0px solid #99D1A2;font-size:0.7em; color:#003300;" onChange="changePage(this.selectedIndex)">
            <option value="">
        </select>&nbsp;<EM>of</EM>&nbsp;
		<input type="text" name="sumofpage" value="" disabled style="width: 3em;text-align:top; border:0px;font-size:0.7em; color:#003300;">&nbsp;
        
		<img src="./images/right.gif" vspace="0" width="8" height="8" border="0" style="cursor:pointer;cursor:hand;" onclick="changePage('next')" title="Next 1000">&nbsp;
		<img src="./images/double_right.gif" vspace="0" width="14" height="8" border="0" style="cursor:pointer;cursor:hand;" onclick="changePage('last')" title="Last page">
        
        <input type="hidden" name="page" value="">
    </form> <!-- userControlForm -->
    <br><br>
	<span class="captionbig"><?=get_cm_var('setcfg_users_available_plans')?></span>
	<br>
    <iframe id="loadplans" name="loadplans" frameborder="0" width="170" height="300" src="loadPlans.php" marginwidth="0" marginheight="0" style="border:1px solid #99D1A2"></iframe>
    </td>
    
    <td width="10">&nbsp;</td>
   
    <td width="500" rowspan="3" valign="top">

<?php
        if (!isset($searchUser) || $searchUser=="") { //only show add button in all user mode
?>
        <input type="button" id="prepaidBtn" title="<?=get_cm_var('setcfg_users_btn_quick_add_title')?>" value="<?=get_cm_var('setcfg_users_btn_quick_add')?>" class="graphicBtn" <?=$disabled_ip_text_sub1?> onClick="callAddform('slip')" />
        <input type="button" id="addUserBtn" name="addUserBtn" title="<?=get_cm_var('setcfg_users_btn_add_title')?>" value="<?=get_cm_var('setcfg_users_btn_add')?>" class="graphicBtn" <?=$disabled_ip_text_sub2?> onClick="callAddform('normal')" />
<?php
        }
?>
        <input type='button' id='editUserBtn' value='<?=get_cm_var('setcfg_users_btn_edit')?>' title='<?=get_cm_var('setcfg_users_btn_edit_title')?>' class='graphicBtn' <?=$disabled_ip_text_sub3?> onClick='editModeSwitch(true);' />
        <input type="button" id="deleteUserBtn" value="<?=get_cm_var('setcfg_users_btn_delete')?>" title="<?=get_cm_var('setcfg_users_btn_delete_title');?>" class="graphicBtn" <?=$disabled_ip_text_sub4?> onClick="deleteUser()" />
        <input type="button" id="resetquotaBtn" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_reset_quota')?>" title="<?=get_cm_var('setcfg_users_btn_reset_quota')?>" onmouseenter="initDropinQuota()" onmouseover="initDropinQuota()" onmouseout="hideDropinQuota()" onmouseleave="hideDropinQuota()" <?=$disabled_ip_text_sub5?> onclick="resetQuota()" />
        <input type="button" id="refresh_btn" name="refresh_btn" value="<?=get_cm_var('setcfg_users_btn_label_refresh')?>" title="<?=get_cm_var('setcfg_users_btn_label_refresh_title')?>" class="graphicBtn" onClick="window.location='setcfg.php?category=u'" />

    <!-- Add user layer -->
    <div id="adduser" style="display:none;">
    <form name="addform"> <!-- add new user form, for both prepaid and normal user -->
	<input type="hidden" name="signupData" value="" />
    <fieldset id="testing" style="border: 1px solid #99D1A2; padding: 5px;">
      <legend class="captionbig" style="color: green; padding: 0px 10px;"><?=get_cm_var('setcfg_users_add_new_user')?></legend>
      
      <input type="hidden" name="copy_addname" value="">
      <input type="hidden" name="copy_password" value="">
      <input type="hidden" name="copy_confirmpass" value="">
      
      <input type="hidden" name="copy_add_acc_enable" value="">
      <input type="hidden" name="copy_add_acc_disable" value="">
      
      <input type="hidden" name="addMode" value=""> 
      <input type="hidden" name="save_u" value="true"> 
      <input type="hidden" name="add" value=""> 
      <input type="hidden" name="page" value="1">    
      <input type="hidden" name="noOfPage" value="1">
      <input type="hidden" name="plan_name" value=""> 
      
    <script type="text/javascript" src="./javascript/ua.js"></script>

	<input type="button" id="extraInfoBtn2" title="<?=get_cm_var('setcfg_users_btn_add_extra_info_title')?>" value="<?=get_cm_var('setcfg_users_btn_add_extra_info')?>" class="graphicBtn" onClick="popup=window.open('','win1','width=380,height=320,scrollbars ,resizable'); popup.location='c_User_ExtraInfo.php?action=add&selectedName='+document.userinfoform.selectedName.value;" />

      <table width="500" border="0" cellspacing="0" cellpadding="0">

        <tr><td colspan="2">&nbsp;</td></tr>

    <!-- Rand User -->
    <?php
    //Marco
        $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');    
	// 20081029 - Obtain login mode status
	$scratch_login = (strtolower($settingobj->getKey('scratch_login', 'gateway') == 'on'))? 'true' : 'false';
	$username_plus_scratch_login = (strtolower($settingobj->getKey('username_plus_scratch_login', 'gateway') == 'on'))? 'true' : 'false';
	
	$tmp = "";
	if ($scratch_login == 'true'){
		// overwrite
		$tmp .= "usernameText = scodeText;";
	}
	
	if ($username_plus_scratch_login == 'true'){
		// overwrite
		$tmp .= "\nglo_isUsernamePlusScratchMode = true;";
	}
	
        echo'
            <script type="text/javascript">         
            function onSelectSlipFormatOption(instance){                               
                if(instance.value==1)
                {
                    document.getElementById("slip_title").style.display="";
                    document.getElementById("slip_title_size").style.display="";
                    document.getElementById("slip_end").style.display="";
					document.getElementById("slip_end_size").style.display="";
					document.addform.slip_title.disabled = false; 
                    document.addform.slip_title_size.disabled = false; 
                    document.addform.slip_end.disabled = false; 
                    document.addform.slip_end_size.disabled = false;
                }
                else                
                {
                    document.getElementById("slip_title").style.display="none";
                    document.getElementById("slip_title_size").style.display="none";
                    document.getElementById("slip_end").style.display="none";
                    document.getElementById("slip_end_size").style.display="none";
                    document.addform.slip_title.disabled = true; 
                    document.addform.slip_title_size.disabled = true; 
                    document.addform.slip_end.disabled = true; 
                    document.addform.slip_end_size.disabled = true; 
                }
            }
            function onSelectSlipTitleSize(instance){                             
                document.addform.slip_title_size.value = instance.value;                
            }
            function onSelectSlipEndSize(instance){                           
                document.addform.slip_end_size.value = instance.value;              
            }
			'.$tmp.'
            </script>';
        $slip_format_option = $settingobj->getKey('slip_format_option', 'users');
        $slip_title = $settingobj->getKey('past_slip_title', 'users');
        $slip_title_size = $settingobj->getKey('past_slip_title_size', 'users');
        $slip_end = $settingobj->getKey('past_slip_end', 'users');
        $slip_end_size = $settingobj->getKey('past_slip_end_size', 'users');
            
        $selectOption=array("", "");
        $selectOption[$slip_format_option] = "selected";
        $defaultSlip = 'none';
        
        if ($slip_format_option > 0)
            $defaultSlip="";            
        
        //create slip_format_option listbox
        $input='<select name="slip_format_option" style="width:180px; font-family: sans-serif, Tahoma; font-size:9pt;" onChange=onSelectSlipFormatOption(this)>
            <option value=0 '.$selectOption[0].'>Default</option>
            <option value=1 '.$selectOption[1].'>New</option>           
            </select>'; 
        ?>
        <tr id="slip_format" style="">
            <td width="400"><p class="captionbig"><?=get_cm_var('setcfg_users_slip_format')?></td>      
            <td width="300" class="normal"><?=$input?></td>
        </tr>
        <?php       
        //create slip_title textbox
        $input = '<input class="longtextbox" type="text" name="slip_title" value="'.$slip_title.'" style="width : 180px"><a name="offset"></a>';
        
        ?>
        <tr id="slip_title" style="display: <?=$defaultSlip?>">
            <td width="400"><p class="captionbig"><?=get_cm_var('setcfg_users_slip_title')?></td>       
            <td width="300" class="normal"><?=$input?></td>
        </tr>
        <?php       
        //create slip_title textbox
        $select=array("", "", "", "");
        $select[$slip_title_size] = "selected";     
        $input='<select name="slip_title_size" style="width:180px; font-family: sans-serif, Tahoma; font-size:9pt;" onChange=onSelectSlipTitleSize(this)>
            <option value=0 '.$select[0].'>Default</option>
            <option value=1 '.$select[1].'>2</option>
            <option value=2 '.$select[2].'>4</option>
            <option value=3 '.$select[3].'>6</option>           
            </select>'; 
        ?>
        <tr id="slip_title_size" style="display: <?=$defaultSlip?>">
            <td width="400"><p class="captionbig"><?=get_cm_var('setcfg_users_slip_title_size')?></td>      
            <td width="300" class="normal"><?=$input?></td>
        </tr>
        <?php
        //create slip_end textbox
        $input = '<input class="longtextbox" type="text" name="slip_end" value="'.$slip_end.'" style="width : 180px"><a name="offset"></a>';
        ?>
        <tr id="slip_end" style="display: <?=$defaultSlip?>">
            <td width="400"><p class="captionbig"><?=get_cm_var('setcfg_users_slip_end')?></td>
            <td width="300" class="normal"><?=$input?></td>
        </tr>
        <?php
        //create slip_end textbox
        $select=array("", "", "", "");
        $select[$slip_end_size] = "selected";
        $input='<select name="slip_end_size" style="width:180px; font-family: sans-serif, Tahoma; font-size:9pt;" onChange=onSelectSlipEndSize(this)>
            <option value=0 '.$select[0].'>Default</option>
            <option value=1 '.$select[1].'>2</option>
            <option value=2 '.$select[2].'>4</option>
            <option value=3 '.$select[3].'>6</option>           
            </select>'; 
        ?>
        <tr id="slip_end_size" style="display: <?=$defaultSlip?>">
            <td width="400"><p class="captionbig"><?=get_cm_var('setcfg_users_slip_end_size')?></td>
            <td width="300" class="normal"><?=$input?></td>
        </tr>
        
        <tr valign="top" style="display: none;" id="randUserOption">
          <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_random_user_name')?><br /></td>
          <td valign="top" class="captionbig">
            <input type="radio" name="randUser" value="true" onclick="select_isRandomUser()" checked><b><?=get_cm_var('setcfg_users_random_user_y')?></b>&nbsp;&nbsp;
            <input type="radio" name="randUser" value="false" onclick="select_isRandomUser()"><b><?=get_cm_var('setcfg_users_random_user_n')?></b><br />
          </td>
        </tr>      
        
        <tr id="row_usrname">
<?
	// 20081029 - Handling for Scratch Code mode
	if ($scratch_login == 'true') {
?>
          <td class="captionbig"><div id="usertitleText"><?=get_cm_var('setcfg_users_scode')?></div></td>
<?
	} else {
?>
          <td class="captionbig"><div id="usertitleText"><?=get_cm_var('setcfg_users_user_name')?></div></td>
<?
	}
?>
  
          <td class="captionbig">
				<!--Normal username-->
              <div id="usr_name"><input type="text" name="addname" value="" onKeyPress="return noSpecialCharacters(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;"></div>
              <!-- Scratch Code -->
			  <div id="usr_scratch_code" style="display: none;"><input type="text" name="addscratchcode" value="" onKeyPress="return noSpecialCharacters(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" <?=$disabled?>></div>
              <!--Mac as username-->
              <div id="usr_mac" style="display: none;">
                <input class="IPtextbox" type="text" name="userMACaddr1" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr2')" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>-
                <input class="IPtextbox" type="text" name="userMACaddr2" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr3')" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>-
                <input class="IPtextbox" type="text" name="userMACaddr3" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr4')" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>-
                <input class="IPtextbox" type="text" name="userMACaddr4" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr5')" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>-
                <input class="IPtextbox" type="text" name="userMACaddr5" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr6')" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>-
                <input class="IPtextbox" type="text" name="userMACaddr6" maxlength="2" onKeyPress="return hexnumbersonly(this,event)" onChange="this.value=this.value.toUpperCase()" style="width:25px" <?=$disabled?>>
              </div>
              <!--IP as username-->
              <div id="usr_ip" style="display: none;">
                <input class="IPtextbox" type="text" name="userIPaddr1" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr2')" onChange="this.value=this.value.toUpperCase()" style="width:30px" <?=$disabled?>>.
                <input class="IPtextbox" type="text" name="userIPaddr2" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr3')" onChange="this.value=this.value.toUpperCase()" style="width:30px" <?=$disabled?>>.
                <input class="IPtextbox" type="text" name="userIPaddr3" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr4')" onChange="this.value=this.value.toUpperCase()" style="width:30px" <?=$disabled?>>.
                <input class="IPtextbox" type="text" name="userIPaddr4" maxlength="3" onKeyPress="return numbersonly(this,event)" onChange="this.value=this.value.toUpperCase()" style="width:30px" <?=$disabled?>><br>
              </div>
              <br>
          </td>
          
<?
	if ($username_plus_scratch_login == 'true') {

?>		
        <!--username Type-->
        <tr valign="top" id="row_usermac">
	        <td class="captionbig"><?=get_cm_var('setcfg_users_user_name_type')?></td>
	        <td class="captionbig">
	        	<table border="0" cellspacing=0 cellpadding=0 style="border-collapse:collapse; border:none;">
					<tr>
	        			<td width = "60%" class="greenCellLT">	        			
	        			&nbsp;<input type="radio" name="add_name_mode" value="0" onClick="addNameMode('0');" <?=$disabled?>><span class = "captionbig"><?=get_cm_var('setcfg_users_use_normal_ex')?></span><br/>
	        			&nbsp;<input type="radio" name="add_name_mode" value="3" onClick="addNameMode('3');" <?=$disabled?>><span class = "captionbig"><?=get_cm_var('setcfg_users_use_scratch')?></span>
	        			</td>
	        			<td class="greenCellTRB">
							<div>&nbsp;<input disabled type="checkbox" name="multiple_login" value="on" onClick="select_multiple()"><?=get_cm_var('setcfg_users_multiple_login')?>&nbsp;</div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_max_limit')?>&nbsp;<input class="moreshorttextbox" type="text" name="multiple_login_max_limit" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled></div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_warn')?></div>
						</td>
	        		</tr>
	        		<tr>
	        			<td width = "60%" class="greenCell" rowspan=3>	        			
	        			&nbsp;<input type="radio" name="add_name_mode" value="1" onClick="addNameMode('1');" <?=$disabled?>><span class = "captionbig"><?=$standard_version_star.get_cm_var('setcfg_users_use_mac')?></span><br>&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_macip_warn')?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_mac_warn')?><br>
	        			&nbsp;<input type="radio" name="add_name_mode" value="2" onClick="addNameMode('2');" <?=$disabled?>><span class = "captionbig"><?=$standard_version_star.get_cm_var('setcfg_users_use_ip')?></span><br>&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_macip_warn')?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_ip_warn')?>
	        			</td>
	        			<td class="greenCellL">&nbsp;</td>
	        		</tr>
	        		<tr><td class="greenCellLTB_w">&nbsp;<input disabled type="checkbox" name="passive_login" value="on" onClick="select_passive()"><?=get_cm_var('setcfg_users_passive_login')?></td></tr>
	        		<tr ><td class="greenCellL">&nbsp;</td></tr>
		          </table>
		          <br>
	        </td>
        </tr>
        
        <tr valign="top" id="row_usrpwd">
			<input type="hidden" name="scratch_mode" value="0">
			<input type="hidden" name="username_plus_scratch_mode" value="1">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td class="captionbig"><input type="password" name="password" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onKeyPress="return noSpecialCharacters(this,event)"></td>       
        </tr>
        <tr valign="top" id="row_confirmpass">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td class="captionbig"><input type="password" name="confirmpass" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onKeyPress="return noSpecialCharacters(this,event)"></td>   
        </tr>
<?

	}
	// 20090814 - Hide type and password fields under Scratch Code mode
	// 20081029 - Handling for Scratch Code mode
	else if ($scratch_login == 'true') {

?>
		<tr valign="top" id="row_usermac">
	        <td class="captionbig"><?=get_cm_var('setcfg_users_user_name_type')?></td>
	        <td class="captionbig">
				<table border="0" cellspacing=0 cellpadding=0 style="border-collapse:collapse; border:none;">
					<tr>
	        			<td width = "60%" class="greenCellLTB">
	        			&nbsp;<input type="radio" <?=$disabled?> checked="true"><span class = "captionbig"><?=get_cm_var('setcfg_users_use_scratch')?>
	        			</td>
						
	        			<td width="40%" class="greenCellTRB" >
							<div>&nbsp;<input disabled type="checkbox" name="multiple_login" value="on" onClick="updateMultipleLogin(this)"><?=get_cm_var('setcfg_users_multiple_login')?>&nbsp;</div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_max_limit')?>&nbsp;<input class="moreshorttextbox" type="text" name="multiple_login_max_limit" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled></div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_warn')?></div>
						</td>
	        		</tr>
		          </table>
				<input type="radio" name="add_name_mode" value="0" style="display:none">
				<input type="radio" name="add_name_mode" value="3" style="display:none">
	        	<input type="radio" name="add_name_mode" value="1" disabled style="display:none">
				<input type="radio" name="add_name_mode" value="2" disabled style="display:none">
				<input type="checkbox" name="passive_login" style="display:none">
				<br>
	        </td>
        </tr>
		<div id="row_usrpwd">
			<input type="hidden" name="scratch_mode" value="1">
			<input type="hidden" name="username_plus_scratch_mode" value="0">
			<input type="hidden" name="password" value="">
		</div>
		<div id="row_confirmpass">
			<input type="hidden" name="confirmpass" value="">
		</div>
<?

	} else {

?>
        <!--username Type-->
        <tr valign="top" id="row_usermac">
	        <td class="captionbig"><?=get_cm_var('setcfg_users_user_name_type')?></td>
	        <td class="captionbig">
				<table border="0" cellspacing=0 cellpadding=0 style="border-collapse:collapse; border:none;">
					<tr>
	        			<td width = "60%" class="greenCellLT">	        			
	        			&nbsp;<input type="radio" name="add_name_mode" value="0" onClick="addNameMode('0');" <?=$disabled?>><span class = "captionbig"><?=get_cm_var('setcfg_users_use_normal_ex')?></span><br/>
						<input type="radio" name="add_name_mode" value="3" disabled style="display:none">
	        			</td>
	        			<td class="greenCellTRB">
							<div>&nbsp;<input disabled type="checkbox" name="multiple_login" value="on" onClick="select_multiple()"><?=get_cm_var('setcfg_users_multiple_login')?>&nbsp;</div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_max_limit')?>&nbsp;<input class="moreshorttextbox" type="text" name="multiple_login_max_limit" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled></div>
							<div align="center"><?=get_cm_var('setcfg_users_multiple_login_warn')?></div>
						</td>
	        		</tr>
	        		<tr>
	        			<td width = "60%" class="greenCell" rowspan=3>	        			
	        			&nbsp;<input type="radio" name="add_name_mode" value="1" onClick="addNameMode('1');" <?=$disabled?>><span class = "captionbig"><?=$standard_version_star.get_cm_var('setcfg_users_use_mac')?></span><br>&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_macip_warn')?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_mac_warn')?><br>
	        			&nbsp;<input type="radio" name="add_name_mode" value="2" onClick="addNameMode('2');" <?=$disabled?>><span class = "captionbig"><?=$standard_version_star.get_cm_var('setcfg_users_use_ip')?></span><br>&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_macip_warn')?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_use_ip_warn')?>
	        			</td>
	        			<td class="greenCellL">&nbsp;</td>
	        		</tr>
	        		<tr><td class="greenCellLTB_w">&nbsp;<input disabled type="checkbox" name="passive_login" value="on" onClick="select_passive()"><?=get_cm_var('setcfg_users_passive_login')?></td></tr>
	        		<tr ><td class="greenCellL">&nbsp;</td></tr>
		          </table>
				<input type="radio" name="add_name_mode" value="3" style="display:none">
		        <br>
	        </td>
        </tr>
        
        <tr valign="top" id="row_usrpwd">
			<input type="hidden" name="scratch_mode" value="0">
			<input type="hidden" name="username_plus_scratch_mode" value="0">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td class="captionbig"><input type="password" name="password" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onKeyPress="return noSpecialCharacters(this,event)"></td>       
        </tr>
        <tr valign="top" id="row_confirmpass">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td class="captionbig"><input type="password" name="confirmpass" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onKeyPress="return noSpecialCharacters(this,event)"></td>   
        </tr>
<?

	}

?>

        <tr><td colspan="2">&nbsp;</td></tr>

        <tr valign="top">
          <td class="captionbig"><?=get_cm_var('setcfg_users_account_status')?></td>
          <td class="captionbig">
            <input type="radio" name="add_acc_enable" value="0" onClick="addaccparam('0')" checked><?=get_cm_var('setcfg_users_account_status_enabled')?><br>
            <input type="radio" name="add_acc_disable" value="1" onClick="addaccparam('1')"><?=get_cm_var('setcfg_users_account_status_disabled')?>
          </td>
        </tr>
    
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr valign="top">
          <td class="captionbig"><?=get_cm_var('setcfg_users_activate_account')?></td>
          <td class="captionbig">
            <input type="radio" name="bt_acc" value="0" onClick="addActivateAcc('0')" checked><?=get_cm_var('setcfg_users_account_is_created')?><br />
            <input type="radio" name="bt_acc" value="1" onClick="addActivateAcc('1')"><?=get_cm_var('setcfg_users_first_login')?><br />
            <input type="radio" name="bt_acc" value="2" onClick="addActivateAcc('2')"><?=get_cm_var('setcfg_users_date')?>
            <input class="shorttextbox format-m-d-y divider-dash highlight-days-12" type="text" name="add_act_date" maxlength="10" value="" style="width:100px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300" disabled>
            <input class="timetextbox" type="text" name="add_act_time" maxlength="5" value="" disabled><br />
            <?=get_cm_var('setcfg_recur_name')?>&nbsp;
            <input type="radio" name="recur_option" value="1" onClick="recur_disabled(this)"><?=get_cm_var('setcfg_recur_option_on')?>&nbsp;
            <input type="radio" name="recur_option" value="0" onClick="recur_disabled(this)" checked><?=get_cm_var('setcfg_recur_option_off')?>&nbsp;<br />
            <tr id="schedule" style="display: none">
              <td class="captionbig"></td>
              <td class="captionbig">
                <input type="checkbox" name="cb_mon" value="2"><?=get_cm_var('setcfg_mon')?>&nbsp;
                <input type="checkbox" name="cb_tue" value="4"><?=get_cm_var('setcfg_tue')?>&nbsp;
                <input type="checkbox" name="cb_wed" value="8"><?=get_cm_var('setcfg_wed')?>&nbsp;
                <input type="checkbox" name="cb_thr" value="16"><?=get_cm_var('setcfg_thr')?>&nbsp;<br>
                <input type="checkbox" name="cb_fri" value="32"><?=get_cm_var('setcfg_fri')?>&nbsp;
                <input type="checkbox" name="cb_sat" value="64"><?=get_cm_var('setcfg_sat')?>&nbsp;
                <input type="checkbox" name="cb_sun" value="1"><?=get_cm_var('setcfg_sun')?>&nbsp;<br>
                <?=get_cm_var('setcfg_recur_start_end_time')?>&nbsp;<br />
                <?=get_cm_var('setcfg_recur_time_format')?>&nbsp;<br>
                <input class="shorttextbox" type="text" name="recur_stime" maxlength="5" value"" style="width:65px"> -
                <input class="shorttextbox" type="text" name="recur_etime" maxlength="5" value"" style="width:65px">
              </td>
            </tr>
          </td>
        </tr>
        
        <!-- Reset option -->
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr>
            <td class="captionbig">
                <?=get_cm_var('setcfg_resetopt_enabled')?>
            </td>
            <td class="captionbig">
                <input type="radio" name="reset_opt" value="y" disabled />
                <?=get_cm_var('setcfg_resetopt_yes')?>
                <input type="radio" name="reset_opt" value="n" disabled checked />
                <?=get_cm_var('setcfg_resetopt_no')?>
            </td>
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>
        <tr valign="top">
          <td id="ua_expireAcc" class="captionbig"><?=get_cm_var('setcfg_users_expire_account')?></td>
          <td class="captionbig">
            <input type="checkbox" name="cb_acc0" value="0" onClick="addExpireAcc('0')" checked><?=get_cm_var('setcfg_users_never')?><br>
            <input type="checkbox" name="cb_acc1" id="cb_acc1" value="1" onClick="addExpireAcc('1')"><span id="cb_acc1_text"><?=get_cm_var('setcfg_users_timeleft')?><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_timeleft2')?>&nbsp; </span>
            <input class="shorttextbox" type="text" name="add_timeleft" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled><br>
            <input type="checkbox" name="cb_acc2" id="cb_acc2" value="2" onClick="addExpireAcc('2')"><span id="cb_acc2_text"><?=get_cm_var('setcfg_users_login')?></span>&nbsp;
            <input class="shorttextbox" type="text" name="add_login" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled><br>
            <input type="checkbox" name="cb_acc3" value="3" onClick="addExpireAcc('3')"><?=get_cm_var('setcfg_users_on_date')?>&nbsp;
            <input class="shorttextbox" type="text" name="add_exp_date" maxlength="10" value="" style="width:100px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300" disabled>&nbsp;
            <input class="timetextbox" type="text" name="add_exp_time" maxlength="5" value="" disabled><br>
            <input type="checkbox" name="cb_acc4" value="4" onClick="addExpireAcc('4')"><span id="cb_acc4_text"><?=get_cm_var('setcfg_users_minutes')?></span>&nbsp;
            <input class="shorttextbox" type="text" name="add_days" maxlength="8" value="" onKeyPress="return numbersonly(this,event)" disabled>&nbsp;
            <select NAME="select_add_timeleft">
                <option VALUE="min">Minute(s)
                <option VALUE="hour">Hour(s)
                <option VALUE="day">Day(s)
            </select>
			<br>
			<input type="checkbox" name="cb_acc5" value="5" onClick="addExpireAcc('5')"><?=get_cm_var('setcfg_expire_month_text')?>&nbsp;
            <select NAME="select_add_expire_month">
			<?
				for($i = 1; $i<=12; $i++){
					echo '<option VALUE="'.$i.'">'.get_cm_var("setcfg_expire_month_val".$i);
				}
			?>
            </select>
			<input class="timetextbox" type="text" name="add_expire_year" maxlength="4" value="" onKeyPress="return numbersonly(this,event)" disabled><?=get_cm_var('setcfg_expire_month_text2')?>&nbsp;
          </td>
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>

        <tr valign="top">
            <td width="35%" valign="top" class="captionbig"><?echo $standard_version_star;?><?=get_cm_var('setcfg_users_bt')?></td>
            <td width="65%" class="captionbig">
            <input type="radio" name="add_bt_mode" value="0" onClick="addrbtn('0');" <?=$disabled?>><?=get_cm_var('setcfg_users_no_throttling')?><br>
            <input type="radio" name="add_bt_mode" value="1" onClick="addrbtn('1');" <?=$disabled?>><?=get_cm_var('setcfg_users_low')?> (~<?=$bt_num_low?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="2" onClick="addrbtn('2');" <?=$disabled?>><?=get_cm_var('setcfg_users_medium')?> (~<?=$bt_num_medium?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="3" onClick="addrbtn('3');" <?=$disabled?>><?=get_cm_var('setcfg_users_high')?> (~<?=$bt_num_high?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="4" onClick="addrbtn('4');" checked <?=$disabled?>><?=get_cm_var('setcfg_users_use_global_setting')?><br>
            <input class="textbox" type="radio" name="add_bt_mode" value="5" onClick="addrbtn('5');" <?=$disabled?>><?=get_cm_var('setcfg_users_upload')?> <br>
            <input type="text" name="user_bt_num_add" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" <?=$disabled?>><br>&nbsp;<?=get_cm_var('setcfg_users_download')?> <br>
            <input type="text" name="user_bt_num_add_dl" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" <?=$disabled?>><br></td>
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>

        <?php /***************************************** UPLOAD REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">UPLOAD</td></tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
            <td valign="top" class="captionbig">
            <input type="radio" name="bwcountUL" value="-1" onClick="addBwparamUL('-1')"><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="bwcountUL" value="0" onClick="addBwparamUL('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcountUL" value="1" onClick="addBwparamUL('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcountUL" value="2" onClick="addBwparamUL('2')" ><font id="ua_bwcountUL_color"><?=$standard_version_star?><span id="bwcountUL_text4"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input type="text" name="bwquotaUL" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>

        <?php /***************************************** DOWNLOAD REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">DOWNLOAD</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">
            <input type="radio" name="bwcount" value="-1" onClick="addBwparam('-1')"><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="bwcount" value="0" onClick="addBwparam('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcount" value="1" onClick="addBwparam('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcount" value="2" onClick="addBwparam('2')" ><font id="ua_bwcount_color"><?=$standard_version_star?><span id="bwcount_text4"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
                <input type="text" name="bwquota" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>
		
		
        <?php /***************************************** TOTAL REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">TOTAL</td></tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
            <td valign="top" class="captionbig">
            <input type="radio" name="bwcountSHA" value="0" onClick="addBwparamSHA('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcountSHA" value="1" onClick="addBwparamSHA('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcountSHA" value="2" onClick="addBwparamSHA('2')" ><font id="ua_bwcountSHA_color"><?=$standard_version_star?><span id="bwcountSHA_text3"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input type="text" name="bwquotaSHA" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>		
		
		
		

        <tr valign="top">
            <td valign="top" id="add_usr_abw_rm_col_1" class="captionbig"><?=get_cm_var('setcfg_users_acc_bandwidth_reset_param')?></td>
            <td valign="top" id="add_usr_abw_rm_col_2" class="captionbig">
                <input type="radio" name="add_usr_abw_rm" id="add_usr_abw_rm[0]" value="0" onclick="add_usr_abw_disable_all()"><?=get_cm_var('setcfg_users_quota_disable')?>
                <input type="radio" name="add_usr_abw_rm" id="add_usr_abw_rm[1]" value="1" onclick="add_usr_abw_enable_textbox()"><?=get_cm_var('setcfg_users_monthly')?>
                <input type="radio" name="add_usr_abw_rm" id="add_usr_abw_rm[2]" value="2" onclick="add_usr_abw_disable_textbox()"><?=get_cm_var('setcfg_users_daily')?><br>
                <input type="radio" name="add_usr_abw_rm" id="add_usr_abw_rm[3]" value="3" onclick="add_usr_abw_disable_all()" checked><?=get_cm_var('setcfg_users_quota_use_global_setting')?></td>
        </tr>
<?php
        $add_usr_resetabw_monthly_default = 'none';
        $add_usr_resetabw_daily_default = 'none';
        $add_usr_resetabw_lastrbw_default = 'none';
    
		    $timeArray_date = '';
		    $timeArray_time = '';

        $input = get_cm_var('setcfg_users_resetabw_monthly_str1').
            '<input type="text" name="add_usr_abw_rdate" id="add_usr_abw_rdate" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_users_resetabw_monthly_str2').
            '<input type="text" name="add_usr_abw_rp_1" id="add_usr_abw_rp_1" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_users_resetabw_monthly_str3');
			
		$input = '<span id="add_usr_abw_col_2">'.$input.'</span>';

        gen_invisible_line3('<span id="add_usr_abw_col_1">'.get_cm_var('setcfg_users_resetabw_title').'</span>',$input,'add_usr_resetabw_monthly',$add_usr_resetabw_monthly_default);

        $input = get_cm_var('setcfg_users_resetabw_daily_str1').
            '<input type="text" name="add_usr_abw_rp_2" id="add_usr_abw_rp_2" maxlength="3" value="" class="shorttextbox" style="width:30px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_users_resetabw_daily_str2');
			
		$input = '<span id="add_usr_abw_col_4">'.$input.'</span>';

        gen_invisible_line3('<span id="add_usr_abw_col_3">'.get_cm_var('setcfg_users_resetabw_title').'</span>',$input,'add_usr_resetabw_daily',$add_usr_resetabw_daily_default);
        
        //User Set last period of time (Reset ABW)    (Add)
		    $input = '('.get_cm_var('setcfg_date_format').')&nbsp;('.get_cm_var('setcfg_time_format').')<br>&nbsp;<input type="text" maxlength="10" name="add_usr_resetabw_lastrbw_date" id="add_usr_resetabw_lastrbw_date" value="'.$timeArray_date.'" class="shorttextbox" style="width:85px;"  onfocus="this.select()"> &nbsp;&nbsp;'.
		            '<input type="text" maxlength="5" name="add_usr_resetabw_lastrbw_time" id="add_usr_resetabw_lastrbw_time" value="'.$timeArray_time.'" class="timetextbox" style="width:45px;" onfocus="this.select()">';
					
			$input = '<span id="add_usr_resetabw_lastrbw_time_col_2">'.$input.'</span>';
			
		    gen_invisible_line3('<span id="add_usr_resetabw_lastrbw_time_col_1">'.get_cm_var('setcfg_dispatcher_resetabw_title2').'</span>',$input,'add_usr_resetabw_lastrbw',$add_usr_resetabw_lastrbw_default);
		    
?>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_users_acl')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="acl" value="y" disabled checked />
            <?=get_cm_var('setcfg_users_acl_y')?>
            <input type="radio" name="acl" value="n" disabled />
            <?=get_cm_var('setcfg_users_acl_n')?>
        </td>
    </tr>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="rsu_col_1" class="captionbig">
            <?=get_cm_var('setcfg_users_rsu')?>
        </td>
        <td id="rsu_col_2" class="captionbig">
            <input type="radio" name="rsu" id="rsu[0]" value="y" disabled />
            <?=get_cm_var('setcfg_users_rsu_y')?>
            <input type="radio" name="rsu" id="rsu[1]" value="n" disabled checked />
            <?=get_cm_var('setcfg_users_rsu_n')?>
        </td>
    </tr>
    <!-- MAC mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="mac_map_col_1" class="captionbig">
            <?=get_cm_var('setcfg_mac_map_enabled')?>
        </td>
        <td id="mac_map_col_2" class="captionbig">
			<div id="mac_map_c2_yes">
				<input type="radio" name="mac_map" id="mac_map[0]" value="1" onclick="lcpwDisablingA(this.value)" disabled />
				<?=get_cm_var('setcfg_mac_map_yes')?>
			</div>
			<div id="mac_map_c2_no">
				<input type="radio" name="mac_map" id="mac_map[1]" value="0" onclick="lcpwDisablingA(this.value)" disabled checked />
				<?=get_cm_var('setcfg_mac_map_no')?><br>
			</div>
			<div id="mac_map_c2_once">
				<input type="radio" name="mac_map" id="mac_map[2]" value="2" onclick="lcpwDisablingA(this.value)" disabled />
				<?=get_cm_var('setcfg_mac_map_passive')?>
			</div>
        </td>
    </tr>
    <!-- IP mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_ip_map_enabled')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="ip_map" value="y" disabled />
            <?=get_cm_var('setcfg_ip_map_yes')?>
            <input type="radio" name="ip_map" value="n" disabled checked />
            <?=get_cm_var('setcfg_ip_map_no')?>
        </td>
    </tr>
    <!-- Port Filtering Rules Set -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_user_port_filtering_apply')?>
        </td>
        <td class="captionbig">
<?php
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setfree.php FSCONFIG.Cfgmgr Object cannot be created!');
    $setNum = $settingobj->getKey('user_pf_size', 'UserPortFilter');
    $setData = $comma = '';
    for ($i = 1; $i <= $setNum; $i++) {
    	$key = $settingobj->getKey("flt_num{$i}_name", 'UserPortFilter');
    	$setData .= $comma . htmlspecialchars($key);
    	$comma = '`';
    }
?>
        	<input type="hidden" name="portflt_set" value="<?=$setData?>" />
        	<input type="text" name="portflt" value="" disabled />
        </td>
    </tr>
	<!-- login segment-->
<?php
			$add_usr_login_segment_default = '';
			
			$local_ip = $settingobj->getKey('gateway_IP', 'gateway');
			$local_mask = $settingobj->getKey('subnet_mask', 'gateway');
			$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

			$tmp_num = '0'.trim($num_return_path);
			$num = (int)$tmp_num;

			$arr_opt = array();
			$return_path = array();
			$i = 0;
			while ($i < $num) {
				$return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
				$strarray = explode(' ', trim($return_path[$i]));
				$arr_opt[$i] = ($i+1).': '.$lang['setcfg_multi_net_seg_router_IP'].'='.$strarray[0].', '.$lang['setcfg_multi_net_seg_subnet_mask'].'='.$strarray[1];
				$i++;
			}
			
			$subInput = '';
			$subInput  .= '<option VALUE="-1">'.$lang['setcfg_segment_map_login_segment_opt'];
			$subInput  .= '<option VALUE="0">'.$lang['setcfg_segment_map_login_segment_opt0']." (".$lang['setcfg_segment_map_login_segment_opt0_text1'].'='.$local_ip.', '.$lang['setcfg_segment_map_login_segment_opt0_text2'].'='.$local_mask.")";;
			$j = 0;
			
			while ($j < 20) { // hard code limit 
				if  ($j < $num)
					$subInput  .= "<option VALUE=\"".($j+1)."\">$arr_opt[$j]";
				else
					$subInput  .= "<option VALUE=\"".($j+1)."\">".($j+1).": ";
				$j++;
			}
			
		    $input = '<select NAME="select_add_login_segment" disabled>'.$subInput.'</select>';
		    gen_invisible_line3(get_cm_var('setcfg_segment_map_login_segment_title'),$input,'add_usr_login_segment',$add_usr_login_segment_default);
        
?>
    <!-- Free Access User -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="faflag_col_1" class="captionbig">
            <?=get_cm_var('setcfg_free_access_user')?>
        </td>
        <td id="faflag_col_2" class="captionbig">
        	<input type="radio" name="faflag" id="faflag[0]" value="1" disabled /> <?=get_cm_var('setcfg_free_access_user_yes')?> <input type="radio" name="faflag" id="faflag[1]" value="0" disabled checked="checked" /> <?=get_cm_var('setcfg_free_access_user_no')?>
        </td>
    </tr>
	
	<!-- used -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="used_col_1" class="captionbig">
            <?=get_cm_var('setcfg_used')?>
        </td>
        <td id="used_col_2" class="captionbig">
            <input type="radio" name="used" id="used[0]" value="1" disabled  />
            <?=get_cm_var('setcfg_used_yes')?>
            <input type="radio" name="used" id="used[1]" value="0" disabled checked />
            <?=get_cm_var('setcfg_used_no')?>
        </td>
    </tr>

	<!--//\\ Change Password After Next Login -->
    <tr id="lcpwSpaceA"><td colspan="2">&nbsp;</td></tr>
    <tr id="logincpwRowA">
        <td id="login_cpw_col_1" class="captionbig">
            <?=get_cm_var('setcfg_login_cpw')?>
        </td>
        <td id="login_cpw_col_2" class="captionbig">
        	<input type="radio" name="login_cpw" value="1" disabled /> <?=get_cm_var('setcfg_login_cpw_yes')?>
			<input type="radio" name="login_cpw" value="0" disabled checked="checked" /> <?=get_cm_var('setcfg_login_cpw_no')?>
        </td>
    </tr>
	
    <!-- auto_del -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="autodel_col_1" class="captionbig">
            <?=get_cm_var('setcfg_auto_del_enabled')?>
        </td>
        <td id="autodel_col_2" class="captionbig">
            <input type="radio" name="autodel" id="autodel[0]" value="y" disabled checked />
            <?=get_cm_var('setcfg_auto_del_yes')?>
            <input type="radio" name="autodel" id="autodel[1]" value="n" disabled />
            <?=get_cm_var('setcfg_auto_del_no')?>
        </td>
    </tr>
    
        <tr>
            <td height="4" colspan="2"><img border="0" src="./images/blank.gif" width="4" height="4"></td>
        </tr>
        
        <div id="AddSavebtn" style="position:absolute; z-index: 100;">
        <!--
        <tr>
          <td colspan="2" align="center">
        -->
              <input type="button" name="save" class="graphicBtn" alt="Save" title="Save" value="Save" onclick="addUser()" />
              <input type="button" name="cancel" class="graphicBtn" alt="Cancel" title="Cancel" value="Cancel" onClick="cancelAdd()" />
        <!--
          </td>
        </tr>
        -->
        </div>
        <?php
        	$session_handling = $settingobj->getKey('session_handling', 'gateway');
        	//$settingobj->Release();
            $settingobj=null;
        ?>
     			<input type="hidden" name="add_session_handling" value="<?=$session_handling?>"> 
      </table>
      </fieldset>
    </form> <!-- end of addform -->
    </div>
    <!-- End add user layer -->

    <!-- Edit user layer -->
    <div id="userinfo" style="display:">
	<form name="userinfoform"> <!-- User information form for both display and editing -->
	<div id="dcUserCheck" name="dcUserCheck" style="display: none; font-weight:normal" class="captionbig">
		<br/>
		<input type="checkbox" name="editDCon" id="editDCon" onclick="onlineEdit()" />
		<label><?=get_cm_var('setcfg_disconnect_for_edit');?></label>
		<br/>
	</div>
	<input type="hidden" name="signupData" value="" />
    <fieldset style="border: 1px solid #99D1A2; padding: 5px;">
        <legend class="captionbig" style="color: green; padding: 0px 10px;"><?=get_cm_var('setcfg_users_user_info')?></legend>
        <input type="hidden" name="save_u" value="true"> 
        <input type="hidden" name="name0" id="name0" value="">
        <input type="hidden" name="timeleft0" id="timeleft0" value="">
		<input type="hidden" name="login0" id="login0">
		<input type="hidden" name="edate0" id="edate0">
		<input type="hidden" name="etime0" id="etime0">
		<input type="hidden" name="mins0" id="mins0">
		<input type="hidden" name="cmb_time0" id="cmb_time0">
		<input type="hidden" name="emonth0" id="emonth0">
		<input type="hidden" name="eyear0" id="eyear0">
		<input type="hidden" name="usr_bt_mode0" id="usr_bt_mode0" value="">
		<input type="hidden" name="usr_bt_num0" id="usr_bt_num0" value="">
		<input type="hidden" name="usr_bt_num_dl0" id="usr_bt_num_dl0" value="">
		<input type="hidden" name="bwquotaUL0" id="bwquotaUL0">
		<input type="hidden" name="bwcountUL0" id="bwcountUL0">
		<input type="hidden" name="bwquotaSHA0" id="bwquotaSHA0">
		<input type="hidden" name="bwcountSHA0" id="bwcountSHA0">
		<input type="hidden" name="bwquota0" id="bwquota0">
		<input type="hidden" name="bwcount0" id="bwcount0">
        <input type="hidden" name="plan_name" value=""> 
		
		<!--Marco-->
		<input type="button" id="extraInfoBtn" title="<?=get_cm_var('setcfg_users_btn_show_extra_info_title')?>" value="<?=get_cm_var('setcfg_users_btn_show_extra_info')?>" class="graphicBtn" onClick="popup=window.open('','win1','width=380,height=320,scrollbars ,resizable'); popup.location='c_User_ExtraInfo.php?action=view&selectedName='+document.userinfoform.selectedName.value;" style="cursor:default" />
		<input type="button" id="extraInfoBtn3" title="<?=get_cm_var('setcfg_users_btn_edit_extra_info_title')?>" style="display: none;" value="<?=get_cm_var('setcfg_users_btn_edit_extra_info')?>" class="graphicBtn" onClick="popup=window.open('','win1','width=380,height=320,scrollbars ,resizable'); popup.location='c_User_ExtraInfo.php?action=edit&selectedName='+document.userinfoform.selectedName.value;" />
		<input type="button" id="snInfoBtn" title="<?=get_cm_var('setcfg_users_btn_show_sn_info_title')?>" value="<?=get_cm_var('setcfg_users_btn_show_sn_info')?>" class="graphicBtn" onClick="popup=window.open('','win1','width=600,height=320,scrollbars ,resizable'); popup.location='c_User_SNInfo.php?action=add&selectedName='+document.userinfoform.selectedName.value;"  style="cursor:default"/>
	
		<script type="text/javascript">         
            document.getElementById('extraInfoBtn').disabled = true;
            document.getElementById('snInfoBtn').disabled = true;
		</script>
		<input type="hidden" name="selectedName" id="selectedName">
    <!-- javascript for edit user UI control -->
    <script type="text/javascript" src="./javascript/ue.js"></script>
        <input type="text" name="acc_warning" id="acc_warning" value="" style="width:450px; border:0px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:red;" readonly />
        <table width="500" border="0" cellspacing="0" cellpadding="0">
        <tr>
			<td colspan="2">
				<br>
			</td>
		</tr>
		<tr id="pmlogin_row_wrn" style="display:none">
			<td class="captionbig" colspan="2">
				<font color = "red">
				<?=get_cm_var('setcfg_users_pmlogin_warning_0')?><br/>
				<?=get_cm_var('setcfg_users_pmlogin_warning_1')?><br/>
				<?=get_cm_var('setcfg_users_pmlogin_warning_2')?><br/>
				<?=get_cm_var('setcfg_users_pmlogin_warning_3')?><br/>
				&nbsp;</font>
			</td>
		</tr>
        <tr>
<?
	if ($scratch_login == 'true') {
?>
          <td width="35%" class="captionbig"><div id="e_usertitleText"><?=get_cm_var('setcfg_users_scode')?></div></td>
<?
	} else {
?>
          <td width="35%" class="captionbig"><div id="e_usertitleText"><?php gen_search_feature(get_cm_var('setcfg_users_user_name'));?></div></td>
<?
	}
?>
			<td width="65%"><input type="text" name="name1" value="" readonly style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;">&nbsp;&nbsp;<span id="e_userWarn" class = "normal" style="display:none;"><?=get_cm_var('setcfg_users_v6_style_sc_warn')?></span></td>
		</tr>
		<tr id="passive" style="display:none;">
			<td width="35%">&nbsp;</td>
			<td width="65%" class="captionbig">
				<input type="checkbox" name="chg_passive_login" value="on" onClick="edit_passive()" disabled><?=get_cm_var('setcfg_users_passive_login')?>
				<input type="hidden" name="orignal_mode" value="">
			</td>
		</tr>
<?

	if ($username_plus_scratch_login == 'true') {
		?>
		<tr id="chpwRow" valign="top" style="display:none;">
			<input type="hidden" name="scratch_mode" value="0">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td><input type="password" name="chgpassword" id="chgpassword" value="     " class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onfocus="this.select()"></td>
        </tr>
        <tr id="cfpwRow" valign="top" style="display:none;">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td><input type="password" name="chgconfirmpass" id="chgconfirmpass" value="     " class="passwordbox" style="width:150px; font-weight: bold; color:#003300;" onfocus="this.select()"></td>
        </tr>
		<?
	}
	// 20090814 - Hide password fields under Scratch Code mode
	else if ($scratch_login == 'true') {

?>
		<div id="chpwRow">
			<input type="hidden" name="scratch_mode" value="1">
			<input type="hidden" name="chgpassword" id="chgpassword" value="     ">
		</div>
        <div id="cfpwRow">
			<input type="hidden" name="chgconfirmpass" id="chgconfirmpass" value="     ">
		</div>
<?

	} else {

?>
        <tr id="chpwRow" valign="top" style="display:none;">
			<input type="hidden" name="scratch_mode" value="0">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td><input type="password" name="chgpassword" id="chgpassword" value="     " class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onfocus="this.select()"></td>
        </tr>
        <tr id="cfpwRow" valign="top" style="display:none;">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td><input type="password" name="chgconfirmpass" id="chgconfirmpass" value="     " class="passwordbox" style="width:150px; font-weight: bold; color:#003300;" onfocus="this.select()"></td>
        </tr>
<?

	}

?>		
		<tr><td colspan="2"><br></td></tr>
        <tr valign="top">
			<td class="captionbig"><?php gen_search_feature(get_cm_var('setcfg_users_multiple_login'));?></td>
			<td class="captionbig">
				<input disabled type="checkbox" name="multiple_login" value="on" onClick="edit_multiple(false)">&nbsp;<?=get_cm_var('setcfg_users_multiple_login_max_limit')?>&nbsp;<input class="shorttextbox" type="text" name="multiple_login_max_limit" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled><br/>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_multiple_login_warn')?>
			</td>
        </tr>
		<?//\\ 20121113 >>> 000 - Display Child Account of Passive Multiple Login User?>
		<tr id="pmlogin_space" style="display:none"><td colspan="2"><br></td></tr>
		<tr id="pmlogin_row" style="display:none">
			<td class="captionbig">
				<?=get_cm_var('setcfg_users_pmlogin')?><br/>
			</td>
			<td class="captionbig">
				<select disabled style="width:80%" multiple size="5" name="pmuserList">
					<option></option>
				</select><br/>
				<input disabled type="button" id="delPMChild" class="graphicBtn" onClick="deleteMPLUser(false)" value="<?=get_cm_var('setcfg_users_pmlogin_delchild');?>"/>
				<input disabled type="button" class="graphicBtn" onClick="deleteMPLUser(true)" value="<?=get_cm_var('setcfg_users_pmlogin_delall');?>"/>
				<?//<input type="hidden" name="deleteString" value=""/>?>
			</td>
		</tr>
        <tr><td colspan="2"><br></td></tr>
        <tr valign="top"><td class="captionbig"><?php gen_search_feature(get_cm_var('setcfg_users_account_status'));?></td>
          <td class="captionbig">
            <input type="radio" name="acc_enable" value="0" onClick="accparam('0')" disabled><?=get_cm_var('setcfg_users_account_status_enabled')?><br>
            <input type="radio" name="acc_disable" value="1" onClick="accparam('1')" disabled><?=get_cm_var('setcfg_users_account_status_disabled')?><br>
          </td>
        </tr>

        <tr valign="top">
            <td class="captionbig"><?php gen_search_feature(get_cm_var('setcfg_users_status'));?></td>
            <td><input type="text" id="status" name="status" value="" style="width:100px; border:0px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" readonly></td>
        </tr>

        <tr><td colspan="2"><br></td></tr>

        <tr valign="top"><td class="captionbig"><?php gen_search_feature(get_cm_var('setcfg_users_activate_account'));?></td>
          <td class="captionbig">
            <input type="radio" name="usr_bt_acc" value="0" onClick="editActivateAcc('0')" disabled><?=get_cm_var('setcfg_users_account_is_created')?>&nbsp;<br>
            <input type="radio" name="usr_bt_acc" value="1" onClick="editActivateAcc('1')" disabled><?=get_cm_var('setcfg_users_first_login')?>&nbsp;<br>
            <input type="radio" name="usr_bt_acc" value="2" onClick="editActivateAcc('2')" disabled><?=get_cm_var('setcfg_users_date')?>&nbsp;
            <input class="shorttextbox w8em format-m-d-y divider-dash highlight-days-12" type="text" name="edit_act_date" maxlength="10" value="" onfocus="this.select()">&nbsp;
            <input class="timetextbox" type="text" name="edit_act_time" maxlength="5" value="" onfocus="this.select()" disabled><br>
            <?=get_cm_var('setcfg_recur_name')?>&nbsp;
            <input type="radio" name="edit_recur_option" value="1" onClick="edit_recur_disabled(this)" disabled><?=get_cm_var('setcfg_recur_option_on')?>&nbsp;
            <input type="radio" name="edit_recur_option" value="0" onClick="edit_recur_disabled(this)" disabled><?=get_cm_var('setcfg_recur_option_off')?>&nbsp;<br />
            <tr id="edit_schedule" style="display: none">
              <td class="captionbig"></td>
              <td class="captionbig">
                <input type="checkbox" name="edit_cb_mon" value="2"><?=get_cm_var('setcfg_mon')?>&nbsp;
                <input type="checkbox" name="edit_cb_tue" value="4"><?=get_cm_var('setcfg_tue')?>&nbsp;
                <input type="checkbox" name="edit_cb_wed" value="8"><?=get_cm_var('setcfg_wed')?>&nbsp;
                <input type="checkbox" name="edit_cb_thr" value="16"><?=get_cm_var('setcfg_thr')?>&nbsp;<br>
                <input type="checkbox" name="edit_cb_fri" value="32"><?=get_cm_var('setcfg_fri')?>&nbsp;
                <input type="checkbox" name="edit_cb_sat" value="64"><?=get_cm_var('setcfg_sat')?>&nbsp;
                <input type="checkbox" name="edit_cb_sun" value="1"><?=get_cm_var('setcfg_sun')?>&nbsp;<br>
                <?=get_cm_var('setcfg_recur_start_end_time')?>&nbsp;<br />
                <?=get_cm_var('setcfg_recur_time_format')?>&nbsp;<br>
                <input class="shorttextbox" type="text" name="edit_recur_stime" maxlength="5" value"" style="width:65px"> -
                <input class="shorttextbox" type="text" name="edit_recur_etime" maxlength="5" value"" style="width:65px">
              </td>
            </tr>
          </td>
        </tr>

        <!-- Reset option -->
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr>
            <td class="captionbig">
                <?php gen_search_feature(get_cm_var('setcfg_resetopt_enabled'));?>
            </td>
            <td class="captionbig">
                <input type="radio" name="reset_opt" value="y" disabled />
                <?=get_cm_var('setcfg_resetopt_yes')?>
                <input type="radio" name="reset_opt" value="n" disabled checked />
                <?=get_cm_var('setcfg_resetopt_no')?>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>
        <tr valign="top"><td id="ue_expireAcc" class="captionbig"><?php gen_search_feature(get_cm_var('setcfg_users_expire_account'));?></td>
          <td class="captionbig">
            <input type="checkbox" name="usr_cb_acc0" value="0" onClick="editExpireAcc('0')" disabled><?=get_cm_var('setcfg_users_never')?><br>
            <input type="checkbox" name="usr_cb_acc1" id="usr_cb_acc1" value="1" onClick="editExpireAcc('1')" disabled><span id="usr_cb_acc1_text"><?=get_cm_var('setcfg_users_timeleft')?><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_users_timeleft2')?>&nbsp;</span>
            <!-- following textbox use onmouseup instead of onclick because onmouseup still work even if textbox is disabled -->
            <input class="shorttextbox" type="text" name="edit_timeleft" id="edit_timeleft" maxlength="15" value="" onmouseup="warnEditTimeLeft()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled><br/>
            <div id="addtimeleft" style="display:none;"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id="usr_cb_acc1_text_b"><?=get_cm_var('setcfg_users_add_min')?></span>
                <input class="shorttextbox" type="text" name="edit_addtimeleft" id="edit_addtimeleft" maxlength="15" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">
            </div>
            <input type="checkbox" name="usr_cb_acc2" id="usr_cb_acc2" value="2" onClick="editExpireAcc('2')" disabled><span id="usr_cb_acc2_text"><?=get_cm_var('setcfg_users_login')?>&nbsp;</span>
            <input class="shorttextbox" type="text" name="edit_login" id="edit_login" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled></br>
            <input type="checkbox" name="usr_cb_acc3" value="3" onClick="editExpireAcc('3')" disabled><?=get_cm_var('setcfg_users_on_date')?>&nbsp;
            <input class="shorttextbox" type="text" name="edit_exp_date" maxlength="10" value="" onfocus="this.select()" disabled>&nbsp;
            <input class="timetextbox" type="text" name="edit_exp_time" maxlength="5" value="" onfocus="this.select()" disabled></br>
            <input type="checkbox" name="usr_cb_acc4" value="4" onClick="editExpireAcc('4')" disabled><span id="usr_cb_acc4_text"><?=get_cm_var('setcfg_users_minutes')?>&nbsp;</span>
            <input class="shorttextbox" type="text" name="edit_days" maxlength="8" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>&nbsp;
            <select NAME="select_edit_timeleft" id="select_edit_timeleft" disabled>
                <option VALUE="minutes">Minute(s)
                <option VALUE="hours">Hour(s)
                <option VALUE="days">Day(s)
            </select>
			<br>
			<input type="checkbox" name="usr_cb_acc5" value="5" onClick="editExpireAcc('5')" disabled><?=get_cm_var('setcfg_expire_month_text')?>&nbsp;
            <select NAME="select_edit_expire_month" disabled>
			<?
				for($i = 1; $i<=12; $i++){
					echo '<option VALUE="'.$i.'">'.get_cm_var("setcfg_expire_month_val".$i);
				}
			?>
            </select>
			<input class="timetextbox" type="text" name="edit_expire_year" maxlength="4" value="" onKeyPress="return numbersonly(this,event)" disabled>&nbsp;<?=get_cm_var('setcfg_expire_month_text2')?>&nbsp;
			<br/>
			<div id="addmonthlypass" style="display:none;"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_add_monthly_pass_text')?>
                <input class="shorttextbox" type="text" name="edit_addmonthlypass" maxlength="4" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">&nbsp;<?=get_cm_var('setcfg_add_monthly_pass_text2')?>
            </div>
        </td></tr>
        <tr><td colspan="2"><br></td></tr>
        <tr valign="top">
            <td width="35%" valign="top" class="captionbig"><?echo $standard_version_star;?><?php gen_search_feature(get_cm_var('setcfg_users_bt'));?>
            </td>
            <td width="65%" class="captionbig">
            <input type="radio" name="usr_bt_mode" value="0" onClick="rbtn('0')" disabled><?=get_cm_var('setcfg_users_no_throttling')?><br>
            <input type="radio" name="usr_bt_mode" value="1" onClick="rbtn('1')" disabled><?=get_cm_var('setcfg_users_low')?> (~<?=$bt_num_low?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="2" onClick="rbtn('2')" disabled><?=get_cm_var('setcfg_users_medium')?> (~<?=$bt_num_medium?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="3" onClick="rbtn('3')" disabled><?=get_cm_var('setcfg_users_high')?> (~<?=$bt_num_high?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="4" onClick="rbtn('4')" disabled><?=get_cm_var('setcfg_users_use_global_setting')?><br>
            <input type="radio" name="usr_bt_mode" value="5" onClick="rbtn('5')" disabled>
                <?=get_cm_var('setcfg_users_upload')?><br>
            <input type="text" class="shorttextbox" name="user_bt_num" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled><br>&nbsp;<?=get_cm_var('setcfg_users_download')?> <br>
            <input type="text" class="shorttextbox" name="user_bt_num_dl" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>

        <?php /***************************************** UPLOAD REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">UPLOAD</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">

            <input type="radio" name="Bn_bwcountUL" value="-1" onClick="bwparamType('-1','UL')" disabled><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="0" onClick="bwparamType('0','UL')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="1" onClick="bwparamType('1','UL')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="2" onClick="bwparamType('2','UL')" disabled><font id="ue_bwcountUL_color"><?=$standard_version_star?><span id="Bn_bwcountUL_text4"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font>
        </td></tr>

        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <!-- following textbox use onmouseup instead of onclick because onmouseup still work even if textbox is disabled -->
            <input class="shorttextbox" type="text" name="bwquota1UL" maxlength="15" value="" onmouseup="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr id="addQuotaULRow" style="display:none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig" id="edit_addquotaUL_col_1"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" id="edit_addquotaUL" name="edit_addquotaUL" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
            <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
            <input class="shorttextbox" type="text" name="acc_bandwidthUL" value="" disabled><br/><br/><br/>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>

        <?php /***************************************** DOWNLOAD REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">DOWNLOAD</td></tr>
        <tr valign="top">
          <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
          <td valign="top" class="captionbig">
            <input type="radio" name="Bn_bwcount" value="-1" onClick="bwparamType('-1')" disabled><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="0" onClick="bwparamType('0')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="1" onClick="bwparamType('1')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="2" onClick="bwparamType('2')" disabled><font id="ue_bwcount_color"><?=$standard_version_star?><span id="Bn_bwcount_text4"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font>
          </td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input class="shorttextbox" type="text" name="bwquota1" maxlength="10" value="" onClick="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>
        <tr id="addQuotaRow" valign="top" style="display: none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig" id="edit_addquota_col_1"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" name="edit_addquota" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
          <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
              <input class="shorttextbox" type="text" name="acc_bandwidth" value="" disabled><br/><br/><br/>
            </td>
        </tr>

		<tr><td colspan="2"><br></td></tr>
		
        <?php /***************************************** TOTAL REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">TOTAL</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">

            <!--<input type="radio" name="Bn_bwcountSHA" value="-1" onClick="bwparamSHA('-1')" disabled></*=get_cm_var('setcfg_users_global_counting'*/)?><br> -->
            <input type="radio" name="Bn_bwcountSHA" value="0" onClick="bwparamType('0','SHA')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcountSHA" value="1" onClick="bwparamType('1','SHA')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcountSHA" value="2" onClick="bwparamType('2','SHA')" disabled><font id="ue_bwcountSHA_color"><?=$standard_version_star?><span id="Bn_bwcountSHA_text3"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></span></font>
        </td></tr>

        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <!-- following textbox use onmouseup instead of onclick because onmouseup still work even if textbox is disabled -->
            <input class="shorttextbox" type="text" name="bwquota1SHA" maxlength="15" value="" onmouseup="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr id="addQuotaSHARow" style="display:none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig" id="edit_addquotaSHA_col_1"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" id="edit_addquotaSHA" name="edit_addquotaSHA" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
            <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
            <input class="shorttextbox" type="text" name="acc_bandwidthSHA" value="" disabled><br/><br/><br/>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>
        <tr valign="top">
          <td valign="top" class="captionbig" id="usr_abw_rm_col_1"><?php gen_search_feature(get_cm_var('setcfg_users_acc_bandwidth_reset_param'));?></td>
          <td valign="top" class="captionbig" id="usr_abw_rm_col_2">
            <input type="radio" name="usr_abw_rm" id="usr_abw_rm[0]" value="0" onclick="usr_abw_disable_all()" disabled><?=get_cm_var('setcfg_users_quota_disable')?>
            <input type="radio" name="usr_abw_rm" id="usr_abw_rm[1]" value="1" onclick="usr_abw_enable_textbox()" disabled><?=get_cm_var('setcfg_users_monthly')?>
            <input type="radio" name="usr_abw_rm" id="usr_abw_rm[2]" value="2" onclick="usr_abw_disable_textbox()" disabled><?=get_cm_var('setcfg_users_daily')?><br>
            <input type="radio" name="usr_abw_rm" id="usr_abw_rm[3]" value="3" onclick="usr_abw_disable_all()" disabled><?=get_cm_var('setcfg_users_quota_use_global_setting')?>
          </td>
        </tr>
<?php
        $usr_resetabw_monthly_default = 'none';
        $usr_resetabw_daily_default = 'none';
        $usr_resetabw_lastrbw_default = 'none';
    
		    $timeArray_date = '';
		    $timeArray_time = '';

        $input = get_cm_var('setcfg_users_resetabw_monthly_str1').
            '<input type="text" name="usr_abw_rdate" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>'.
            get_cm_var('setcfg_users_resetabw_monthly_str2').
            '<input type="text" name="usr_abw_rp_1" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>'.
            get_cm_var('setcfg_users_resetabw_monthly_str3');
		
		$input = '<span id="usr_abw_col_2">'.$input.'</span>';

        gen_invisible_line3('<span id="usr_abw_col_1">'.get_cm_var('setcfg_users_resetabw_title').'</span>',$input,"usr_resetabw_monthly",$usr_resetabw_monthly_default);

        $input = get_cm_var('setcfg_users_resetabw_daily_str1').
            '<input type="text" name="usr_abw_rp_2" maxlength="3" value="" class="shorttextbox" style="width:30px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>'.
            get_cm_var('setcfg_users_resetabw_daily_str2');
			
		$input = '<span id="usr_abw_col_4">'.$input.'</span>';

        gen_invisible_line3('<span id="usr_abw_col_3">'.get_cm_var('setcfg_users_resetabw_title').'</span>',$input,'usr_resetabw_daily',$usr_resetabw_daily_default);
        
        //User Set last period of time (Reset ABW) (Edit)
		    $input = '('.get_cm_var('setcfg_date_format').')&nbsp;('.get_cm_var('setcfg_time_format').')<br>&nbsp;<input type="text" maxlength="10" name="usr_resetabw_lastrbw_date" value="'.$timeArray_date.'" class="shorttextbox" style="width:85px;"  onfocus="this.select()"> &nbsp;&nbsp;'.
		            '<input type="text" maxlength="5" name="usr_resetabw_lastrbw_time" value="'.$timeArray_time.'" class="timetextbox" style="width:45px;" onfocus="this.select()">';
					
			$input = '<span id="usr_resetabw_lastrbw_time_col_2">'.$input.'</span>';
					
		    gen_invisible_line3('<span id="usr_resetabw_lastrbw_time_col_1">'.get_cm_var('setcfg_dispatcher_resetabw_title2').'</span>',$input,'usr_resetabw_lastrbw',$usr_resetabw_lastrbw_default);
        
?>
    <tr><td colspan="2"><br/></td></tr>
    <tr>
        <td class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_users_acl'));?>
        </td>
        <td class="captionbig">
            <input type="radio" name="acl" value="y" disabled />
            <?=get_cm_var('setcfg_users_acl_y')?>
            <input type="radio" name="acl" value="n" disabled checked />
            <?=get_cm_var('setcfg_users_acl_n')?>
        </td>
    </tr>
    <tr><td colspan="2"><br/></td></tr>
    <tr>
        <td id="usr_rsu_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_users_rsu'));?>
        </td>
        <td id="usr_rsu_col_2" class="captionbig">
            <input type="radio" name="rsu" id="edit_rsu[0]" value="y" disabled />
            <?=get_cm_var('setcfg_users_rsu_y')?>
            <input type="radio" name="rsu" id="edit_rsu[1]" value="n" disabled checked />
            <?=get_cm_var('setcfg_users_rsu_n')?>
        </td>
    </tr>
    <!-- MAC mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="usr_mac_map_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_mac_map_enabled'));?>
        </td>
        <td id="usr_mac_map_col_2" class="captionbig">
			<div id="usr_mac_map_c2_yes">
				<input type="radio" name="mac_map" id="edit_mac_map[0]" value="1" onclick="lcpwDisablingE(this.value)" disabled />
				<?=get_cm_var('setcfg_mac_map_yes')?>
			</div>
			<div id="usr_mac_map_c2_no">
				<input type="radio" name="mac_map" id="edit_mac_map[1]" value="0" onclick="lcpwDisablingE(this.value)" disabled checked />
				<?=get_cm_var('setcfg_mac_map_no')?><br>
			</div>
			<div id="usr_mac_map_c2_once">
				<input type="radio" name="mac_map" id="edit_mac_map[2]" value="2" onclick="lcpwDisablingE(this.value)" disabled />
				<?=get_cm_var('setcfg_mac_map_passive')?>
			</div>
        </td>
    </tr>
    <!-- IP mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_ip_map_enabled'));?>
        </td>
        <td class="captionbig">
            <input type="radio" name="ip_map" value="y" disabled />
            <?=get_cm_var('setcfg_ip_map_yes')?>
            <input type="radio" name="ip_map" value="n" disabled checked />
            <?=get_cm_var('setcfg_ip_map_no')?>
        </td>
    </tr>
    <!-- Port Filtering Rules Set -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_user_port_filtering_apply'));?>
        </td>
        <td class="captionbig">
<?php
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setfree.php FSCONFIG.Cfgmgr Object cannot be created!');
    $setNum = $settingobj->getKey('user_pf_size', 'UserPortFilter');
    $setData = $comma = '';
    for ($i = 1; $i <= $setNum; $i++) {
    	$key = $settingobj->getKey("flt_num{$i}_name", 'UserPortFilter');
    	$setData .= $comma . htmlspecialchars($key);
    	$comma = '`';
    }
?>
        	<input type="hidden" name="portflt_set" value="<?=$setData?>" />
        	<input type="text" name="portflt" value="" disabled /> <span id="portflt_msgbx" style="font-weight: bold; color: red;"></span>
        </td>
    </tr>
	<!--login segment-->
<?php
        $usr_login_segment_default = '';
			
			$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
			$local_ip = $settingobj->getKey('gateway_IP', 'gateway');
			$local_mask = $settingobj->getKey('subnet_mask', 'gateway');
			$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

			$tmp_num = '0'.trim($num_return_path);
			$num = (int)$tmp_num;

			$arr_opt = array();
			$return_path = array();
			$i = 0;
			while ($i < $num) {
				$return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
				$strarray = explode(' ', trim($return_path[$i]));
				$arr_opt[$i] = ($i+1).': '.$lang['setcfg_multi_net_seg_router_IP'].'='.$strarray[0].', '.$lang['setcfg_multi_net_seg_subnet_mask'].'='.$strarray[1];
				$i++;
			}
			$settingobj = null;
			
			$subInput = '';
			$subInput  .= '<option VALUE="-1">'.$lang['setcfg_segment_map_login_segment_opt'];
			$subInput  .= '<option VALUE="0">'.$lang['setcfg_segment_map_login_segment_opt0']." (".$lang['setcfg_segment_map_login_segment_opt0_text1'].'='.$local_ip.', '.$lang['setcfg_segment_map_login_segment_opt0_text2'].'='.$local_mask.")";;
			$j = 0;
			
			while ($j < 20) { // hard code limit 
				if  ($j < $num)
					$subInput  .= "<option VALUE=\"".($j+1)."\">$arr_opt[$j]";
				else
					$subInput  .= "<option VALUE=\"".($j+1)."\">".($j+1).": ";
				$j++;
			}
			
		    $input = '<select NAME="select_edit_login_segment" disabled>'.$subInput.'</select>';
		    gen_invisible_line3(get_cm_var('setcfg_segment_map_login_segment_title'),$input,'usr_login_segment',$usr_login_segment_default);
        
?>
    <!-- Free Access User -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="usr_faflag_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_free_access_user'));?>
        </td>
        <td id="usr_faflag_col_2" class="captionbig">
        	<input type="radio" name="faflag" id="edit_faflag[0]" value="1" disabled /> <?=get_cm_var('setcfg_free_access_user_yes')?> <input type="radio" name="faflag" id="edit_faflag[1]" value="0" disabled checked="checked" /> <?=get_cm_var('setcfg_free_access_user_no')?>
        </td>
    </tr>

	<!-- used -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="usr_used_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_used'));?>
        </td>
        <td id="usr_used_col_2" class="captionbig">
            <input type="radio" name="used" id="edit_used[0]" value="1" disabled  />
            <?=get_cm_var('setcfg_used_yes')?>
            <input type="radio" name="used" id="edit_used[1]" value="0" disabled checked />
            <?=get_cm_var('setcfg_used_no')?>
        </td>
    </tr>

	<!--//\\ Change Password After Next Login -->
    <tr id="lcpwSpaceB"><td colspan="2">&nbsp;</td></tr>
    <tr id="logincpwRowB">
        <td id="usr_login_cpw_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_login_cpw'));?>
        </td>
        <td id="usr_login_cpw_col_2" class="captionbig">
        	<input type="radio" name="login_cpw" value="1" disabled /> <?=get_cm_var('setcfg_login_cpw_yes')?>
			<input type="radio" name="login_cpw" value="0" disabled checked="checked" /> <?=get_cm_var('setcfg_login_cpw_no')?>
        </td>
    </tr>
	
    <!-- auto_del -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td id="usr_autodel_col_1" class="captionbig">
            <?php gen_search_feature(get_cm_var('setcfg_auto_del_enabled'));?>
        </td>
        <td id="usr_autodel_col_2" class="captionbig">
            <input type="radio" name="autodel" id="edit_autodel[0]" value="y" disabled checked />
            <?=get_cm_var('setcfg_auto_del_yes')?>
            <input type="radio" name="autodel" id="edit_autodel[1]" value="n" disabled />
            <?=get_cm_var('setcfg_auto_del_no')?>
        </td>
    </tr>
    
    <tr><td height="4" colspan="2"><img border="0" src="./images/blank.gif" width="4" height="4"></td></tr>
    <!--
    <tr id="saveBtn" style="display:none;">
      <td colspan="2" align="center">
    -->
    	<div id="saveBtn" style="position:absolute; z-index: 100; display:none;">
          <input type="button" name="save" value="Save" class="graphicBtn" alt="Save" title="Save" onClick="editUser()">
          <input type="button" id="cancelBtn" name="cancel" class="graphicBtn" value="Cancel" alt="Cancel" title="Cancel" onClick="editModeSwitch(false)">
    	</div>
    <!--
      </td>
    </tr>
    -->
    <?php
    	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
    	$session_handling = $settingobj->getKey('session_handling', 'gateway');
    	$settingobj = null;
    ?>
     		<input type="hidden" name="session_handling" value="<?=$session_handling?>"> 
    </table>
      </fieldset>
      </form> <!-- end of userinfoform -->
      </div>
      <!-- End edit user layer -->
    </td>

  </tr>    

  <tr>
    <td width="40%" colspan="2" valign="top" height="3"><img src="./images/blank.gif" border="0" width="3" height="3"></td>
    <td width="20" valign="top" height="3"><img src="./images/blank.gif" border="0" width="20" height="3"></td>    
    <td width="40%" valign="top" height="5"><img src="./images/blank.gif" border="0" width="3" height="5"></td>
  </tr>  

<tr>
    <td width="40%" valign="top">&nbsp;</td>
    <td width="170" valign="top"> 

    <!-- 'Move to Existing user' to fix the mislocation problem-->
   
    <!-- Fix mislocation problem -->
    
    </td>
    <td width="20">&nbsp;</td>
    <td width="40%">&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" colspan="5" valign="top" height="12"><img src="./images/blank.gif" border="0" width="3" height="12"></td>
  </tr>  

  <tr>

    <td width="40%">&nbsp;</td>
  </tr>    
  <tr>
    <td width="100%" colspan="5" valign="top" height="12"><img src="./images/blank.gif" border="0" width="3" height="12"></td>
  </tr>
  <tr>
    <td width="40%">&nbsp;</td>
    <td width="60%" colspan="2" valign="top" height="12">
        <input id="log_button" type="button" value="<?=get_cm_var('setcfg_users_btn_show_user_log')?>" title="<?=get_cm_var('setcfg_users_btn_show_user_log_title')?>" class="graphicBtn" onClick="show_userlog()" altValue="<?=get_cm_var('setcfg_users_btn_hide_user_log')?>" altTitle="<?=get_cm_var('setcfg_users_btn_hide_user_log_title')?>" />
    </td>
    <!-- Export User Log -->
    <td width="100%" colspan="2" valign="top" align="center" height="12">
        <form action="settingok.php" name="exportUsageform" method="post">
            <input type="hidden" id="exportUsageLog" name="exportUsageLog"  value="true"/>
			<input type="hidden" id="ClearLog" name="ClearLog"  value=""/>
            <input type="button" name="exportLog" title="<?=get_cm_var('setcfg_users_btn_export_user_log_title')?>" value="<?=get_cm_var('setcfg_users_btn_export_user_log')?>" class="graphicBtn" <?=$disabled_ip_text_sub6?> onclick = "DoTheCheck()" />&nbsp;&nbsp;&nbsp;
			<input type = "checkbox" name ="box1" <?=$disabled_ip_text_sub2?>> <font size = "2"><b><?=get_cm_var('setcfg_users_userlog_clearbox')?></b></font>
		</form>
    </td>
  </tr>
  <tr>
      <td colspan="5" width="100%">
            <!-- user log -->
            <div id="userlog" style="display:none">
		<!-- 20071109 - Set src not to load anything by default -->
                <iframe id="logFrame" class="bordered_frame" frameborder="0" width="100%" height="200" marginwidth="2" marginheight="0"></iframe>
            </div>
            <!-- this iframe is for remote scripting -->
            <iframe id="serverFrame" name="serverFrame" src="about:blank" style="width:0px; height:0px; border:0px"></iframe>
      </td>
  </tr>
<?php
      gen_foot(); //close table and div

        if (isset($searchuser) && $searchuser!='') { //restore search form field only in search user mode
            echo "<script type=\"text/javascript\">\nrestoresearchformdata('$searchuser');\n//searchuser.js\n</script>";
        }
    } // all user mode or $searchformdata is set

    if (!isset($searchUser) || $searchUser=='') { //show export form only in all user mode
?>
<!-- edited 1 Sept 2003 -->
<form action="settingok.php" name="exportimportform" method="post">
  <table border="0" cellspacing="1" cellpadding="1">
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment1')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment2')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment3')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment4')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment5')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_export_import_comment6')?></td>
    </tr>
    <tr>
      <td width="100%" class="captionbig"><?=get_cm_var('setcfg_users_sel_db')?></td>
    </tr>
    <tr>
      <td width="50%">
        <select name="table" style="width: 50%;" <?=$disabled_ip_text_sub7?>>
<?
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
    $Datasource_Tablename=$settingobj->getKey('Datasource_Tablename', 'gateway');
    $Datasource_Plans_Tablename=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
    $Datasource_PayPal_Table=$settingobj->getKey('Datasource_PayPal_Table', 'gateway');
    //$Datasource_URL_Log_Tablename=$settingobj->getKey('Datasource_URL_Log_Tablename', 'gateway');

    //$settingobj->Release();
    $settingobj=null;

    echo "<option value=\"user\" selected>$Datasource_Tablename";
    echo "<option value=\"plan\">$Datasource_Plans_Tablename";
    echo "<option value=\"cc\">$Datasource_PayPal_Table";
    //echo "<option value=\"url\">$Datasource_URL_Log_Tablename";

?>
        </select>
      </td>
      </tr>
      <tr>
      <td width="25%" colspan="5">
        <input type="submit" name="export" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_label_export')?>" <?=$disabled_ip_text_sub7?>>
        <input type="submit" name="import" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_label_import')?>" <?=$disabled_ip_text_sub7?>>
        <input type="submit" name="exportall" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_label_exportall')?>" <?=$disabled_ip_text_sub7?>>
        <input type="submit" name="importall" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_label_importall')?>" <?=$disabled_ip_text_sub7?>>
      </td>
    </tr>
  </table>
    <input type="hidden" name="exportImportDB" value="true">
</form>

<hr style="border: thin solid green;"/>

<!-- Remove user -->
<?php
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
	$rdays = $settingobj->getKey('removePeriod', 'misc');
	//$settingobj->Release();
  $settingobj=null;
?>
<form action="settingok.php" name="ruserform" method="post" onSubmit="return confirm('<?=get_cm_var('setcfg_users_remove_confirm')?>')">
<table>
  <tr>
    <td width="85%" class="captionbig"><?=get_cm_var('setcfg_users_remove_title')?></td>
  </tr>
  <tr>
    <td width="15%" class="captionbig" colspan="5" align="left">
    	<?=get_cm_var('setcfg_users_remove_period')?><input type="text" name="removePeriod" size="2" value="<?=$rdays?>" onKeyPress="return numbersonly(this.event)"> <?=get_cm_var('setcfg_users_remove_days')?><br>
      <input type="submit" name="btn_remove_usr" class="graphicBtn" value="<?=get_cm_var('setcfg_users_remove_btn')?>" <?=$disabled_ip_text_sub8?>>   
    </td>
  </tr>
</table>
</form>

<hr style="border: thin solid green;"/>

<form action="settingok.php" name="resetbwform" method="post" onSubmit="return confirmBWReset()">
<table>
  <tr>
    <td width="85%" class="captionbig"><?=stripslashes(get_cm_var('setcfg_users_reset_bandwidth_comment1'))?></td>
  </tr>
  <tr>
    <td width="15%" colspan="5" align="left">
        <input type="submit" name="btn_reset_bw" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_label_reset_bandwidth')?>" <?=$disabled_ip_text_sub9?>>   
        <input type="hidden" name="reset_bw" value="true">
    </td>
  </tr>
</table>
</form>
<label id="datadisplay"></label>
<?php
        } //all user mode
?>

<!-- end -->
<?php
    if (!isset($searchUser) || isset($searchFormData)) {
        //only do in all user mode or after search
        echo("<script type=\"text/javascript\"><!--\n");
        echo("totalPage($pages, $pageno);\n"); //users.js

        echo("initcombobox();\n"); //users.js
        echo("// -->\n</script>");  
     } //only do in all user mode or after search
?>

<? require_once "dropinQuota.php"; ?>

<script type="text/javascript">
callLoadingBox(false,false); //loadingBox.js hide loading box and stop button
</script>
<?php 
if (isset($_SERVER['HTTP_REFERER']))
	search_scroll($HTTP_REFERER);
?>