//*********************************************
// Bandwidth throttling
//*********************************************
function disable_textbox()
{
    document.form_d.bt_num.disabled=true;
    document.form_d.bt_num_down.disabled=true;
}

function enable_textbox()
{
    document.form_d.bt_num.disabled=false;
    document.form_d.bt_num_down.disabled=false;
}

//*********************************************
// Global data transfer setting
//*********************************************
function ShowQuotaDL()
{
    document.getElementById('div_dispatch_quota_dl').style.display = '';
}

function HideQuotaDL()
{
    document.form_d.bwdl_quota_checkbox.checked = false;
    EnableQuotaDL();
    document.getElementById('div_dispatch_quota_dl').style.display = 'none';
}

function EnableQuotaDL()
{
    if( document.form_d.bwdl_quota_checkbox.checked == true )
        document.form_d.bwdl_quota.disabled = false;
    else
    {
        document.form_d.bwdl_quota.disabled = true;
        document.form_d.bwdl_quota.value = '';
    }
}

function ShowQuotaUL()
{
    document.getElementById('div_dispatch_quota_ul').style.display = '';
}

function HideQuotaUL()
{
    document.form_d.bwul_quota_checkbox.checked = false;
    EnableQuotaUL();
    document.getElementById('div_dispatch_quota_ul').style.display = 'none';
}

function EnableQuotaUL()
{
    if( document.form_d.bwul_quota_checkbox.checked == true )
        document.form_d.bwul_quota.disabled = false;
    else
    {
        document.form_d.bwul_quota.disabled = true;
        document.form_d.bwul_quota.value = '';
    }
}

//******************************************************
// Global accumulative data transfer reset setting
//******************************************************
function show_hide(id, isshow)
{
        document.getElementById(id).style.display = isshow;
}

function abw_disable_all(){
    show_hide('abw_monthly', 'none');
    show_hide('abw_daily', 'none');
    show_hide('abw_lastrbw', 'none');
}

function abw_enable_textbox(){
    show_hide('abw_monthly', '');
    show_hide('abw_daily', 'none');
    show_hide('abw_lastrbw', '');
}

function abw_disable_textbox(){
    show_hide('abw_monthly', 'none');
    show_hide('abw_daily', '');
    show_hide('abw_lastrbw', '');
}

//*********************************************
// Qos
//*********************************************
function showQOS(){
    var i;
    var radio = document.form_d.qos;
    var oFrameDoc = getFrameDocument(frames['loadframe_qos']);

    // 20080929 - Remove settings of maximum values, increase loops
    if( radio[0].checked == true ) {
        for (i = 0; i < 4; i++)
            document.getElementById('divQos'+i).style.display = '';
        document.form_d.qos_dl.disabled=false;
        document.form_d.qos_ul.disabled=false;
        oFrameDoc.form_qos.qos_port.disabled=false;
        oFrameDoc.form_qos.qos_mindl.disabled=false;
        oFrameDoc.form_qos.qos_minul.disabled=false;
    }
    else if( radio[1].checked == true ) {
        for (i = 0; i < 4; i++)
            document.getElementById('divQos'+i).style.display = 'none';
        document.form_d.qos_dl.value = '';
        document.form_d.qos_ul.value = '';
        document.form_d.qos_dl.disabled=true;
        document.form_d.qos_ul.disabled=true;
        oFrameDoc.form_qos.qos_port.disabled=true;
        oFrameDoc.form_qos.qos_mindl.disabled=true;
        oFrameDoc.form_qos.qos_minul.disabled=true;
    }
}

//*********************************************
// Proxy ARP
//*********************************************
function showARP() {
    var radio = document.form_d.parp;
    if( radio[0].checked == true ) {    // enabled
        document.getElementById('divPARP').style.display = '';
    }
    else if( radio[1].checked == true ) {   // disabled
        document.getElementById('divPARP').style.display = 'none';
    }
}

//*********************************************
// NAT
//*********************************************

function displayARP(){
    var radio = document.form_d.nat;
    if( radio[0].checked == true ) {    // enabled NAT
        document.form_d.parp[1].checked = true;
    showARP();
    document.getElementById('parp_radio').style.display = 'none';
    
    }
    else if( radio[1].checked == true ) {   // disabled NAT
        document.form_d.parp[1].checked = true;
    showARP();
    document.getElementById('parp_radio').style.display = '';
    
    }
}

//*********************************************
// SMTP ON/OFF
//*********************************************
function switchSMTP()
{
	// default (1) is Off SMTP, (0) is On SMTP, boolean type 
	var whichRadio = document.form_d.smtp_on_selection[1].checked;	
	var authenticCheck = document.form_d.IspSmtpAuthLogin[0].checked;
	var isSMTP_Display = whichRadio? "none" : "";
	
	// SMTP Roaming
	document.getElementById('smtp_line1').style.display = isSMTP_Display;
	
	// ISP Server	
	document.getElementById('IspSmtpDomain').style.display = isSMTP_Display;
	document.getElementById('smtp_line3').style.display = isSMTP_Display;
	
	// Authentication login
	document.getElementById('IspSmtpAuthLogin').style.display = isSMTP_Display;
	document.getElementById('smtp_line3a').style.display = isSMTP_Display;
	
	// SMTP Port number
	document.getElementById('SmtpPort').style.display = isSMTP_Display;
	document.getElementById('smtp_line3d').style.display = isSMTP_Display;
	
	// Recipient Limit
	document.getElementById('rcptMax').style.display = isSMTP_Display;
	document.getElementById('smtp_line4').style.display = isSMTP_Display;
	
	// Mail Size Limit
	document.getElementById('mailsize').style.display = isSMTP_Display;
	document.getElementById('smtp_line5').style.display = isSMTP_Display;
	
	// Send Mail Recycle Time
	document.getElementById('execTime').style.display = isSMTP_Display;
	document.getElementById('smtp_line6').style.display = isSMTP_Display;
	
	ispChangeAuthLogin();

	if(whichRadio == true )
	{
		// Authentication login -> IspSmtp User
		document.getElementById('IspSmtpUserName').style.display = 'none';
		document.getElementById('smtp_line3b').style.display = 'none';
		
		// Authentication login -> IspSmtp Password
		document.getElementById('IspSmtpPassword').style.display = 'none';
		document.getElementById('smtp_line3c').style.display = 'none';
	}
}

function show_hideSMTP(id){
    var isshow='';

    content = document.getElementById(id);
    if (content.style.display == 'none')
        isshow = '';
    else
        isshow = 'none';

    content.style.display = isshow;
}

function commonChangeSMTP(){
    show_hideSMTP('smtp_on_checked');
    show_hideSMTP('smtp_off_checked');


    show_hideSMTP('smtp_line1');
    //show_hideSMTP('smtp_isp_on_checked');
	//show_hideSMTP('smtp_line2');
    show_hideSMTP('rcptMax');
    show_hideSMTP('smtp_line4');
    show_hideSMTP('mailsize');
    show_hideSMTP('smtp_line5');
    show_hideSMTP('execTime');
    show_hideSMTP('smtp_line6');
    //show_hideSMTP('MailLogOffset');
	/*if(document.form_d.smtp_on_selection[0].checked==false){
		document.getElementById('IspSmtpDomain').style.display = 'none';
		document.getElementById('smtp_line3').style.display = 'none';
		document.getElementById('SmtpPort').style.display = 'none';
		document.getElementById('smtp_line3d').style.display = 'none';
		document.form_d.smtp_isp_on_selection[0].checked= true;
		document.getElementById('IspSmtpAuthLogin').style.display = 'none';
		document.getElementById('smtp_line3a').style.display = 'none';
		document.form_d.IspSmtpAuthLogin[1].checked= true;
		ispChangeAuthLogin();
	}*/
}

function smtpOff(){
  //  document.form_d.smtp_off_selection[1].checked = true;
    //document.form_d.smtp_on_selection[1].checked = true;    
	//document.form_d.smtp_off_selection.checked = true;
   // document.form_d.smtp_on_selection.checked = false;
    commonChangeSMTP();	
    	document.getElementById('IspSmtpDomain').style.display = 'none';
		document.getElementById('smtp_line3').style.display = 'none';
		document.getElementById('SmtpPort').style.display = 'none';
		document.getElementById('smtp_line3d').style.display = 'none';
		document.form_d.IspSmtpDomain.value = '';
		document.getElementById('IspSmtpAuthLogin').style.display = 'none';
		document.getElementById('smtp_line3a').style.display = 'none';
		document.form_d.IspSmtpAuthLogin[0].checked= false;
		ispChangeAuthLogin();
		//document.form_d.SmtpPort.value = '';
}

function smtpOn(){
   // document.form_d.smtp_off_selection[0].checked = true;
    //document.form_d.smtp_on_selection[0].checked = true;   
	 // document.form_d.smtp_off_selection.checked = false;
     // document.form_d.smtp_on_selection.checked = true;
    commonChangeSMTP();	
	
    document.getElementById('IspSmtpDomain').style.display = '';
	document.getElementById('smtp_line3').style.display = '';
	document.getElementById('SmtpPort').style.display = '';
	document.getElementById('smtp_line3d').style.display = '';
	document.getElementById('IspSmtpAuthLogin').style.display = '';
	document.getElementById('smtp_line3a').style.display = '';
	document.form_d.IspSmtpAuthLogin[1].checked= true;
	
	ispChangeAuthLogin();
}

function getFrameDocument(frameObj)
{
/**
 *  For compatibility between IE & Firefox
 */
    if (frameObj.document) {
        return frameObj.document;
    } else {
        return frameObj.contentDocument;
    }
}

// Authentication login setting
function ispChangeAuthLogin(){
	if(document.form_d.IspSmtpAuthLogin[0].checked==true){
		document.getElementById('IspSmtpUserName').style.display = '';
		document.getElementById('smtp_line3b').style.display = '';
		document.getElementById('IspSmtpPassword').style.display = '';
		document.getElementById('smtp_line3c').style.display = '';
	}else{
		document.getElementById('IspSmtpUserName').style.display = 'none';
		document.getElementById('smtp_line3b').style.display = 'none';
		document.getElementById('IspSmtpPassword').style.display = 'none';
		document.getElementById('smtp_line3c').style.display = 'none';
		document.form_d.IspSmtpUserName.value = '';
		document.form_d.IspSmtpPassword.value = '';
	}
}

// 20080930 - Modify global bandwidth speed values based on selected type
function OnSelectQOSBw(instance)
{
    var dl = document.form_d.qos_dl;
    var ul = document.form_d.qos_ul;

    switch (instance.value) {
	case '0':
	    // Clear fields
	    dl.value = '';
	    ul.value = '';
	    break;
	case '1':
	    // DSL (384 Kb)
	    dl.value = 48;
	    ul.value = 48;
	    break;
	case '2':
	    // Pro DSL (768 Kb)
	    dl.value = 96;
	    ul.value = 96;
	    break;
	case '3':
	    // T1 (1.5 Mb)
	    dl.value = 192;
	    ul.value = 192;
	    break;
	case '4':
	    // Cable modem (3 Mb)
	    dl.value = 384;
	    ul.value = 384;
	    break;
	case '5':
	    // LAN (10 Mb)
	    dl.value = 1280;
	    ul.value = 1280;
	    break;
	case '6':
	    // WLAN (11 Mb)
	    dl.value = 1408;
	    ul.value = 1408;
	    break;
	case '7':
	    // T3 (44 Mb)
	    dl.value = 5632;
	    ul.value = 5632;
	    break;
    }
}

function changeFP(t){
	if (t==1){
		document.getElementById('fp_line1').style.display = '';
		document.getElementById('forword_proxyAddress').style.display = '';
		document.getElementById('fp_line2').style.display = '';
		document.getElementById('forword_proxyPort').style.display = '';
	}
	else{
		document.getElementById('fp_line1').style.display = 'none';
		document.getElementById('forword_proxyAddress').style.display = 'none';
		document.getElementById('fp_line2').style.display = 'none';
		document.getElementById('forword_proxyPort').style.display = 'none';
	}
}

function changeDynamicBT(){
	if(document.form_d.bt_dynamic[0].checked==true){
		document.getElementById('btExceedLimit_line').style.display = '';
		document.getElementById('btExceedULLimit').style.display = '';
		document.getElementById('btExceedLimit_line2').style.display = '';
		document.getElementById('btExceedDLLimit').style.display = '';
	}else{
		document.getElementById('btExceedLimit_line').style.display = 'none';
		document.getElementById('btExceedULLimit').style.display = 'none';
		document.getElementById('btExceedLimit_line2').style.display = 'none';
		document.getElementById('btExceedDLLimit').style.display = 'none';
	}
}

function changeBP(t){
	if (t==1 || t==2){
		document.getElementById('bp_line1').style.display = '';
		document.getElementById('blackout_period_time').style.display = '';
		document.getElementById("schdeuleValue").value = "";
	}
	else{
		document.getElementById('bp_line1').style.display = 'none';
		document.getElementById('blackout_period_time').style.display = 'none';
	}
}

function changeDI(t){
	if (t==1){
		document.getElementById('di_line1').style.display = '';
		document.getElementById('publicNIC2').style.display = '';
		document.getElementById('di_line2').style.display = '';
		document.getElementById('refresh_conn_name_list').style.display = '';
	}
	else{
		document.getElementById('di_line1').style.display = 'none';
		document.getElementById('publicNIC2').style.display = 'none';
		document.getElementById('di_line2').style.display = 'none';
		document.getElementById('refresh_conn_name_list').style.display = 'none';
	}
}

function setRefreshList(){
	document.form_d.refresh_conn_name_list.value = true;
}

//\\ 20130322 >>> 347 - Bandwidth Throttling Exception List Process
function bte_btn_process(type){
	var inStr = document.form_d.bte_data_content;
	var list = document.form_d.bte_list;
	switch(type){
		case 1: // Add Ip Or Url to Exception List
			counter = bte_search_str(inStr.value);
			if(counter == -2)
				inStr.value = 'Wrong Input';
			else if(counter == -1){
				list.innerHTML += '<option value="'+inStr.value+'" style="color:green"># '+inStr.value+'</option>';
				inStr.value = '';
			}
			else{
				list.options[counter].selected=true;
				if(list.options[counter].value.indexOf('*')>=0){
					list.options[counter].value = list.options[counter].value.replace('*','');
					list.options[counter].text = '# '+list.options[counter].value;
					list.options[counter].style.color = 'green';
				}
			}
			return;
		case 3: // Delete Selected Option
			if(list.selectedIndex == -1){
				inStr.value = 'IP or URL is not selected';
				break;
			}
			var x = 0;
			while(x < list.length){
				if(list.options[x].selected){
					list.options[x].text = '* '+list.options[x].value;
					list.options[x].value += '*';
					list.options[x].style.color = 'red';
					list.options[x].selected = false;
				}
				x++;
			}
			break;
	}
}

//\\ 20130322 >>> 347 <<<
//\\ Function for searching Ip or Url in Exception List
//\\ -2 : Wrong Input, >=0 : Element Location, -1 : Not Found
function bte_search_str(addrStr){
	if(addrStr == '')
		return -2;
	var list = document.form_d.bte_list;
	var counter = 0;
	var content = '';
	while(counter<list.length){
		content = list.options[counter].value;
		content = (content.indexOf('*')>=0)?content.replace('*',''):content;
		if(addrStr==content)
			return counter;
		else
			counter++;
	}
	return -1;
}

//\\ 20130325 >>> 347 <<<
function bte_prepare_data(){
	var counter = 0;
	var content = '';
	while(document.form_d.bte_list.length > counter){
		content = document.form_d.bte_list.options[counter].value;
		document.form_d.bte_path_array.value += (content.indexOf('*')<0)?(content+'|'):'';
		counter++;
	}
}