<?php

require_once "fs_lang.php";
require_once "common_functions.php";
require_once 'generate_common.php';
include "..\\cfgmgr\\db_access.php";
require_once "..\\cfgmgr\\fsAPI.php";

// print_r($_GET);

$settingobj			= new COM("FSCONFIG.Cfgmgr") or die("email_callback.php FSCONFIG.Cfgmgr Object cannot be created!");
$email_confirmation	= ($settingobj->getKey( "self_sign_up_email_verification", "gateway") == 1) ;
$email_login		= (strtolower($settingobj->getKey( "email_login", "gateway")) == 'on');
if($email_login)
	$upwdPlan		= $settingobj->getKey( "email_login_plan", "gateway");
else
	$upwdPlan		= $settingobj->getKey( "self_sign_up_plan", "gateway");

$settingobj			= null;
//$dbmsg			= '';
$displayResult		= '';
$logout				= 0;
$logoutStr			= '';
$refreshStr			= '';
$waitForRedirect	= 5;
$myFsApi			= new fsAPI();

// checking 
if (!$email_confirmation && !$email_login){
	// not using email confirmation
	$displayResult = $lang['email_confirm_error1'];
}
elseif (isset($code) && strlen ($code) > 0){

	$de_str = base64_decode($code);
	//$dbmsg .= 'de_str -> '.$de_str.'<br/>';
	
	list($k,$uname,$passwd) = explode("=", $de_str);
	//$dbmsg .= 'uname -> '.$uname.'<br/>';
	
	$myDB = new db();
	$usr_table = $myDB->get_usr_table();
	
	// check username
	$query="SELECT name, emailVer, acctype, sdate, edate FROM $usr_table where name = '".$uname."'";
	$result=$myDB->query($query);
	
	if (!odbc_fetch_row($result)) {
		// user not exist
		$displayResult = $lang['email_confirm_error2'];
	}
	else {
		$end_date		= odbc_result($result,"edate");
		$email_confirm	= odbc_result($result,"emailVer");

		if (strcasecmp($email_confirm, "email confirmed") == 0){
			// user already click the email confirm link
			//echo $lang['email_confirm_error3'];
			$displayResult = $lang['email_confirm_error3'];
		}
		// expired account can not be confirmed
		elseif(strlen($email_confirm)==0){
			$displayResult = $lang['email_confirm_error1'];
		}
		elseif(strtotime($end_date) < time()){
			$displayResult = $lang['email_confirm_error6'];
		}
		else{
			// email confirmed, update database
			$acctype = odbc_result($result,"acctype");
			//echo 'Account type : '.$acctype.'<br/>';	//\\-
			$sdate = odbc_result($result,"sdate");
			//echo 'Start date : '.$sdate.'<br/>';	//\\-
			
			$query=fs_usr_plan_update_query($upwdPlan, $uname, 0, ($acctype == 1), $email_login);
			
			//echo "First SQL : ".$query;	//\\-
			// Check user active date in plan
			if(preg_match("/, SDATE=([^,]+)/",$query,$planSdate)){
				if($planSdate[1]=='NULL')
					$query = preg_replace('/, SDATE=NULL/i','',$query); //Stop set SDATE as null
				else
					$sdate = str_replace("'","",$planSdate[1]);
			}
			
			$eMin=0;
			if(preg_match("/, EMINUTES=([^,]+)/",$query,$pEMin) && preg_match("/, EDATE=([^,]+)/",$query,$pEdate)){
				if($pEMin[1]!='NULL'){
					//$dbmsg .= 'EDate : '.$pEdate[1].'<br/>';	//\\-
					$eMin = intval($pEMin[1]);
					//$dbmsg .= 'EMinutes : '.$eMin.'<br/>';	//\\-
					$endSecond = strtotime($sdate)+$eMin*60;
					//$dbmsg .= 'ESecond : '.$endSecond.'<br/>';	//\\-
					if($pEdate[1]!='NULL'){
						if(strtotime($pEdate[1]) < $endSecond)
							$endSecond = strtotime($pEdate[1]);
					}
					$query = preg_replace('/, EDATE=[^,]+/',", EDATE='".date("D M d H:i:s Y",$endSecond)."'",$query);
					if(time() > $endSecond)
						$logout = 1;	// user expired
				}
				// Second check for plan expire date if it is expirated "today"
				if($pEdate[1]!='NULL'){
					if(time() > strtotime($pEdate[1]))
						$logout = 1;	// user expired
				}
			}
			
			// check access minutes if no more time left
			if(preg_match("/, TIMELEFT=([^,]+)/",$query,$pAMin)){
				if($pAMin[1]!='NULL'){
					$aMin = intval($pAMin[1]);
					if(!($aMin > 0))
						$logout = 2; // no time to access the Internet
				}
			}
			
			// check data transfer quota ( upload )
			foreach(array('','UL','SHA') as $key => $DTtype){
				if(preg_match("/, BWCOUNT".$DTtype."=([^,]+)/",$query,$pBWC)){
					if(intval($pBWC[1]) == 2){
						$totalDT = 0;
						$DTquota = 0;
						if(preg_match("/, BWQUOTA".$DTtype."=([^,]+)/",$query,$pBWQ)){
							if(preg_match("/, ACCUMBW".$DTtype."=([^,]+)/",$query,$pABW)){
								if($pABW[1]!='NULL')
									$totalDT = intval($pABW[1]);
							}
							if($pBWQ[1]!='NULL')
								$DTquota = intval($pBWQ[1]);
							if(!($totalDT < $DTquota)){
								$logout = 3 + $key;	// no quota for data transfer
								break;
							}
						}
					}
				}
			}
			
			$query = preg_replace('/, EMINUTES=[^,]+/',", EMINUTES=NULL",$query); // Set EMinutes as null after edate calculating
			$query = str_replace(' WHERE',",EMAILVER = 'email confirmed' WHERE",$query);
			//$dbmsg .= 'Finished SQL : '.$query.'<br/>';	//\\-
			
			// start logout if account is expired or other 
			if($logout > 0){
				$myobj = new COM("FSAUTH.Authserv") or die("disconnectscript.php FSAUTH.Authserv object cannot be created!");

				$result_name= "";
				$result_name= $myobj->ForceLogout($uname);

				if (strcmp($result_name, "") != 0 && ($result_name == 'DB NOT FOUND' || $result_name == 'DB EXEC FAIL'))
					$displayResult = $lang['email_confirm_error5'];

				$myobj = null;
				
				switch($logout){
					case 1:
						$logoutStr = '<br/>'.$lang['ec_success_expired'];
						break;
					case 2:
						$logoutStr = '<br/>'.$lang['ec_success_no_access'];
						break;
					case 3:
						$logoutStr = '<br/>'.$lang['ec_success_no_dt_upload'];
						break;
					case 4:
						$logoutStr = '<br/>'.$lang['ec_success_no_dt_download'];
						break;
					case 5:
						$logoutStr = '<br/>'.$lang['ec_success_no_dt_total'];
				}
				$logoutStr.= ' '.$lang['ec_success_logout'];
				if($passwd!=''){
					$logoutStr.= '<br/><a href="'.fs_urlhead().'cart.php">'.$lang['ec_success_sc_redirect'].'</a>';
					$_SESSION['session_username']	= $uname;
					$_SESSION['session_code']		= rawurlencode(encrypt($uname.'|'.$passwd)); //\\
					$refreshStr = '<meta http-equiv="refresh" content="'.$waitForRedirect.';url='.fs_urlhead().'cart.php">';
				}
				else
					$logoutStr.= '<br/>'.$lang['ec_success_contact_sa'];
			}
			else
				$logoutStr = '<br/>'.$lang['ec_success_continue'];

			$result=$myDB->query($query);

			// live update user for email login
			$myFsApi->live_update($uname, 0, 0, 0, 1);

			// write log
			$output = date("D M d H:i:s Y")."\t User($uname) - Email confirmed.\r\n";

			$export_file = 'email_confirmation.log';
			$writeHd = false;

			if (is_file("..\\log\\".$export_file) == FALSE){
				touch ("..\\log\\".$export_file);
				$writeHd = true;
			}
			$fileHandler = fopen ("..\\log\\".$export_file, 'a');
			fwrite ($fileHandler, $output);
			fclose ($fileHandler);

			// Finish
			if($displayResult==''){
				$displayResult = $lang['email_confirm_success'].$logoutStr;
			}
		}
	}
}
else{
	$displayResult = $lang['email_confirm_error4'];
}
$displayResult = "<span class=\"textspan\">".$displayResult."</span>";
$smarty = new SmartyConnect;
$smarty->assign('L_FSSIGNUP_CHARSET', metaCharset());
$smarty->assign('L_FSSIGNUP_REFRESH', $refreshStr);
$smarty->assign('L_FSSIGNUP_TITLE', $lang['email_confirm_title']);
$smarty->assign('L_FSSIGNUP_STATUS_MSG', $displayResult);
//$smarty->assign('J_COMMON', $j_common);
//$smarty->assign('DEBUG_MSG', $dbmsg);	//\\=

$smarty->display('fs_signup_body.tpl');
$myFsApi = null;
?>