<?php

if (!function_exists('get_cm_var')) exit();

if (isset($_POST['start_submit'])) {
	try {
		startHostedNetwork();
	} catch (Exception $e) {
		echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">';
		echo 'Error:<br>';
		exit(nl2br($e->getMessage()));
		echo '</div>';
	}
	echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">'.get_cm_var('sap_msg_1').'</div>';
} else if (isset($_POST['ssid_change_submit'])) {
	try {
		editSSID($_POST['ssid']);
	} catch (Exception $e) {
		echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">';
		echo 'Error:<br>';
		exit(nl2br($e->getMessage()));
		echo '</div>';
	}
	try {
		startHostedNetwork();
	} catch (Exception $e) {
		echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">';
		echo 'Error:<br>';
		exit(nl2br($e->getMessage()));
		echo '</div>';
	}
	echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">'.get_cm_var('sap_msg_2').'</div>';
} else if (isset($_POST['key_change_submit'])) {
	try {
		editKey($_POST['key']);
	} catch (Exception $e) {
		echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">';
		echo 'Error:<br>';
		exit(nl2br($e->getMessage()));
		echo '</div>';
	}
	try {
		startHostedNetwork();
	} catch (Exception $e) {
		echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">';
		echo 'Error:<br>';
		exit(nl2br($e->getMessage()));
		echo '</div>';
	}
	echo '<div style="color: red; font-weight: bold; font-size: 14px; margin-top: 7px;">'.get_cm_var('sap_msg_3').'</div>';
}

$hostedNetworkStatus = getHostedNetworkStatus();
$checkAdapter = checkAdapter();

/* For testing
$hostedNetworkStatus = true;
//$hostedNetworkStatus = false;

$checkAdapter = true;
//$checkAdapter = false;
*/

if ($hostedNetworkStatus == true) {
	// for testing
	// $networkStatusDetail = array('ssid' => 'shing', 'bssid' => '00:21:6e:7d:d8:ee', 'radioType' => '802.11g', 'channel' => 11, 'clientNum' => 0);
	$networkStatusDetail = getHostedNetworkStatusDetail();
}

?>
<tr><td style="padding: 10px 0px;">

<div style="border: 1px solid green; padding: 10px; background: #eee; font-size: 12px; margin-bottom: 10px; width: 400px;">
	<div style="font-weight: bold; font-size: 14px; padding-bottom: 3px;"><?=get_cm_var('sap_status')?>:</div>
	<div style="padding-left: 10px; line-height: 20px;">
		<?php if ($hostedNetworkStatus == true) { ?>
			<div style="padding-bottom: 5px;">
				<?=get_cm_var('sap_the_softap_is')?> <span style="color: red;"><?=get_cm_var('sap_started')?></span>
			</div>
	</div>
	<div style="font-weight: bold; font-size: 14px; padding-bottom: 3px; padding-top: 6px;"><?=get_cm_var('sap_softap_info')?>:</div>
	<div style="padding-left: 10px; line-height: 20px;">
			<div style="padding-bottom: 5px;">
				<b>SSID:</b> <?=$networkStatusDetail['ssid']?><br />
				<b>BSSID:</b> <?=$networkStatusDetail['bssid']?><br />
				<b><?=get_cm_var('sap_radio_type')?>:</b> <?=$networkStatusDetail['radioType']?><br />
				<b><?=get_cm_var('sap_channel')?>:</b> <?=$networkStatusDetail['channel']?>
			</div>
			<div style="padding-bottom: 5px;">
				<b><?=get_cm_var('sap_network_authentication')?>:</b> <?=get_cm_var('sap_wpa2_personal')?><br />
				<b><?=get_cm_var('sap_data_encryption')?>:</b> <?=get_cm_var('sap_aes_ccmp')?>
			</div>

			<b><?=get_cm_var('sap_max_number_of_clients')?>:</b> 100<br />
			<b><?=get_cm_var('sap_number_of_clients')?>:</b> <?=$networkStatusDetail['clientNum']?>
		<?php } else { ?>
			<?=get_cm_var('sap_the_softap_is')?> <span style="color: red;"><?=get_cm_var('sap_not_started')?></span>.
		<?php } ?>
	</div>
</div>
<?php if ($hostedNetworkStatus != true) { ?>
	<?php if ($checkAdapter == true) { ?>
		<script type="text/javascript">
			function validateStartAP() {
				var ssid = document.getElementById('ssid').value;
				if (!ssid.match(new RegExp("^[a-zA-Z0-9]{1}[a-zA-Z0-9\s]{0,32}$", "m"))) {
					alert('<?=get_cm_var('sap_msg_4')?>');
					return false;
				}
				var key = document.getElementById('key').value;
				if (key.length < 8 || key.length > 64) {
					alert('<?=get_cm_var('sap_msg_5')?>');
					return false;
				}
			}
		</script>
		<form method="post" onsubmit="javascript: return validateStartAP();">
			<div style="border: 1px solid green; padding: 10px; background: #eee; font-size: 12px; margin-bottom: 10px; width: 400px;">
				<div style="font-weight: bold; font-size: 15px; padding-bottom: 8px;"><?=get_cm_var('sap_strat_softap')?>:</div>
				<div style="padding-left: 10px; line-height: 20px;">
					<b>SSID:</b> <input type="text" id="ssid" name="ssid" value="" style="border: 1px solid seagreen; height: 20px;" /><br />
					<b><?=get_cm_var('sap_key')?>:</b> <input type="text" id="key" name="key" value="" style="border: 1px solid seagreen; height: 20px;" /> &nbsp;<input type="submit" class="graphicBtn" name="start_submit" value="<?=get_cm_var('sap_start')?>" />
					<hr></hr>
					<b><?=get_cm_var('sap_network_authentication')?>:</b> <?=get_cm_var('sap_wpa2_personal')?><br />
					<b><?=get_cm_var('sap_data_encryption')?>:</b> <?=get_cm_var('sap_aes_ccmp')?><br />
					<b><?=get_cm_var('sap_max_number_of_clients')?>:</b> 100
				</div>
			</div>
		</form>
	<?php } else { ?>
		<div style="border: 1px solid green; padding: 4px; background: #eee; font-weight: bold; font-size: 13px; padding-bottom: 3px;">
			<?=get_cm_var('sap_attention')?>: 'Microsoft Virtual WiFi Miniport Adapter' <?=get_cm_var('sap_not_found')?>
		</div>
	<?php } ?>
<?php } else { ?>
		<script type="text/javascript">
			function validateChangeSSID() {
				var ssid = document.getElementById('ssid').value;
				if (!ssid.match(new RegExp("^[a-zA-Z0-9]{1}[a-zA-Z0-9\s]{0,32}$", "m"))) {
					alert('SSID format invalid');
					return false;
				}
			}
			function validateChangeKey() {
				var key = document.getElementById('key').value;
				if (key.length < 8 || key.length > 64) {
					alert('The length of WPA2-Personal Key should be at lease 8 and less than 64 characters.');
					return false;
				}
			}
		</script>
		<form method="post" onsubmit="javascript: return validateChangeSSID();">
			<div style="border: 1px solid green; padding: 10px; background: #eee; font-size: 12px; margin-bottom: 10px; width: 400px;">
				<div style="font-weight: bold; font-size: 15px; padding-bottom: 8px;"><?=get_cm_var('sap_change_ssid')?>:</div>
				<div style="padding-left: 10px; line-height: 20px;">
					<b>SSID:</b> <input type="text" id="ssid" name="ssid" value="" style="border: 1px solid seagreen; height: 20px;" /> &nbsp;<input type="submit" class="graphicBtn" name="ssid_change_submit" value="<?=get_cm_var('sap_change')?>" />
				</div>
			</div>
		</form>
		<form method="post" onsubmit="javascript: return validateChangeKey();">
			<div style="border: 1px solid green; padding: 10px; background: #eee; font-size: 12px; margin-bottom: 10px; width: 400px;">
				<div style="font-weight: bold; font-size: 15px; padding-bottom: 8px;"><?=get_cm_var('sap_change_key')?>:</div>
				<div style="padding-left: 10px; line-height: 20px;">
					<b><?=get_cm_var('sap_key')?>:</b> <input type="text" id="key" name="key" value="" style="border: 1px solid seagreen; height: 20px;" /> &nbsp;<input type="submit" class="graphicBtn" name="key_change_submit" value="<?=get_cm_var('sap_change')?>" />
				</div>
			</div>
		</form>
<?php } ?>

</td></tr>
<?php

/**
 * Change SSID, will start hosted network after changing the SSID
 * @param string $ssid the SSID that want to change to
 * @return boolean always return true
 */
function editSSID($ssid) {
	$respond = trim(shell_exec("cmd.exe /c chcp 437 | netsh wlan set hostednetwork ssid=\"{$data}\""));
	if ($respond != 'The SSID of the hosted network has been successfully changed.') {
		throw new Exception($respond);
	}
	return true;
}

/**
 * Change WPA2-PSK Key, will start hosted network after changing the key
 * @param string $key the WPA2-PSK key that want to change to
 * @return boolean always return true
 */
function editKey($key) {
	$respond = trim(shell_exec("cmd.exe /c chcp 437 | netsh wlan set hostednetwork key=\"{$data}\" keyUsage=persistent"));
	if ($respond != 'The user key passphrase of the hosted network has been successfully changed.') {
		throw new Exception($respond);
	}
	return true;
}

/**
 * Start hosted network
 * @return boolean always return true
 */
function startHostedNetwork() {
	$respond = trim(shell_exec("cmd.exe /c chcp 437 | netsh wlan set hostednetwork mode=allow"));
	$respond = trim(shell_exec("cmd.exe /c chcp 437 | netsh wlan start hostednetwork"));
	if ($respond != 'The hosted network started.') {
		throw new Exception($respond);
	}
	return true;
}

/**
 * Check whether the hosted network is started.
 * @return boolean true if hosted network is started, false if not
 */
function getHostedNetworkStatus() {
	$getHostedNetworkStatus = shell_exec("cmd.exe /c chcp 437 | netsh wlan show hostednetwork");
	$treat = explode("\n", $getHostedNetworkStatus);

	foreach ($treat as $stateLine) {
		if (preg_match("/^[\s]*Status[\s]*:[\s]*([a-zA-Z]+)[\s]*$/", $stateLine, $matches)) {
			return ($matches[1] == 'Started');
		}
	}

	return false;
}

/**
 * Get hosted network status detail.
 * @return array e.g. array('ssid' => 'shing', 'bssid' => '00:21:6e:7d:d8:ee', 'radioType' => '802.11g', 'channel' => 11, 'clientNum' => 0);
 */
function getHostedNetworkStatusDetail() {
	$getHostedNetworkStatus = shell_exec("cmd.exe /c chcp 437 | netsh wlan show hostednetwork");
	$treat = explode("\n", $getHostedNetworkStatus);

	$returnArray = array('ssid' => '', 'bssid' => '', 'radioType' => '', 'channel' => 0, 'clientNum' => 0);

	foreach ($treat as $stateLine) {
		if (preg_match("/^[\s]*SSID\sname[\s]*:[\s]*\"([a-zA-Z0-9\s]+)\"[\s]*$/", $stateLine, $matches)) {
			$returnArray['ssid'] = $matches[1];
		}
		if (preg_match("/^[\s]*BSSID[\s]*:[\s]*([a-fA-F0-9:]+)[\s]*$/", $stateLine, $matches)) {
			$returnArray['bssid'] = $matches[1];
		}
		if (preg_match("/^[\s]*Radio\stype[\s]*:[\s]*([a-zA-Z0-9\.]+)[\s]*$/", $stateLine, $matches)) {
			$returnArray['radioType'] = $matches[1];
		}
		if (preg_match("/^[\s]*Channel[\s]*:[\s]*([0-9]+)[\s]*$/", $stateLine, $matches)) {
			$returnArray['channel'] = $matches[1];
		}
		if (preg_match("/^[\s]*Number\sof\sClients[\s]*:[\s]*([0-9]+)[\s]*$/", $stateLine, $matches)) {
			$returnArray['clientNum'] = $matches[1];
		}
	}

	return $returnArray;
}

/**
 * Check whether 'Microsoft Virtual WiFi Miniport Adapter' exist or not
 * @todo to make it really detect the 'Microsoft Virtual WiFi Miniport Adapter'
 * @return boolean true if adapter found, false if not
 */
function checkAdapter() {
	return true;
}

?>