<?php

// emulate magic_quotes_gpc
// cannot use variable variables as it will result in "Undefined variable: _REQUEST"
foreach ([&$_GET, &$_POST, &$_COOKIE, &$_REQUEST] as &$mqval0) {
	foreach ($mqval0 as $mqkey1 => $mqval1){
		if (is_array($mqval1)) {			// only handle one-level nested array
			foreach ($mqval1 as $mqkey2 => $mqval2) {
				$mqval0[$mqkey1][$mqkey2] = addslashes($mqval2);
			}
		} else {
			$mqval0[$mqkey1] = addslashes($mqval1);
		}
	}
}
unset($mqval0);


// emulate register_globals is On. Note that the sequence is in reversed order compare to variables_order parameter since EXTR_SKIP won't overwrite
// see http://php.net/variables-order. $_ENV is not included in variables_order in PHP7 php.ini 
if (isset($_SESSION)) {			// assume $_SESSION has priority
	// array_keys is fast in PHP7
	// this is necessary in intermediate.php as the code only change $var then redirect via $_SESSION[$var]
	foreach (array_keys($_SESSION) as $key) {
		$$key = &$_SESSION[$key];
	}
}

foreach ([$_SERVER, $_FILES, $_COOKIE, $_POST, $_GET] as $superglobal) {
	extract($superglobal, EXTR_SKIP);
}


// no return code for the below 2 functions as we didn't use it
function session_register($name) {
	global $$name;
	
	// this is the most likely behaviour as the original function has failed code
	if (!isset($_SESSION[$name])) {
		$_SESSION[$name] = $$name;
	} 
	$$name = &$_SESSION[$name]; 
}

function session_unregister($key) {
      unset($_SESSION[$key]);
}

?>