<?php header("Cache-Control: no-cache, must-revalidate"); ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>FirstSpot&reg; | submit</title>
<link href="local.css" rel="stylesheet" type="text/css">
<script type="text/javascript">
function submitForm()
{
	document.payment.submit();
}
</script>
</head>

<?php
include_once "transaction.php";
require_once "..\\authserv\\common_functions.php";

$settingobj		= new COM("FSCONFIG.Cfgmgr") or die("paypal_submit2.php FSCONFIG.Cfgmgr Object cannot be created!");
picturePath();

//******** ensure require postfields have submitted by cart.php ***********//  

$status_message="";
$ok=true;

if ( !isset($_POST["username"]) || strcmp ($_POST["username"], "") == 0) {
	$status_message="- <b>username</b>: the FirstSpot user who is going to receive the purchase air time credit.<br>";
	$ok=false;
}
if (!isset($_POST["item_index"]) || strcmp ($_POST["item_index"], "") == 0) {
	$status_message.="- <b>item_index</b>: the item_index for searching the item attributes.<br>";
	$ok=false;
}


if (!$ok) {
	echo '<body>'."\n";
	echo 'These are the minimum fields you have to post to this php file:<p>'."\n";
	echo $status_message;
	echo "\n".'</p><p>Auto-redirection to WebPAY is aborted.</p>'."\n";

	// 20080211 - Correct typo

	if(isset($_SERVER['HTTP_REFERER'])) {
		echo "<a href=\"{$_SERVER['HTTP_REFERER']}\">Click here to go back</a>\n";
	}
	
	echo "</body>\n";
	echo "</html>\n";
	die;
}

// 21-01-2010 Add include common_functions.php
// 20090113 - Add ppal_lc_table


$myTransaction	= new transaction();
//20080716 use the get_cart_item_arr function to retrieve the transaction item array(contains the item information)
$item_index		=$_POST['item_index'];
$cart_item_arr	=$myTransaction->get_cart_item_arr($item_index);

//20080716 show warning if the cart item does not exists
if($cart_item_arr==null){
	echo '<body>'."\n";
	echo 'Shopping Item not find!!'."\n";
	echo '<p>Auto-redirection to WebPAY is aborted.</p>'."\n";
	if(isset($_SERVER['HTTP_REFERER']))
	echo "<a href=\"{$_SERVER['HTTP_REFERER']}\">Click here to go back</a>\n";
	echo "</body>\n";
	echo "</html>\n";
	die;
}

// running time (for calculate prorata use)
$current_time = time();

if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
	$withinDay = false;
	if (isset($_POST["cart_time"]) && $_POST["cart_time"] >0){
		$curr_localtime  = localtime($current_time, true);
		$post_localtime  = localtime($_POST["cart_time"] , true);
		// compare the running time within a day
		if ($curr_localtime['tm_year'] == $post_localtime['tm_year'] && $curr_localtime['tm_yday'] == $post_localtime['tm_yday']){ // compare year and Day of the year 
			$withinDay = true;
		}
	}
	
	if ($withinDay == false) { // not at the same day
		echo '<body>'."\n";
		echo 'Item is updated, please retry again'."\n";
		echo '<p>Auto-redirection to Interswitch WebPAY is aborted.</p>'."\n";
		if(isset($_SERVER['HTTP_REFERER']))
		echo "<a href=\"{$_SERVER['HTTP_REFERER']}\">Click here to go back</a>\n";
		echo "</body>\n";
		echo "</html>\n";
		die;
	}
	
	// 21-01-2010 adjust the shopping cart item's price by prorata
	// calculate method same as fs_cart.php
	$base_time = 0;
	$expire_time = 0;
	
	if ($_POST["username"] != ""){
		$u_expire_month = fs_expire_month_utime($_POST["username"]); // get user expire month (unix timestamp format)
	}
	
	if ( $u_expire_month == false || $u_expire_month == -1 || $current_time > $u_expire_month) // emonth eyear field is null or expired
		$base_time = $current_time;
	else
		$base_time = $u_expire_month;
		
	// adjust item amount
	$cart_item_arr["amount"] = fs_cal_price_with_prorata($base_time, $cart_item_arr["amount"], $cart_item_arr['item_attr']['topup'], 2);
}




$current_time = time();

$id				=$settingobj->getKey( "webpay_id", "webpay");
$txn_key		=$settingobj->getKey( "webpay_mac_key", "webpay");
$pid 			=$settingobj->getKey( "webpay_product_id", "webpay");
$payitemid		=$settingobj->getKey( "webpay_pay_item_id", "webpay");
$currency		=$settingobj->getKey( "webpay_base_currency", "webpay");
$webpay_test	=$settingobj->getKey( "webpay_testing", "webpay");

if($webpay_test == 'true') $url = "https://stageserv.interswitchng.com/test_paydirect/pay"; 
	else $url="https://webpay.interswitchng.com/paydirect/pay";
$notify_url		=fs_local_site_address();
$settingobj=null;
$notify_url		=substr($notify_url,0,strlen($notify_url)-strlen('webpay_submit.php'));


if ($notify_url{strlen($notify_url)-1} != "/" )
  $notify_url.='/webpay_callback.php';
else
  $notify_url.='webpay_callback.php';
  
  

$postfields['product_id']= $pid;//$item_index;
$postfields['amount'] =$cart_item_arr['amount'] * 100; //convert currency unit from Naira to Kobo
$postfields['currency']=$currency;
$postfields['site_redirect_url'] = $notify_url;

//start of recurring
//define your own interval_unit for recurring
if (isset($cart_item_arr['interval_unit'])) {
	$interval_unit = $cart_item_arr['interval_unit'];

	if ($interval_unit == "days")
		$unit = "D";
	else if ($interval_unit == "weeks")
		$unit = "W";
	else if ($interval_unit == "months")
		$unit = "M";
	else if ($interval_unit == "years")
		$unit = "Y";
}

$method = "webpay";

$dbfields['item_name'] = $cart_item_arr["item_name"];
$dbfields['amount'] = $cart_item_arr["amount"] * 100; //convert currency unit from Naira to Kobo
$dbfields['planname'] = $cart_item_arr["plan"];
$dbfields['quantity'] = $cart_item_arr["quantity"];
$dbfields['curr'] = $currency;
$dbfields['method'] = $method;
$dbfields['useMethod'] = $cart_item_arr['useMethod'];
$random = rand(1000,9999);
$curr_localtime  = localtime($current_time, true);
$txn_ref = $curr_localtime['tm_year'].$curr_localtime['tm_yday'].$curr_localtime['tm_hour'].$curr_localtime['tm_min'].$curr_localtime['tm_sec'].$random;
$dbfields['txn_id'] = $txn_ref;
$invoice_no = $myTransaction->insert_transaction($_POST["username"], $dbfields);

$postfields['txn_ref'] = $txn_ref;
$postfields['pay_item_id'] = $payitemid;

//$hash_string = $invoice_no.$item_index.$invoice_no.$cart_item_arr['amount'].$notify_url.$txn_key;
$hash_string = $postfields['txn_ref'].$postfields['product_id'].$postfields['pay_item_id'].$postfields['amount'].$postfields['site_redirect_url'].$txn_key;
$postfields['hash'] = hash('sha512', $hash_string);
$_SESSION['desc'] = $cart_item_arr['item_name'];
$_SESSION['username'] = $_POST['username'];
$_SESSION['plan'] =$cart_item_arr['plan'];
$_SESSION['postTime'] = $current_time;  
$_SESSION['amount'] = $cart_item_arr["amount"] * 100; //convert currency unit from Naira to Kobo
$_SESSION['invoice_no'] = $invoice_no;
$_SESSION['webpay_email'] = $_POST["webpay_email"];
$_SESSION['code'] = $_POST['code'];
if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
	$postfields['local_date_time'] = $current_time;
}

if ($invoice_no > 0) {

?>
<body onload="submitForm()">
<?php
    //submit form to payment gateway
    $myTransaction->submit_form($url, $postfields);
} else {
    echo "<body>\n";
    echo "\n".'<p>Transaction failed... Please contact the help desk!</p>'."\n";
    if(isset($_SERVER['HTTP_REFERER'])) {
	echo "<a href=\"{$_SERVER['HTTP_REFERER']}\">Click here to go back</a>\n";
    }
    echo "</body>\n";
    echo "</html>\n";
    die;
}

?>
</body>
</html>